#ifndef BASICCS_H
#define BASICCS_H

#include <tcl.h>
#include "ptg_gen.h"

/* Solver_Interact sends a single Solver Command to the Solver and wait's
 * Solvers response. The response code is the result of the procedure.
 * The Tcl_Obj-Variant frees the given object. If you need to retain a
 * pointer, increment the reference count *before* the call to Solver_Interact. */

int Solver_Interact(Tcl_Obj *ob);
int Solver_Interact(char *string);

/* Solver_New sends a new-command to the solver. It also manages to collect 
 * changed values and produces a valid new / val command-pair. */

void Solver_New();

/* Processes a whole commandtree described by root. Each command must be terminated
 * by a newline */

PTGNode PTGSolverOut(PTGNode root);


#endif
