#ifndef BASICCHECK_H
#define BASICCHECK_H

#include "ptg_gen.h"

/**PUBLIC*/
void PTGBasicCheckExecute(int round, PTGNode root);

/**
 * Die Funktion speichert den PTG-Text [root], um ihn nach Beedigung des Attributauswerters
 * auszufuehren. Diese Funktion kann waehrend eines Attributauswerterlaufs mehrfach
 * aufgerufen werden. In diesem Fall werden all gespeicherten PTG-Texte ausgefuehrt, die
 * von allen Aufrufen den kleinsten [round]-Wert haben. Durch den [round]-Wert lassen sich
 * also Abhaengigkeiten von Baumaenderungen ausdruecken. Faustregel: Strukturaenderungen
 * sollten in Runde 1 durchgefuehrt werden, Attributaenderungen in Runde 2. Dadurch
 * ist sichergestellt, dass keine Attributaenderungen ausgefuhert wurden, deren Knoten
 * vorher geloescht wurden.
 *
 * Nach Aenderungen des Baumes wird der [check]-Attributauswerter erneut aufgerufen.
 * In dem neuen Baumdurchlauf kann er wiederum Baumaenderungen ausloesen, was dann
 * wiederum einen neuen Check-Durchlauf erfordert, usw. Um Endlosschleifen zu vermeiden
 * wird diese Iteration nach 3 Schritten abgebrochen. (Eine bessere Regel waere: Das
 * Minimum der [round]-Werte muss streng monoton steigend sein)
 *
 * Achtung: Der Mechanismus des Wiederausfuehrens und die Benutzung von "rounds"
 * liefert nur sinnvolle Ergebnisse, wenn der auszufuehrende Codte tatsaechlich
 * eine Baumaenderung ausloest!
 */

#endif
