
namespace eval ::bo {
    variable invisibleColor {}
}
        
::call_init ::bo::basic_objects_init

proc ::bo::basic_objects_init {} {
    variable invisibleColor

    # Set Insertion Point Kinds

    ::visual::create_inspoint_kind "rectangle" "rectangle" \
            [list -width 2 -outline $invisibleColor] 4 {} {::bo::inspoint_onselect_rectangle}
    ::visual::create_inspoint_kind "mrectangle" "rectangle" \
            [list -width 1 -outline $invisibleColor] 4 {} {::bo::inspoint_onselect_mdot}
    ::visual::create_inspoint_kind "line" "line" \
            [list -width 2 -fill $invisibleColor] 4 {} {::bo::inspoint_onselect_line}
    ::visual::create_inspoint_kind "circle" "oval" \
            [list -width 1 -outline $invisibleColor] 4 {} {::bo::inspoint_onselect_dot}
    ::visual::create_inspoint_kind "mcircle" "oval" \
            [list -width 1 -outline $invisibleColor] 4 {} {::bo::inspoint_onselect_mdot}
    ::visual::create_inspoint_kind "dot" "oval" \
            [list -width 2 -outline $invisibleColor] 2 {
        set coords [list \
                [expr [lindex $coords 0] - 3] [expr [lindex $coords 1] - 3] \
                [expr [lindex $coords 0] + 3] [expr [lindex $coords 1] + 3]] 
    } {::bo::inspoint_onselect_dot}
    ::visual::create_inspoint_kind "mdot" "oval" \
            [list -width 2 -outline $invisibleColor] 2 {
        set coords [list \
                [expr [lindex $coords 0] - 3] [expr [lindex $coords 1] - 3] \
                [expr [lindex $coords 0] + 3] [expr [lindex $coords 1] + 3]] 
    } {::bo::inspoint_onselect_mdot}

    ::visual::create_inspoint_kind "yellowbox" "rectangle" \
            [list -outline {} -width 2 -fill yellow] 4 {} {::bo::inspoint_onselect_redline}

}

proc ::bo::inspoint_onselect_redline {varname id select context} {
    upvar #0 $varname data

    if {$select} {
        $data(workspace) itemconfigure $id -outline black
    } else {
        $data(workspace) itemconfigure $id -outline {}
    }
}

proc ::bo::inspoint_onselect_rectangle {varname id select context} {
    upvar #0 $varname data
    variable invisibleColor

    if {$select} {
        $data(workspace) itemconfigure $id -outline black
    } else {
        $data(workspace) itemconfigure $id -outline $invisibleColor
    }
}

proc ::bo::inspoint_onselect_dot {varname id select context} {
    upvar #0 $varname data
    variable invisibleColor

    if {$select} {
        $data(workspace) itemconfigure $id -outline black
    } else {
        $data(workspace) itemconfigure $id -outline $invisibleColor
    }
}
    
proc ::bo::inspoint_onselect_mdot {varname id select context} {
    upvar #0 $varname data
    variable invisibleColor
    variable move_id

        #by cs: die Markierung des Einfuegekontextes wieder entfernen:
        if [info exists ::bo::tempinscontext] {
          $::bo::tempinscontextws delete $::bo::tempinscontext
          unset ::bo::tempinscontext
        }
 

    if {$select} {

        #by cs: zurest den Einfuegekontext markieren, damit man weiss, was passiert:
        set tags [$data(workspace) gettags $id]
        set bbox [lsearch $tags "bbox,*"]
        if { $bbox != -1 } {
          set bbox [split [string range [lindex $tags $bbox] 5 end] ","]
          set ::bo::tempinscontext [eval "$data(workspace) create rectangle $bbox -width 2 -outline blue"]
          set ::bo::tempinscontextws $data(workspace)
        }

        if {[lindex $context 0] == "move"} {
            set move_id [eval {$data(workspace) create rectangle} [lrange $context 1 end] \
                {-outline black -fill {} -width 2}]
            return [lrange $context 1 end]

        } else {
            $data(workspace) itemconfigure $id -outline black
        }
    } else {


        if {[info exists move_id]} {
            $data(workspace) delete $move_id
            unset move_id
        } else {
            $data(workspace) itemconfigure $id -outline $invisibleColor
        }
    }
}

proc ::bo::inspoint_onselect_line {varname id select context} {
    upvar #0 $varname data
    variable invisibleColor

    if {$select} {
        $data(workspace) itemconfigure $id -fill black
    } else {
        $data(workspace) itemconfigure $id -fill $invisibleColor
    }
}


