
#include "VisBasicCode.h"


void VisSolver::solve(PTGNode c)
  {
  PTGSolverOut(c);
  Solver_New();
  }



/* Dies ist obsolet, aber das alte Statechart-Beispiel braucht es noch */

  void VisRoundedRectangle(VLPointArrayPtr p,
       int x1,int y1,int x2,int y2,int d)
    {
    p->setXY(0, x1  ,y1+d);
    p->setXY(1, x1  ,y1  );
    p->setXY(2, x1+d,y1  );
    p->setXY(3, x1+d,y1  );

    p->setXY(4, x2-d,y1  );
    p->setXY(5, x2-d,y1  );
    p->setXY(6, x2  ,y1  );
    p->setXY(7, x2  ,y1+d);
    p->setXY(8, x2  ,y1+d);

    p->setXY(9, x2  ,y2-d);
    p->setXY(10,x2  ,y2-d);
    p->setXY(11,x2  ,y2  );
    p->setXY(12,x2-d,y2  );
    p->setXY(13,x2-d,y2  );

    p->setXY(14,x1+d,y2  );
    p->setXY(15,x1+d,y2  );
    p->setXY(16,x1  ,y2  );
    p->setXY(17,x1  ,y2-d);
    p->setXY(18,x1  ,y2-d);

    p->setXY(19,x1  ,y1+d);
    }




// abscoord <-> linecoord 
// Erste Version: Positionierung eines Punktes

VisFloatVector abscoord2linecoord(VisFloatVector linestart, VisFloatVector lineend, VisFloatVector abspos)
{
   VisFloatVector direction=lineend-linestart;
   VisFloatVector normal=direction.rightnormal();
   VisFloatVector relpos1=abspos-linestart;
   return VisFloatVector( scalprod(relpos1,normal), 
                          scalprod(relpos1,direction)/scalprod(direction,direction));
}


VisFloatVector linecoord2abscoord(VisFloatVector linestart, VisFloatVector lineend, VisFloatVector relpos)
{
   VisFloatVector direction=lineend-linestart;
   VisFloatVector normal=direction.rightnormal();
   return linestart + relpos.x*normal + relpos.y*direction;
}


// abscoord <-> linecoord 
// Zweite Version: Positionierung eines Rechtecks


VisFloatVector getBorderPoint(VisFloatVector size, VisFloatVector direction)
// Liefere Koordinaten eines Randpunktes eines Rechtecks(!) relativ zu dessen Mittelpunkt,
// so dass die "Tangente" an diesem Punkt die Richtung "direction" hat.
// Das besondere: Diese Funktion ist stetig!
// getBorderpoint(direction,...) * direction.rightnormal >= 0 !!!
{
   //Berechne Punkt auf der Ellipse zu Box, an der die Tangente die
   //Richtung direction hat:
   VisFloatVector point;
   double alpha=atan2(-direction.x*size.y, direction.y*size.x);
   point.setXY(cos(alpha)*size.x/2, sin(alpha)*size.y/2);

   // Verschiebe diesen Punkt, so dass die Box (rechteckig!) komplett
   // auf einer Seite liegt:
   VisFloatVector normal=direction.rightnormal();
   double dist=(fabs(normal.x*size.x)+fabs(normal.y*size.y))/2;
   point.move((dist-scalprod(point,normal))*normal);
   return point;
}


VisFloatVector abscoord2linecoord(VisFloatVector linestart, VisFloatVector lineend, 
   VisFloatVector boxsize, VisFloatVector lefttoppos)
{
#ifdef no
   printf("In abscoord2linecoord:\n");
   linestart.print("linestart");
   lineend.print("lineend");
   boxsize.print("boxsize");
   lefttoppos.print("lefttoppos");
#endif

   //Aus linestart, lineend und boxsize abgeleitette Werte:
   VisFloatVector direction=lineend-linestart;
   VisFloatVector normal=direction.rightnormal();
   VisFloatVector borderpoint=getBorderPoint(boxsize,direction);

   VisFloatVector midpos = lefttoppos+boxsize/2;
   double relpos = scalprod(midpos-linestart,normal) / scalprod(borderpoint,normal);

   VisFloatVector anchor,res;
   if(relpos>1)
   {
     anchor=midpos-borderpoint;
     res=abscoord2linecoord(linestart,lineend,anchor);
     res.x+=1; 
     assert(res.x>1);
   }
   else if(relpos<-1)
   {
     anchor=midpos+borderpoint;
     res=abscoord2linecoord(linestart,lineend,anchor);
     res.x-=1; 
     assert(res.x<-1);
   }
   else
   {
     anchor=midpos-relpos*borderpoint;
     res=abscoord2linecoord(linestart,lineend,anchor);
     res.x=relpos; //res.x war vorher 0!
     assert(res.x<=1 && res.x>=-1);
   }
   return 1000*res;
}


VisFloatVector linecoord2abscoord(VisFloatVector linestart, VisFloatVector lineend, 
   VisFloatVector boxsize, VisFloatVector relpos)
// Ergebnis: Linke obere Ecke der Box
{
#ifdef no
   printf("In linecoord2abscoord:\n");
   linestart.print("linestart");
   lineend.print("lineend");
   boxsize.print("boxsize");
   relpos.print("relpos");
#endif

   //Aus linestart, lineend und boxsize abgeleitette Werte:
   VisFloatVector direction=lineend-linestart;
   VisFloatVector normal=direction.rightnormal();
   VisFloatVector borderpoint=getBorderPoint(boxsize,direction);

   relpos=relpos/1000;
   VisFloatVector midpos,anchor;
   if(relpos.x>1)
   {
     relpos.x-=1;
     anchor=linecoord2abscoord(linestart,lineend,relpos);
     midpos=anchor+borderpoint; 
   }
   else if(relpos.x<-1)
   {
     relpos.x+=1;
     anchor=linecoord2abscoord(linestart,lineend,relpos);
     midpos=anchor-borderpoint; 
   }
   else
   { 
     double alpha=relpos.x;
     relpos.x=0;
     anchor=linecoord2abscoord(linestart,lineend,relpos);
     midpos=anchor+alpha*borderpoint;
   }
   return midpos-boxsize/2;
}


// abscoord <-> linecoord 
// Dritte Version: Positionierung eines Rechtecks an einer Polylinie

#ifdef working_here

VisFloatVector abscoord2linecoord(VLPointArray polyline,
   VisFloatVector boxsize, VisFloatVector lefttoppos)
//Liefert die Koordinaten einer Box relativ zu einer Polylinie. Die
//Positionierung entlang der Linie wird dazu prozentual zur Gesamtlaenge
//der Linie gespeichert.
{
    const int n=polyline.getNumbPoints();

    //Das Liniensegment suchen, wo die Beschriftung am naechsten dran ist
    //Gleichzeitig die Segmentlaengen aufsummieren
    int nearestSegment=-1;
    float nearestDistance=FLOAT_MAX;
    float absLength=0;
    for(int i=0; i<n-1; i++)
    {
        VisFloatVector start(polyline,i);
        VisFloatVector ende(polyline,i+1);
        VisFloatVector dist=abscoord2linecoord(start,ende,boxsize,lefttopos);
        float segmentLength=(start-ende).length();

        float distance;
        if(dist.y>1) distance=segmentLength*(dist.y-1)+dist.x;
        else if(dist.y<0) distance=segmentLength*(-dist.y)+dist.x;
        else distance=dist.x;

        absLength+=segmentLength;
}


VisFloatVector linecoord2abscoord(VLPointArrayPtr polyline,
   VisFloatVector boxsize, VisFloatVector relpos)
{}


/// working...

#endif

static int 
Vl_abscoord2linecoord(ClientData clientData, Tcl_Interp* interp, int objc, Tcl_Obj*CONST* objv)
{
  if(objc!=5)
  {
    Tcl_AppendResult(interp,"Usage: abscoord2linecoord linestart lineend boxsize abspos",(char *)NULL);
    return TCL_ERROR;
  }
  VLPointArray linestart(objv[1]);
  VLPointArray lineend(objv[2]);
  VLPointArray boxsize(objv[3]);
  VLPointArray abspos(objv[4]);

  VLPointArray *relpos=abscoord2linecoord(linestart,lineend,boxsize,abspos);
  relpos->setResult();
  return TCL_OK;
}


extern "C" void VisBasicCode_Init(Tcl_Interp* interp)
{
  Tcl_CreateObjCommand(interp, "abscoord2linecoord", Vl_abscoord2linecoord, 0, 0);
}



