

#include "VisComplexElementPtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisComplexElementPtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisComplexElementPtrList (void)
#else
void FinlVisComplexElementPtrList ()
#endif
{
    if (VisComplexElementPtrListSpace != (DynP)0)
    {  obstack_free(&(VisComplexElementPtrListSpace->space), VisComplexElementPtrListSpace->baseptr);
       VisComplexElementPtrListSpace->baseptr = obstack_alloc(&(VisComplexElementPtrListSpace->space), 0);
    }
}/* FinlVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList ConsVisComplexElementPtrList (VisComplexElementPtr e, VisComplexElementPtrList l)
#else
VisComplexElementPtrList ConsVisComplexElementPtrList (e, l)
        VisComplexElementPtr    e;
        VisComplexElementPtrList        l;
#endif
{
    VisComplexElementPtrList    h;

    if (VisComplexElementPtrListSpace == (DynP)0)
    {   VisComplexElementPtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisComplexElementPtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisComplexElementPtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisComplexElementPtrListSpace->space));
        VisComplexElementPtrListSpace->baseptr =
                obstack_alloc(&(VisComplexElementPtrListSpace->space), 0);
    }

    h = (VisComplexElementPtrList)obstack_alloc(&(VisComplexElementPtrListSpace->space),
                                  sizeof (struct _VisComplexElementPtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtr HeadVisComplexElementPtrList (VisComplexElementPtrList l)
#else
VisComplexElementPtr HeadVisComplexElementPtrList (l)
        VisComplexElementPtrList        l;
#endif
{
    if (l == NULLVisComplexElementPtrList)
    {
        message (DEADLY, "HeadVisComplexElementPtrList: empty list", 0, (POSITION*)0);
        /* return ((VisComplexElementPtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList TailVisComplexElementPtrList (VisComplexElementPtrList l)
#else
VisComplexElementPtrList TailVisComplexElementPtrList (l)
        VisComplexElementPtrList        l;
#endif
{
    return ((l==NULLVisComplexElementPtrList) ? NULLVisComplexElementPtrList : l->tail);
}/* TailVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisComplexElementPtrList (VisComplexElementPtrList l)
#else
int LengthVisComplexElementPtrList (l)
        VisComplexElementPtrList        l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtr IthElemVisComplexElementPtrList (VisComplexElementPtrList l, int i)
#else
VisComplexElementPtr IthElemVisComplexElementPtrList (l, i)
        VisComplexElementPtrList        l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisComplexElementPtrList))
        message (DEADLY, "IthElemVisComplexElementPtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisComplexElementPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList CopyVisComplexElementPtrList (VisComplexElementPtrList l, VisComplexElementPtrMapFct cp)
#else
VisComplexElementPtrList CopyVisComplexElementPtrList (l, cp)
        VisComplexElementPtrList l;
        VisComplexElementPtrMapFct      cp;
#endif
{
    VisComplexElementPtrList NewList=NULLVisComplexElementPtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisComplexElementPtrList (cp (l->head), NULLVisComplexElementPtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList AppVisComplexElementPtrList (VisComplexElementPtrList l1, VisComplexElementPtrList l2)
#else
VisComplexElementPtrList AppVisComplexElementPtrList (l1, l2)
        VisComplexElementPtrList        l1, l2;
#endif
{
    VisComplexElementPtrList    NewList;
    VisComplexElementPtrList    *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisComplexElementPtrList (l1->head, NULLVisComplexElementPtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList AppElVisComplexElementPtrList (VisComplexElementPtrList l, VisComplexElementPtr e)
#else
VisComplexElementPtrList AppElVisComplexElementPtrList (l, e)
        VisComplexElementPtrList        l;
        VisComplexElementPtr    e;
#endif
{
    VisComplexElementPtrList    res = l;
    if (!l)
        return (ConsVisComplexElementPtrList (e, NULLVisComplexElementPtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisComplexElementPtrList (e, NULLVisComplexElementPtrList);

    return (res);
} /* AppElVisComplexElementPtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisComplexElementPtrList (VisComplexElementPtrList l, VisComplexElementPtr e)
#else
void InsertAfterVisComplexElementPtrList (l, e)
        VisComplexElementPtrList        l;
        VisComplexElementPtr    e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisComplexElementPtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisComplexElementPtrList (e, l->tail);
}/* InsertAfterVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList OrderedInsertVisComplexElementPtrList (VisComplexElementPtrList l, VisComplexElementPtr e, VisComplexElementPtrCmpFctType fcmp)
#else
VisComplexElementPtrList OrderedInsertVisComplexElementPtrList (l, e, fcmp)
        VisComplexElementPtrList        l;
        VisComplexElementPtr    e;
        VisComplexElementPtrCmpFctType fcmp;
#endif
{
    VisComplexElementPtrList    p;
    if (!l)
        return (ConsVisComplexElementPtrList (e, NULLVisComplexElementPtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisComplexElementPtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisComplexElementPtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrListPtr RefEndConsVisComplexElementPtrList (VisComplexElementPtrListPtr addr, VisComplexElementPtr e)
#else
VisComplexElementPtrListPtr RefEndConsVisComplexElementPtrList (addr, e)
        VisComplexElementPtrListPtr     addr;
        VisComplexElementPtr            e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisComplexElementPtrList: no VisComplexElementPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisComplexElementPtrList (e, NULLVisComplexElementPtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrListPtr RefEndAppVisComplexElementPtrList (VisComplexElementPtrListPtr addr, VisComplexElementPtrList l)
#else
VisComplexElementPtrListPtr RefEndAppVisComplexElementPtrList (addr, l)
        VisComplexElementPtrListPtr     addr;
        VisComplexElementPtrList                l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisComplexElementPtrList: no VisComplexElementPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisComplexElementPtrList (VisComplexElementPtr e, VisComplexElementPtrList l, VisComplexElementPtrCmpFctType fcmp)
#else
int ElemInVisComplexElementPtrList (e, l, fcmp)
        VisComplexElementPtr    e;
        VisComplexElementPtrList        l;
        VisComplexElementPtrCmpFctType  fcmp;
#endif
{
    while (l != NULLVisComplexElementPtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList AddToSetVisComplexElementPtrList (VisComplexElementPtr e, VisComplexElementPtrList l, VisComplexElementPtrCmpFctType fcmp)
#else
VisComplexElementPtrList AddToSetVisComplexElementPtrList (e, l, fcmp)
        VisComplexElementPtr    e;
        VisComplexElementPtrList        l;
        VisComplexElementPtrCmpFctType  fcmp;
#endif
{
    if (ElemInVisComplexElementPtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisComplexElementPtrList (e, l));
}/* AddToSetVisComplexElementPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList AddToOrderedSetVisComplexElementPtrList (VisComplexElementPtr e, VisComplexElementPtrList l, VisComplexElementPtrCmpFctType fcmp)
#else
VisComplexElementPtrList AddToOrderedSetVisComplexElementPtrList (e, l, fcmp)
        VisComplexElementPtr  e;
        VisComplexElementPtrList      l;
        VisComplexElementPtrCmpFctType fcmp;
#endif
{   int test;
    VisComplexElementPtrList  p;
    if (!l)
        return (ConsVisComplexElementPtrList (e, NULLVisComplexElementPtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisComplexElementPtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisComplexElementPtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtrList MapVisComplexElementPtrList (VisComplexElementPtrList l, VisComplexElementPtrMapFct f)
#else
VisComplexElementPtrList MapVisComplexElementPtrList (l, f)
        VisComplexElementPtrList        l;
        VisComplexElementPtrMapFct f;
#endif
{
    VisComplexElementPtrList NewList = NULLVisComplexElementPtrList;
    VisComplexElementPtrList last = NULLVisComplexElementPtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisComplexElementPtrList ((f (l->head)), NULLVisComplexElementPtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisComplexElementPtrList ((f (l->head)), NULLVisComplexElementPtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisComplexElementPtrList (VisComplexElementPtrList l1, VisComplexElementPtrList l2, VisComplexElementPtrCmpFctType fcmp)
#else
int CompVisComplexElementPtrList (l1, l2, fcmp)
        VisComplexElementPtrList        l1, l2;
        VisComplexElementPtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisComplexElementPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisComplexElementPtr SumVisComplexElementPtrList (VisComplexElementPtrList l, VisComplexElementPtrSumFct f, VisComplexElementPtr a)
#else
VisComplexElementPtr SumVisComplexElementPtrList (l, f, a)
        VisComplexElementPtrList        l;
        VisComplexElementPtr ((*f) ());
        VisComplexElementPtr    a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisComplexElementPtrList */
