proc ::create_transition {dragid attrname dropid} {
    if {[::visual::getInsertContext] != "objdrag"} {
        ::log::log "create_transition called in wrong context"
    }

    set args [::visual::getInsertContextArgs]   
        
    set transitionContext [lindex $args 0]
    set transition_root [lindex $transitionContext 0]
    set transition_production [lindex $transitionContext 1]

    set new_transition [::vl::create $::vl::prod($transition_production)]
    ::vl::insert $transition_root 0 $new_transition

    foreach {attr val}  [vl::getAttrs $dragid] {
        if {$attr == $attrname} {
            set drag_property $val
            break
        }
    }
        
    ::vl::setAttrs $new_transition [list "persFrom" $drag_property "persTo" $dropid]
}


proc set_endpoint {dragid attrname dropid} {

    if {[catch {::vl::setAttrs $dragid [list $attrname "" $attrname $dropid]}]} {
        ::log::log $::$errorInfo
    }
    
    if {[::visual::getInsertContext] != "objdrag"} {
        ::log::log "set_endpoint called in wrong context"
    }

    set args [::visual::getInsertContextArgs]
    
    # puts $args

    set xy [lindex $args 3]
    set bbox [lindex $args 2]
    
    set x [lindex $xy 0]
    set y [lindex $xy 1]
    set x1 [lindex $bbox 0]
    set y1 [lindex $bbox 1]
    set x2 [expr [lindex $bbox 2] - 1]
    set y2 [expr [lindex $bbox 3] - 1]

    if {$x < $x1} {set x $x1}
    if {$x > $x2} {set x $x2}
    if {$y < $y1} {set y $y1}
    if {$y > $y2} {set y $y2}

    set relx [expr $x - $x1]
    set sizex [expr $x2 - $x1]
    set facx [expr 32000 / $sizex]
    set valx [expr $relx * $facx]

    set rely [expr $y - $y1]
    set sizey [expr $y2 - $y1]
    set facy [expr 32000 / $sizey]
    set valy [expr $rely * $facy]

    # puts "Val X: $valx"
    # puts "Val Y: $valy"

    set xy [list $valx $valy]
    set attrname_pos [lindex $args 0]

    # puts "Attribut: $attrname_pos"
    # puts "XY $xy"

    if {[catch {::vl::setAttrs $dragid [list $attrname_pos $xy]}]} {
        ::log::log $::$errorInfo
    }
}

