
#include "VisConnectionPatternCode.h"

 
VisRelationLabel::VisRelationLabel(
  NODEPTR oNodePtr, VLListPtr pTextPtr,VLCharPtr pTextAttr,int px,int py,int pox,int poy)
  {
  nodePtr = oNodePtr;
  textPtr = pTextPtr;
  textAttr= pTextAttr;
  x       = px;
  y       = py;
  ox      = pox;
  oy      = poy;
  }


void VisRelationLabel::paint(int nx,int ny)
  {
  if(x==-1 && y==-1) { x =nx; y =ny; }
  else               { x+=ox; y+=oy; }
  if(textPtr)
    {
    int id=VLObjectCreate(nodePtr, "text0", "text", 1, VLPOINT(x,y), textPtr);
    if(textAttr!=NULL) VLSetEditable(id,textAttr);
    }
  }
 
VisEndPointLabelsObject::VisEndPointLabelsObject(
  VisRelationTypeReferencePtrList from,
  VisRelationTypeReferencePtrList to,
  int borderd,int mS,
  int opt)
  {
  fromRels = from;                    // Werte uebernehmen
  toRels   = to;
  borderdXY= borderd;
  maxSize  = mS;
  optimalSize = opt;
  calcLabelSize();                    // Groesse berechnen
  }                                // Ende Konstruktor


void VisEndPointLabelsObject::calcLabelSize(void)
  {
  VisRelationTypeReferencePtrList l;  // Laufzeiger fuer Schleife
  maxX=0; maxY=0;                     // maximale Groessen auf 0
  sumX=0; sumY=0;                     // Summe der Groessen auch 0
  count=0;                            // Zaehler fuer Anzahl

  l=fromRels;                         // Maximale Groesse der FromRelationen
  while(l!=NULLVisRelationTypeReferencePtrList) 
    { 
    VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
    l=TailVisRelationTypeReferencePtrList(l);     
    if(p->getXSize()>maxX) maxX=p->getXSize();
    if(p->getYSize()>maxY) maxY=p->getYSize();
    sumX+=p->getXSize();
    sumY+=p->getYSize();
    count++;
    } 

  l=toRels;                           // Maximale Groesse der ToRelationen
  while(l!=NULLVisRelationTypeReferencePtrList) 
    { 
    VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
    l=TailVisRelationTypeReferencePtrList(l);     
    if(p->getXSize()>maxX) maxX=p->getXSize();
    if(p->getYSize()>maxY) maxY=p->getYSize();
    sumX+=p->getXSize();
    sumY+=p->getYSize();
    count++;
    } 

/*  printf("Anz %d\n",count); */
  if(borderdXY==0)                   // Falls X begrenzt ...
   {
   if(maxSize==-1)                   //  Falls alles in einer Zeile passt ...
    {
    sizeX=sumX;                      //   Zeile hat komplette laenge
    sizeY=maxY;                      //   und die Hoehe des hoechsten Elements
    }                                //  Ende Falls
   else if(maxSize==0)               //  Falls immer nur ein Element pro Zeile...
    {
    sizeX=maxX;                      //   Breite ist die max. Breite
    if(optimalSize) sizeY=sumY;      //   je nachdem ob Groesse optimieren=ja
    else            sizeY=count*maxY;
    }                                //  Ende Falls
   else                              //  SONST (X-Groesse Pixelbegrenzt) ...
    {
    sizeX=maxSize;
    if(optimalSize)                  //   FALLS nicht tabellarisch...
     {
     sizeY=0;
     int akkuRow=0;                  //    laenge der aktuellen Zeile

     l=fromRels;                     //    Daten durchgehen und rechnen
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      if(akkuRow && akkuRow+p->getXSize()>maxSize)
        {
        akkuRow=0; 
        sizeY++;
        }
      else
        akkuRow+=p->getXSize();
      }

     l=toRels;
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      if(akkuRow && akkuRow+p->getXSize()>maxSize)
        {
        akkuRow=0; 
        sizeY++;
        }
      else
        akkuRow+=p->getXSize();
      }
     }                               //   ENDE FALLS nicht tabellarisch
    else                             //   SONST tabellarisch ...
     {
     int columns = maxSize/maxX;     //    mit fester Groesse ist die Anzahl der
     if(columns<1) columns=1;        //    Zeilen einfach zu berechnen
     sizeY = count/columns;
     if(count%columns) sizeY++;
     sizeY*= maxY;
     }
    }                                //  Ende sonst  
   }                                 // Ende Falls (x-Gr. begrenzt)
  else                               // Sonst Y-Groesse begrenzt ...
   {
   if(maxSize==-1)                   //  Falls alles in einer Spalte passt ...
    {
    sizeX=maxX;                      //   Zeile hat nur die laenge des laengsten Elements
    if(optimalSize) sizeY=sumY;      //   Hoehe je nach Optimierung berechnen
    else            sizeY=maxY*count;
    }                                //  Ende Falls
   else if(maxSize==0)               //  Falls immer nur ein Element pro Spalte...
    {
    sizeX=sumX;                      //   Breite ist die Summe aller Elementbreiten
    sizeY=maxY;                      //   Hoehe ist die max. Hoehe
    if(optimalSize) sizeY=sumY;      //   je nachdem ob Groesse optimieren=ja
    else            sizeY=count*maxY;
    }                                //  Ende Falls
   else                              //  SONST (Y-Groesse Pixelbegrenzt) ...
    {
    sizeY=maxSize;                   //   Y-Groesse wird voll ausgenutzt
    int rowCount=sizeY/maxY;         //   Anzahl der Reihen ermitteln
    if(rowCount<1)   rowCount=1;
    if(rowCount>100) rowCount=100;

    if(optimalSize)                  //   FALLS nicht tabellarisch...
     {
     int rowLengths[100];            //    Laenge der einzelnen Zeilen
     int i;                          //    Zaehler fuer Schleife
     int minRow=0;                   //    bisher kuerzeste Zeile

     for(i=0; i<rowCount; i++) rowLengths[i]=0;

     l=fromRels;                     //    Daten durchgehen und rechnen
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      rowLengths[minRow]+=p->getXSize();

      int minRowLength=30000;
      for(i=0; i<rowCount; i++)
       if(rowLengths[i]<minRowLength) 
        {
        minRowLength=rowLengths[i];
        minRow=i;
        }
      }

     l=toRels;
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      rowLengths[minRow]+=p->getXSize();

      int minRowLength=30000;
      for(i=0; i<rowCount; i++)
       if(rowLengths[i]<minRowLength) 
        {
        minRowLength=rowLengths[i];
        minRow=i;
        }
      }

     sizeX=0;                        //    maximale Reihe ermitteln
     for(i=0; i<rowCount; i++)
      if(sizeX<rowLengths[i]) sizeX=rowLengths[i];
     }                               //   Ende optimal
    else                             //   Sonst Tabellarisch...
     {
     sizeX =count/rowCount;          //    Anzahl der Spalten ermitteln
     if(count%rowCount) sizeX++;
     sizeX*=maxX;
     }                               //   Ende Sonst Tabellarisch
    }                                //  Ende sonst
   }                                 // Ende sonst (y-Gr. begrenzt)

  }                               // Ende Methode calcLabelSize


int VisEndPointLabelsObject::getLabelSizeX(void)
  {
  return sizeX;
  }

int VisEndPointLabelsObject::getLabelSizeY(void)
  {
  return sizeY;
  }


void VisEndPointLabelsObject::paint(int nx,int ny)
  {
  VisRelationTypeReferencePtrList l;  // Laufzeiger fuer Schleife

/*  printf("XY%d Max%d Optim%d\n",borderdXY,maxSize,optimalSize); */

  if(borderdXY==0)                   // Falls X begrenzt ...
   {
   if(maxSize==-1)                   //  Falls alles in einer Zeile passt ...
    {
    l=fromRels;                      //    alle Felder malen
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(0,nx,ny);
      nx+=p->getXSize();
      }

    l=toRels;                 
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(1,nx,ny);
      nx+=p->getXSize();
      }
    }                                //  Ende Falls alles in einer Zeile
   else if(maxSize==0)               //  Falls immer nur ein Element pro Zeile...
    {
    l=fromRels;                      //    alle Felder malen
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(0,nx,ny);
      if(optimalSize) ny+=p->getYSize();
      else            ny+=maxY;
      }

    l=toRels;                 
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(1,nx,ny);
      if(optimalSize) ny+=p->getYSize();
      else            ny+=maxY;
      }
    }                                //  Ende Falls
   else                              //  SONST (X-Groesse Pixelbegrenzt) ...
    {
    int posx=0,posy=0;

    l=fromRels;                      //    alle Felder malen
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      if(posx && posx+p->getXSize()>=maxSize)
        {
        posy+=maxY;
        posx =0;
        }

      p->drawAtEndpoint(0,nx+posx,ny+posy);
      if(optimalSize) posx+=p->getXSize();
      else            posx+=maxX;
      }

    l=fromRels;                      //    alle Felder malen
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      if(posx && posx+p->getXSize()>=maxSize)
        {
        posy+=maxY;
        posx =0;
        }

      p->drawAtEndpoint(1,nx+posx,ny+posy);
      if(optimalSize) posx+=p->getXSize();
      else            posx+=maxX;
      }

    }                                //  Ende sonst  
   }                                 // Ende Falls (x-Gr. begrenzt)
  else                               // Sonst Y-Groesse begrenzt ...
   {
   if(maxSize==-1)                   //  Falls alles in einer Spalte passt ...
    {
    l=fromRels;                      //    alle Felder malen
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(0,nx,ny);
      if(optimalSize) ny+=p->getYSize();
      else            ny+=maxY;
      }

    l=toRels;                 
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(1,nx,ny);
      if(optimalSize) ny+=p->getYSize();
      else            ny+=maxY;
      }
    }                                //  Ende Falls
   else if(maxSize==0)               //  Falls immer nur ein Element pro Spalte...
    {
    l=fromRels;                      //    alle Felder malen
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(0,nx,ny);
      nx+=p->getXSize();
      }

    l=toRels;                 
    while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(1,nx,ny);
      nx+=p->getXSize();
      }
    }                                //  Ende Falls
   else                              //  SONST (Y-Groesse Pixelbegrenzt) ...
    {
    sizeY=maxSize;                   //   Y-Groesse wird voll ausgenutzt
    int rowCount=sizeY/maxY;         //   Anzahl der Reihen ermitteln
    if(rowCount<1)   rowCount=1;
    if(rowCount>100) rowCount=100;

    if(optimalSize)                  //   FALLS nicht tabellarisch...
     {
     int rowLengths[100];            //    Laenge der einzelnen Zeilen
     int i;                          //    Zaehler fuer Schleife
     int minRow=0;                   //    bisher kuerzeste Zeile

     for(i=0; i<rowCount; i++) rowLengths[i]=0;

     l=fromRels;                     //    Daten durchgehen und rechnen
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(0,nx+rowLengths[minRow],ny+minRow*maxY);
      rowLengths[minRow]+=p->getXSize();

      int minRowLength=30000;
      for(i=0; i<rowCount; i++)
       if(rowLengths[i]<minRowLength) 
        {
        minRowLength=rowLengths[i];
        minRow=i;
        }
      }

     l=toRels;
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(1,nx+rowLengths[minRow],ny+minRow*maxY);
      rowLengths[minRow]+=p->getXSize();

      int minRowLength=30000;
      for(i=0; i<rowCount; i++)
       if(rowLengths[i]<minRowLength) 
        {
        minRowLength=rowLengths[i];
        minRow=i;
        }
      }

     }                               //   Ende optimal
    else                             //   Sonst Tabellarisch...
     {
     int c=0;
     l=fromRels;
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(0,nx+(c/rowCount)*maxX,ny+(c%rowCount)*maxY);
      c++;
      }

     l=toRels;                 
     while(l!=NULLVisRelationTypeReferencePtrList) 
      { 
      VisRelationTypeReferencePtr p=HeadVisRelationTypeReferencePtrList(l); 
      l=TailVisRelationTypeReferencePtrList(l);     
      p->drawAtEndpoint(1,nx+(c/rowCount)*maxX,ny+(c%rowCount)*maxY);
      c++;
      }

     }                               //   Ende Sonst Tabellarisch
    }                                //  Ende sonst
   }                                 // Ende sonst (y-Gr. begrenzt)

  }

 

VisCrossArea::VisCrossArea(VisContainerInterfacePtr c,int dir,int dis)
  {
  container=c;
  direction=dir;
  distance =dis;
  count=0;
  }


void VisCrossArea::addLine(VisRelationTypeOrthogonalPtr p,int offset,
  int sExitDir, int eExitDir)
  {                                   
  lines[count]=new VisCrossAreaLineDef();

  lines[count]->linePtr=p;               // Linie in Liste eintragen
  lines[count]->pointOffset=offset;      // Zielspeicherposition
  if(sExitDir==direction) lines[count]->exitDirections[0]=1;
  else                    lines[count]->exitDirections[0]=0;
  if(eExitDir==direction) lines[count]->exitDirections[1]=1;
  else                    lines[count]->exitDirections[1]=0;

  lines[count]->ex=0;
  if(direction%2==0) 
    {
    if(p->p.getY(offset-1) > p->p.getY(offset)) lines[count]->ex=1;

    lines[count]->fromTo[0] = p->p.getY(offset-(1+lines[count]->ex)%2);
    lines[count]->fromTo[1] = p->p.getY(offset-(0+lines[count]->ex)%2);
    }
  else          
    {
    if(p->p.getX(offset-1) > p->p.getX(offset)) lines[count]->ex=1;

    lines[count]->fromTo[0] = p->p.getX(offset-(1+lines[count]->ex)%2);
    lines[count]->fromTo[1] = p->p.getX(offset-(0+lines[count]->ex)%2);
    }

  lines[count]->row=count;
  count++;                               // Anzahl erhoehen
  }


void VisCrossArea::calcConnections(void)
  {
  int ia,ib;                                      // Zaehler
  int maxrows=1;
  int rows[100];

  // Phase 1: sortieren ------------------------------------------

  for(ia=0; ia<count; ia++)                       // nach Startpunkt sortieren
   for(ib=0; ib<count-1; ib++)                    // (Bubblesort)
    if(lines[ib]->fromTo[0] > lines[ib+1]->fromTo[0])
     {
     VisCrossAreaLineDefPtr p=lines[ib];
     lines[ib]  =lines[ib+1];
     lines[ib+1]=p;
     }

  // Phase 2: erste Reihenzuordnung ------------------------------

  for(ia=0; ia<100; ia++) rows[ia]=-1;            // alle Reihen leeren

  for(ia=0; ia<count; ia++)                       // FUER alle Linien ...
   {
   #ifdef DEBUG_CALCCONNECTIONS
    printf("Betrachte Linie %d: %d bis %d\n",ia,lines[ia]->fromTo[0],lines[ia]->fromTo[1]);
   #endif
   for(ib=0; ib<100; ib++)
    if(rows[ib]!=-1)                              //  alte erst mal loschen
     {
     if(lines[rows[ib]]->fromTo[1]+5<lines[ia]->fromTo[0])
      rows[ib]=-1;
     }
   
   for(ib=0; rows[ib]!=-1; ib++);                 //  ersten freien Platz besorgen
   #ifdef DEBUG_CALCCONNECTIONS
    printf("Reihe %d ausgewaehlt\n",ib);
   #endif
   if(ib+1>maxrows) maxrows=ib+1;                 //  evt. neues maximum
   lines[ia]->row = ib;                           //  Reihe merken
   rows[ib]=ia;                                   //  und besetzen
   }                                              // ENDE FUER alle Linien

  // Phase 3: Verbesserungen -------------------------------------

  // Phase 4: Punkte Eintragen -----------------------------------

  int pos;
  if(direction==0)                                // Start und incrementwert ermitteln
    { 
    if(distance==-1) distance = container->getXSize()/maxrows; 
    pos = container->getXPosition() + distance/2;
    }
  if(direction==1) 
    { 
    if(distance==-1) distance = container->getYSize()/maxrows; 
    pos = container->getYPosition() + distance/2;
    }
  if(direction==2) 
    { 
    if(distance==-1) distance = -container->getXSize()/maxrows;
    else distance*=-1;
    pos = container->getXPosition() + container->getXSize() - distance/2;
    }
  if(direction==3) 
    { 
    if(distance==-1) distance = -container->getYSize()/maxrows; 
    else distance*=-1;
    pos = container->getYPosition() + container->getYSize() - distance/2;
    }

  if(direction%2==0)                              // FALLS vertikales Feld ...
   {                                              // (X-Positionen nachstragen)
   for(ia=0; ia<count; ia++)                      //  FUER alle Linien...
    {
    lines[ia]->linePtr->p.setXY(                  //   Punkte setzen
      lines[ia]->pointOffset-1, pos+distance*lines[ia]->row, 
      lines[ia]->linePtr->p.getY(lines[ia]->pointOffset-1) );
    lines[ia]->linePtr->p.setXY(
      lines[ia]->pointOffset,  pos+distance*lines[ia]->row, 
      lines[ia]->linePtr->p.getY(lines[ia]->pointOffset) );
    }                                             //  ENDE FUER alle Linien
   }                                              // ENDE FALLS vertikales Feld
  else                                            // SONST (Horizontal) ...
   {                                              // (X-Positionen nachstragen)
   for(ia=0; ia<count; ia++, pos+=distance)       //  FUER alle Linien...
    {
    lines[ia]->linePtr->p.setXY(                  //   Punkte setzen
      lines[ia]->pointOffset-1, lines[ia]->linePtr->p.getX(lines[ia]->pointOffset-1), 
      pos+distance*lines[ia]->row );
    lines[ia]->linePtr->p.setXY(
      lines[ia]->pointOffset, lines[ia]->linePtr->p.getX(lines[ia]->pointOffset),
      pos+distance*lines[ia]->row );
    }                                             //  ENDE FUER alle Linien
   }                                              // ENDE SONST horizontales Feld

  }

 

void VisRelationType::setValues(VLPointArrayPtr coords,
               int fromOffsetX,  int fromOffsetY, 
               int toOffsetX,    int toOffsetY,
               int fromObjShape, int toObjShape,   
               int fromObjKind,  int toObjKind,   
               int fromDirection,int toDirection,
               int fromToTheEnd, int toToTheEnd,  
               int fromTarget,   int toTarget,
               VLPointArrayPtr fromArea,VLPointArrayPtr toArea,
               VisRelationLabelPtrList plabels)
  {
  coordsPtr    = coords;             // alle Daten erst mal Speichern
  offset[0][0] = fromOffsetX;
  offset[0][1] = fromOffsetY;
  offset[1][0] = toOffsetX;
  offset[1][1] = toOffsetY;
  objShape[0]  = fromObjShape;
  objShape[1]  = toObjShape;
  objKind[0]   = fromObjKind;
  objKind[1]   = toObjKind;
  direction[0] = fromDirection;
  direction[1] = toDirection;
  toTheEnd[0]  = fromToTheEnd;
  toTheEnd[1]  = toToTheEnd;
  target[0]       = fromTarget;
  target[1]       = toTarget;
  area[0]      = fromArea;
  area[1]      = toArea;
  labels       = plabels;
  calcRealTarget();                     // Richtiges Ziel berechnen
  }

 

void VisRelationType::calcRealTarget(void)
  {
  // genaues Ziel berechnen, falls nur relative Koordinaten existieren
  float fx,fy;

  for(int i=0; i<2; i++)             // FUER Quelle und Ziel ...
   if(target[i]==2)                     // FALLS Punkt mit relativen Koordinaten...
    {
    switch(objKind[i]){
     case 0:                         // Rechteck
                                     //  0..1 Variable erstellen
      fx =(float)offset[i][0]/32000.0;
      fy =(float)offset[i][1]/32000.0;
      break;

     case 1:                         // Rechteckrand
      {
      int minDist=offset[i][0];      //  Mindestabstand zum Rand hin (erst mal links)
      int direction=2;               //  Richtung des Randes (erst links)
      int realRelPos[2];             //  nun berechnete relative Position
      realRelPos[0]=0;
      realRelPos[1]=offset[i][1];

      if( (32000-offset[i][0])<minDist )
        {                            //  untersuche rechts
        minDist=32000-offset[i][0];
        direction=0;
        realRelPos[0]=32000;
        realRelPos[1]=offset[i][1];
        }
      if( offset[i][1]<minDist )
        {                            //  untersuche oben
        minDist=offset[i][1];
        direction=3;
        realRelPos[0]=offset[i][0];
        realRelPos[1]=0;
        }

      if( (32000-offset[i][1])<minDist )
        {                            //  untersuche unten
        minDist=32000-offset[i][1];
        direction=1;
        realRelPos[0]=offset[i][0];
        realRelPos[1]=32000;
        }
                                     //  0..1 Variable erstellen
      fx =(float)realRelPos[0]/32000.0;
      fy =(float)realRelPos[1]/32000.0;
      }
      break;

     case 2:                         // Kreis
     case 3:                         // Kreisrand
      {
      float dist;                    //  Entfernung zum Mittelpunkt

      dist = (float)(16000-offset[i][0])*(float)(16000-offset[i][0]);
      dist+= (float)(16000-offset[i][1])*(float)(16000-offset[i][1]);
      dist = sqrt(dist);
      if(dist<0.01) { dist=1; offset[i][0]=15999; }

      fx   = offset[i][0]-16000.0;   //  Normieren des Richtungsvektor
      fx  /= dist;
      fy   = offset[i][1]-16000.0;
      fy  /= dist;
                                     //  Entfernung beschraenken
      if(dist>16000 || objKind[i]==3) dist=16000;

      fx  *= dist;                   //  Richtungsvektor passend verlaengern
      fy  *= dist;
      fx  += 16000;                  //  wieder Zentrieren
      fy  += 16000;
      fx  /= 32000.0;                //  0..1 Variable erstellen
      fy  /= 32000.0;
      }
      break;
     };
                                     // jetzt Reale Position ausrechnen
    fx*=(float)(area[i]->getX(1)-area[i]->getX(0));
    fy*=(float)(area[i]->getY(1)-area[i]->getY(0));
    fx+=(float) area[i]->getX(0);
    fy+=(float) area[i]->getY(0);
    coordsPtr->setXY(i,(int)fx,(int)fy);
    }                                // ENDE FUER/FALLS
  }

 

void VisRelationType::setCoordValues(int fromX, int fromY, int toX, int toY)
  {
  points[0]->x = fromX;
  points[1]->x = toX;
  points[0]->y = fromY;
  points[1]->y = toY;
  }

 
 
void VisRelationTypeDirect::setDefaultValues(void) 
  { 
  lineType=""; 
  arrowType=""; 
  } 
 
void VisRelationTypeDirect::draw(VisCrossAreaPtrList cross) 
  { 
  int x[2], y[2];                           // Speicher fuer Zielwerte
  int dx, dy;                               // Delta-Werte
  float a, b;                               // Steigung und Achsenabschnitt
  float s, sx, sy;                          // Schnittpunkte
  char  lineEndType[80];                    // Linien Typ (zusammengesetzt)

  // #define DEBUGDIRECTLINE

  // Berechne die Position der Linienenden, wobei diese von
  // Form und Zielpunkt der Endpunkte abhaengen:

  for(int i=0; i<2; i++)                    // FUER beide Richtungen...      
   {
   x[i] = points[i]->x;                     //   diesen Eintragen
   y[i] = points[i]->y;

   if(toTheEnd[i]!=1)                       //  FALLS nicht bis zum Ende ...
    {                                       

    dx = points[(i+1)%2]->x-points[i]->x;   //   Deltas berechnen
    dy = points[(i+1)%2]->y-points[i]->y;
   
    if(objShape[i]<1)                       //   FALLS Rechteck ...
     {
     if(dx==0)                              //    FALLS Steigung unendlich ...
      {
      x[i]=points[i]->x;                    //     X-Koordinate steht fest
      if(dy>0) y[i]=area[i]->getY(1);       //     Schnitt mit der unteren Linie
      else     y[i]=area[i]->getY(0);       //     oder mit der oberen
      }                                     //    ENDE FALLS Steigung unendlich
     else                                   //    SONST Steigung endlich
      {
      a=(float)dy/(float)dx;                //     Linienwerte bestimmen
      b=(float)points[i]->y-a*(float)points[i]->x;

      if(dy>0)                              //     Schnittpunkt mit unterer Grenze
       {
       s=((float)area[i]->getY(1)-b)/a;
       if((area[i]->getX(0)<=s) && (s<=area[i]->getX(1)))
         { x[i]=(int)s; y[i]=area[i]->getY(1); }
       }

      if(dy<0)                              //     Schnittpunkt mit oberer Grenze
       {
       s=((float)area[i]->getY(0)-b)/a;
       if((area[i]->getX(0)<=s) && (s<=area[i]->getX(1)))
         { x[i]=(int)s; y[i]=area[i]->getY(0); }
       }
  
      if(dx>0)                              //     Schnittpunkt mit rechter Grenze
       {
       s=(float)area[i]->getX(1)*a+b;
       if((area[i]->getY(0)<=s) && (s<=area[i]->getY(1)))
         { x[i]=area[i]->getX(1); y[i]=(int)s; }
       }

      if(dx<0)                              //     Schnittpunkt mit linker Grenze
       {
       s=(float)area[i]->getX(0)*a+b;
       if((area[i]->getY(0)<=s) && (s<=area[i]->getY(1)))
         { x[i]=area[i]->getX(0); y[i]=(int)s; }
       }

      }                                     //    ENDE SONST Steigung endlich
     }                                      //   ENDE FALLS Rechteck
    else                                    //   SONST Kreis/Elipse ...
     {                                      //    Radien,Mittelpunkte
     float rx = (area[i]->getX(1)-area[i]->getX(0))/2.0;
     float ry = (area[i]->getY(1)-area[i]->getY(0))/2.0;
     float mx = (area[i]->getX(1)+area[i]->getX(0))/2.0;
     float my = (area[i]->getY(1)+area[i]->getY(0))/2.0;
     if(rx==0.0) rx=1;
     if(ry==0.0) ry=1;

     if(dx==0)                              //    FALLS senkrechte Linie ...
      {
      s = 1.0 - (area[i]->getX(0)-mx)/rx * (area[i]->getX(0)-mx)/rx;
      if(s>=0)                              //     FALLS ein Ergebnis existiert ...
       {
       if(dy>0) sy= sqrt(s)*rx+mx;          //      Passenden Schnittpunkt berechnen
       else     sy=-sqrt(s)*rx+mx;
       x[i] = area[i]->getX(0);             //      und speichern
       y[i] = (int)sy;
       }                                    //     ENDE FALLS Ergebnis existiert
      }                                     //    ENDE FALLS senkrechte Linie
     else                                   //    SONST schraege Linie ...
      {                                     
      a=(float)dy/(float)dx;                //     Linienwerte bestimmen
      b=(float)(points[i]->y)-a*(float)(points[i]->x);
    
      float bq =+a*mx+b-my;
      s = ry*ry* (ry*ry - bq*bq + rx*rx*a*a);

      if(s>=0.0)                            //     FALLS eine Loesung existiert...
       {
       if(dx>0)   sx = -(bq*a*rx - sqrt(s))*rx/(ry*ry+rx*rx*a*a);//      die passende berechnen
       else       sx = -(bq*a*rx + sqrt(s))*rx/(ry*ry+rx*rx*a*a);
       sx+= mx; 
       sy = a*sx+b;
       x[i]=(int)sx;                        //      Daten eintragen
       y[i]=(int)sy;
       }                                    //     ENDE FALLS Loesung existiert 
      else
       printf("Liegt ausserhalb\n");
      }                                     //    ENDE SONST schraege Linie
     }                                      //   ENDE SONST Kreis/Elipse

    }                                       //  ENDE FALLS nicht bis zum Ende
   }                                        // ENDE FUER Start und Endpunkt

  #ifdef DEBUGDIRECTLINE
    printf("DirectLine APoint 0: %d %d\n",x[0],y[0]);
    printf("DirectLine APoint 1: %d %d\n",x[1],y[1]);
  #endif

  coordsPtr->setXY(0,x[0],y[0]);            // evt. geaenderte Koordinaten weitergeben
  coordsPtr->setXY(1,x[1],y[1]);

  if(arrowType==NULL) sprintf(lineEndType,"%s",lineType?lineType:"");
  else                sprintf(lineEndType,"%s %s",lineType?lineType:"",arrowType?arrowType:"");
  VLObjectCreate(nodePtr,"l01","line", 1,  
      VLREGION(x[0],y[0],x[1],y[1]), lineEndType); 



  // Label(s) malen
  int lx = ( x[0] + x[1] )/2;
  int ly = ( y[0] + y[1] )/2;

  VisRelationLabelPtrList list=labels; 
  // Fuer jedes Listenelement die Malfunktion aufrufen
  while(list!=NULLVisRelationLabelPtrList) 
    { 
    VisRelationLabel *p=HeadVisRelationLabelPtrList(list); 
    list=TailVisRelationLabelPtrList(list);     
    p->paint(lx,ly);
    } 
  } 



 
 

void VisRelationTypeDirect2::calcEndpoint(int i, VisIntVector &target, VisIntVector startPoint)
{
  // Berechne die Position der Linienenden, wobei diese von
  // Form und Zielpunkt der Endpunkte abhaengen:

  int x[2], y[2];                           // Speicher fuer Zielwerte
  int dx, dy;                               // Delta-Werte
  float a, b;                               // Steigung und Achsenabschnitt
  float s, sx, sy;                          // Schnittpunkte

  assert(i==0 || i==1);                     //from-Objekt oder to-Objekt
  x[i] = target.x;
  y[i] = target.y;
  x[(i+1)%2] = startPoint.x;
  y[(i+1)%2] = startPoint.y;

   {

   if(toTheEnd[i]!=1)                       //  FALLS nicht bis zum Ende ...
    {                                       

    dx = startPoint.x - target.x;           //   Deltas berechnen
    dy = startPoint.y - target.y; 
   
    if(objShape[i]<1)                       //   FALLS Rechteck ...
     {
     if(dx==0)                              //    FALLS Steigung unendlich ...
      {
      x[i]=target.x;                    //     X-Koordinate steht fest
      if(dy>0) y[i]=area[i]->getY(1);       //     Schnitt mit der unteren Linie
      else     y[i]=area[i]->getY(0);       //     oder mit der oberen
      }                                     //    ENDE FALLS Steigung unendlich
     else                                   //    SONST Steigung endlich
      {
      a=(float)dy/(float)dx;                //     Linienwerte bestimmen
      b=(float)target.y-a*(float)target.x;

      if(dy>0)                              //     Schnittpunkt mit unterer Grenze
       {
       s=((float)area[i]->getY(1)-b)/a;
       if((area[i]->getX(0)<=s) && (s<=area[i]->getX(1)))
         { x[i]=(int)s; y[i]=area[i]->getY(1); }
       }

      if(dy<0)                              //     Schnittpunkt mit oberer Grenze
       {
       s=((float)area[i]->getY(0)-b)/a;
       if((area[i]->getX(0)<=s) && (s<=area[i]->getX(1)))
         { x[i]=(int)s; y[i]=area[i]->getY(0); }
       }
  
      if(dx>0)                              //     Schnittpunkt mit rechter Grenze
       {
       s=(float)area[i]->getX(1)*a+b;
       if((area[i]->getY(0)<=s) && (s<=area[i]->getY(1)))
         { x[i]=area[i]->getX(1); y[i]=(int)s; }
       }

      if(dx<0)                              //     Schnittpunkt mit linker Grenze
       {
       s=(float)area[i]->getX(0)*a+b;
       if((area[i]->getY(0)<=s) && (s<=area[i]->getY(1)))
         { x[i]=area[i]->getX(0); y[i]=(int)s; }
       }

      }                                     //    ENDE SONST Steigung endlich
     }                                      //   ENDE FALLS Rechteck
    else                                    //   SONST Kreis/Elipse ...
     {                                      //    Radien,Mittelpunkte
     float rx = (area[i]->getX(1)-area[i]->getX(0))/2.0;
     float ry = (area[i]->getY(1)-area[i]->getY(0))/2.0;
     float mx = (area[i]->getX(1)+area[i]->getX(0))/2.0;
     float my = (area[i]->getY(1)+area[i]->getY(0))/2.0;
     if(rx==0.0) rx=1;
     if(ry==0.0) ry=1;

     if(dx==0)                              //    FALLS senkrechte Linie ...
      {
      s = 1.0 - (area[i]->getX(0)-mx)/rx * (area[i]->getX(0)-mx)/rx;
      if(s>=0)                              //     FALLS ein Ergebnis existiert ...
       {
       if(dy>0) sy= sqrt(s)*rx+mx;          //      Passenden Schnittpunkt berechnen
       else     sy=-sqrt(s)*rx+mx;
       x[i] = area[i]->getX(0);             //      und speichern
       y[i] = (int)sy;
       }                                    //     ENDE FALLS Ergebnis existiert
      }                                     //    ENDE FALLS senkrechte Linie
     else                                   //    SONST schraege Linie ...
      {                                     
      a=(float)dy/(float)dx;                //     Linienwerte bestimmen
      b=(float)(target.y)-a*(float)(target.x);
    
      float bq =+a*mx+b-my;
      s = ry*ry* (ry*ry - bq*bq + rx*rx*a*a);

      if(s>=0.0)                            //     FALLS eine Loesung existiert...
       {
       if(dx>0)   sx = -(bq*a*rx - sqrt(s))*rx/(ry*ry+rx*rx*a*a);//      die passende berechnen
       else       sx = -(bq*a*rx + sqrt(s))*rx/(ry*ry+rx*rx*a*a);
       sx+= mx; 
       sy = a*sx+b;
       x[i]=(int)sx;                        //      Daten eintragen
       y[i]=(int)sy;
       }                                    //     ENDE FALLS Loesung existiert 
      else
       printf("Liegt ausserhalb\n");
      }                                     //    ENDE SONST schraege Linie
     }                                      //   ENDE SONST Kreis/Elipse

    }                                       //  ENDE FALLS nicht bis zum Ende
   }                                        // ENDE FUER Start und Endpunkt

  target.x=x[i];
  target.y=y[i];
}


 
void VisRelationTypeDirect2::setDefaultValues(void) 
  { 
  lineType=""; 
  arrowType=""; 
  intermediatePoints=NULL;
  intermediatePointsAttrName=NULL;
  } 
 
void VisRelationTypeDirect2::draw(VisCrossAreaPtrList cross) 
  { 
    const int n=intermediatePoints->getNumbPoints();

    //Verschieben der Zwischenpunkte, falls beide endpunkte um gleichen Vektor verschoben wurden
    if(fromDif->getX() == toDif->getX() && fromDif->getY() == toDif->getY())
    {
       int dx=fromDif->getX();
       int dy=fromDif->getY();
       for(int i=0; i<n; i++)
           intermediatePoints->setXY(i,intermediatePoints->getX(i)+dx, intermediatePoints->getY(i)+dy);
    }

    //Zusammensetzen der Linie
    VLPointArray p;
    p.setXY(0,points[0]->x,points[0]->y);
    for(int i=0; i<n; i++)
      p.setXY(i+1,intermediatePoints->getX(i), intermediatePoints->getY(i));
    p.setXY(n+1,points[1]->x,points[1]->y);

    //Genauen Endpunkte des Linienzugs berechnen
    VisIntVector vec;

    vec.x=p.getX(0);
    vec.y=p.getY(0);
    calcEndpoint(0,vec,VisIntVector(p.getX(1),p.getY(1)));
    p.setXY(0, vec.x,vec.y);

    vec.x=p.getX(n+1);
    vec.y=p.getY(n+1);
    calcEndpoint(1,vec,VisIntVector(p.getX(n),p.getY(n)));
    p.setXY(n+1, vec.x,vec.y);


    coordsPtr->setXY(0,p.getX(0),p.getY(0));      // evt. geaenderte Koordinaten weitergeben
    coordsPtr->setXY(1,p.getX(n+1),p.getY(n+1));


  // Zeichne die Linie
  char  lineEndType[80];

  if(arrowType==NULL) sprintf(lineEndType,"%s",lineType?lineType:"");
  else                sprintf(lineEndType,"%s %s",lineType?lineType:"",arrowType?arrowType:"");


  VLObjectCreate(nodePtr,"l01","line", 1, &p, lineEndType); 


  //intermediateHandle erzeugen
  for(int i=1; i<n+1; i++)
  {
    int lx = p.getX(i);
    int ly = p.getY(i);

    sprintf(lineEndType,"intermediateHandle%i",i);
    VLCreateHandle(VLObjectCreate(nodePtr, lineEndType, "rectangle", 0, 
      VLREGION(lx-3,ly-3,lx+3,ly+3), "-outline {}"), "lineHandle",
        VLAPPEND(VLAPPEND(VLAPPEND(VLAPPEND(VLLIST(),VLNodePtr(nodePtr)),intermediatePointsAttrName),i-1),0));
  }

  //newHandles erzeugen:
  for(int i=0; i<n+1; i++)
  {
    int lx = (p.getX(i) + p.getX(i+1)) /2;
    int ly = (p.getY(i) + p.getY(i+1)) /2;

    sprintf(lineEndType,"newHandle%i",i);
    VLCreateHandle(VLObjectCreate(nodePtr, lineEndType, "oval", 0, 
      VLREGION(lx-2,ly-2,lx+2,ly+2), "-outline {}"), "lineHandle",
        VLAPPEND(VLAPPEND(VLAPPEND(VLAPPEND(VLLIST(),VLNodePtr(nodePtr)),intermediatePointsAttrName),i),1));
  } 
}
 
 
 
void VisRelationTypeOrthogonal::setDefaultValues(void) 
  { 
//  color.color=""; 
  reDistance=20;
  lineType=""; 
  arrowType="";
  ex=0;
  for(int i=0;i<3;i++)
    { areas[i]=NULL; minDist[i]=10000; }
  } 


void VisRelationTypeOrthogonal::setXY(
  int pNr,VLPointArray *p,int exchange,int nrx,int nry,int direction,int dx,int dy)
  {
  int x,y;

  if(direction==0) 
    {
    x = points[(exchange+nrx)%2]->x+dx;
    y = points[(exchange+nry)%2]->y+dy;
    }
  if(direction==1)
    {
    x = points[(exchange+nry)%2]->x-dy;
    y = points[(exchange+nrx)%2]->y+dx;
    }
  if(direction==2)
    {
    x = points[(exchange+nrx)%2]->x-dx;
    y = points[(exchange+nry)%2]->y-dy;
    }
  if(direction==3)
    {
    x = points[(exchange+nry)%2]->x+dy;
    y = points[(exchange+nrx)%2]->y-dx;
    }
  p->setXY(pNr,x,y);
  // printf("%d: %d,%d\n",pNr,x,y);
  } 


int VisRelationTypeOrthogonal::dif(int axis,int direction)
  {
  if(direction==0) 
    if(axis==0)  return (points[0]->x-points[1]->x);
    else         return (points[0]->y-points[1]->y);

  if(direction==1)
    if(axis==0)  return (points[0]->y-points[1]->y);
    else         return (points[1]->x-points[0]->x);

  if(direction==2)
    if(axis==0)  return (points[1]->x-points[0]->x);
    else         return (points[1]->y-points[0]->y);

  if(direction==3)
    if(axis==0)  return (points[1]->y-points[0]->y);
    else         return (points[0]->x-points[1]->x);

  assert(0);
  return 0;
  } 


void VisRelationTypeOrthogonal::draw(VisCrossAreaPtrList cross) 
  { 
  int dx, dy;                               // Delta-Werte

  // #define DEBUG_ORTHOGONALDRAW
  #ifdef DEBUG_ORTHOGONALDRAW
   printf("Linie 1: (%d,%d)->%d bis (%d,%d)->%d\n",
           points[0]->x,points[0]->y,direction[0],
           points[1]->x,points[1]->y,direction[1]);
   printf("Anzahl der Punkte: %d\n",p.getNumbPoints());
  #endif

  // TYP 1 *************************************************************
  // Ohne Ausgangsrichtungen und ohne Cross-Areas
  if(cross==NULLVisCrossAreaPtrList &&
     (direction[0]==-1 || direction[1]==-1) )
   {
   #ifdef DEBUG_ORTHOGONALDRAW
    printf("Fall 1\n");
   #endif

   dx = points[1]->x-points[0]->x;          // Deltas berechnen
   dy = points[1]->y-points[0]->y;
   if(abs(dx)>abs(dy))                      // je nach laenge eine Form
    {                                       // Form auswaehlen
    p.setXY(0, points[0]->x,                points[0]->y);
    p.setXY(1,(points[0]->x+points[1]->x)/2,points[0]->y);
    p.setXY(2,(points[0]->x+points[1]->x)/2,points[1]->y);
    p.setXY(3, points[1]->x,                points[1]->y);
    }
   else
    {
    p.setXY(0,points[0]->x, points[0]->y);
    p.setXY(1,points[0]->x,(points[0]->y+points[1]->y)/2);
    p.setXY(2,points[1]->x,(points[0]->y+points[1]->y)/2);
    p.setXY(3,points[1]->x,              points[1]->y);
    }
   }   // Ende Typ 1

  // TYP 2 *************************************************************
  // Mit Ausgangsrichtungen aber noch ohne Cross-Areas
  if(cross==NULLVisCrossAreaPtrList &&
     (direction[0]!=-1 && direction[1]!=-1) )
   {
   int dir;                                // Richtung der Zeichnung

   #ifdef DEBUG_ORTHOGONALDRAW
    printf("Fall 2\n");
   #endif

   if(direction[0]==direction[1])          // Dieselbe Richtung:
    {
    dir=direction[0];                      //  Drehrichtung bestimmen
    if(dif(0,dir)>0) ex=1;                 //  evt. umdrehen damit Start kleiner X-Wert hat
   
    setXY(0,&p, ex,0,0,dir,0,0);
    setXY(1,&p, ex,1,0,dir,reDistance,0);
    setXY(2,&p, ex,1,1,dir,reDistance,0);
    setXY(3,&p, ex,1,1,dir,0,0);
    }                                      // ENDE Dieselbe Richtung
 
   if(direction[0]==(direction[1]+2)%4)    // Gegenrichtung:
    {
    dir=direction[0];                      //  Drehrichtung bestimmen
    if(dif(0,direction[0])<-2*reDistance)  //  FALL A: genuegender Abstand
     {
     setXY(0,&p, ex,0,0,dir,0,0);
     setXY(1,&p, ex,0,0,dir,-dif(0,direction[0])/2,0);
     setXY(2,&p, ex,0,1,dir,-dif(0,direction[0])/2,0);
     setXY(3,&p, ex,1,1,dir,0,0);
     }
    else                                   //  FALL B: gegeneinander
     {
     setXY(0,&p, ex,0,0,dir,0,0);
     setXY(1,&p, ex,0,0,dir, reDistance,0);
     setXY(2,&p, ex,0,0,dir, reDistance,-dif(0,(direction[0]+1)%4)/2);
     setXY(3,&p, ex,1,0,dir,-reDistance,-dif(0,(direction[0]+1)%4)/2);
     setXY(4,&p, ex,1,1,dir,-reDistance,0);
     setXY(5,&p, ex,1,1,dir,0,0);
     }
    }                                      // ENDE Gegenrichtung

   if(direction[1]==(direction[0]+3)%4)    // Ueber Eck1: (drei unterschied)
    {                                      
    dir=direction[0];                      //  Drehrichtung bestimmen
    if((dif(0,direction[0])<-reDistance) &&//  FALL A: direct ueber Eck
       (dif(1,direction[0])<-reDistance))
     {
     setXY(0,&p, ex,0,0,dir,0,0);
     setXY(1,&p, ex,1,0,dir,0,0);
     setXY(2,&p, ex,1,1,dir,0,0);
     }
    else                                   //  FALL B: rueckwaerts ueber Eck
     {
     setXY(0,&p, ex,0,0,dir,0,0);
     setXY(1,&p, ex,0,0,dir,reDistance,0);
     setXY(2,&p, ex,0,1,dir,reDistance,-reDistance);
     setXY(3,&p, ex,1,1,dir,0,         -reDistance);
     setXY(4,&p, ex,1,1,dir,0,0);
     }
    }                                      // ENDE Ueber Eck 1

   if(direction[1]==(direction[0]+1)%4)    // Ueber Eck 2: (eins unterschied)
    {
    dir=direction[0];                      //  Drehrichtung bestimmen
    if((dif(0,direction[0])<-reDistance) &&
       (dif(1,direction[0])> reDistance))  //  FALL A: direct ueber Eck
     {
     setXY(0,&p, ex,0,0,dir,0,0);
     setXY(1,&p, ex,1,0,dir,0,0);
     setXY(2,&p, ex,1,1,dir,0,0);
     }
    else                                   //  FALL B: rueckwaerts ueber Eck
     {
     setXY(0,&p, ex,0,0,dir,0,0);
     setXY(1,&p, ex,0,0,dir,reDistance,0);
     setXY(2,&p, ex,0,1,dir,reDistance,reDistance);
     setXY(3,&p, ex,1,1,dir,0,         reDistance);
     setXY(4,&p, ex,1,1,dir,0,0);
     }
    }                                      // ENDE Ueber Eck 1

   }                                       // ENDE Typ 2 


  // TYP 3 *************************************************************
  // Mit Cross-Areas
  if(cross!=NULLVisCrossAreaPtrList)
   {
   int adirection=-1;                      // Area-Richtung (0=rechts/links 1=oben/unten)
   VisCrossAreaPtrList l;                  // Listenzeigen zum durchgehen

   #ifdef DEBUG_ORTHOGONALDRAW
    printf("Fall 3\n");
   #endif

   // Phase 1: ermitteln der Grunddaten
   l=cross;                                // Ersten Bereich holen
   VisCrossArea *pc=HeadVisCrossAreaPtrList(l); 
   adirection = pc->direction%2;           // dessen Richtung merken
   
   if(adirection==0)                       // FALLS rechts/links ...
    {                                      //  grobe Pfeilrichtung festlegen
    if(points[0]->x < points[1]->x) ldirection=0;
    else                            ldirection=2;
    }                                      // ENDE FALLS rechts/links
   if(adirection==1)                       // FALLS oben/unten ...
    {                                      //  grobe Pfeilrichtung festlegen
    if(points[0]->y < points[1]->y) ldirection=1;
    else                            ldirection=3;
    }                                      // ENDE FALLS oben/unten

   #ifdef DEBUG_ORTHOGONALDRAW
    printf("Richtung der Crossareas: %d\n",adirection);
    printf("Richtung der Linie: %d\n",ldirection);
   #endif

   // Phase 2: Ermittlung der Cross-Bereiche
   while(l!=NULLVisCrossAreaPtrList)       // SOLANGE Cross Area da ...
    { 
    int dist;                              //  Hilfsvariable
    VisCrossArea *pc=HeadVisCrossAreaPtrList(l); 
    l=TailVisCrossAreaPtrList(l);          //  diesen Bereich holen

    if(ldirection==0)                      //  FALLS nach rechts ...
     {                                     //   Vorbereich, Mitte und Endbereich pruefen
     dist = (points[0]->x) - (pc->container->getXPosition());
     if((dist>=0) && (dist<minDist[0]))
       { minDist[0]=dist; areas[0]=pc; }

     dist = (pc->container->getXPosition()) - (points[0]->x);
     if((dist>=0) && (dist<minDist[1]) &&
        ((pc->container->getXPosition())< (points[1]->x)))
       { minDist[1]=dist; areas[1]=pc; }

     dist = (pc->container->getXPosition()) - (points[1]->x);
     if((dist>=0) && (dist<minDist[2]))
       { minDist[2]=dist; areas[2]=pc; }
     }                                     //   ENDE FALLS rechts

    if(ldirection==2)                      //  FALLS nach links ...
     {                                     //   Vorbereich, Mitte und Endbereich pruefen
     dist = - (points[0]->x) + (pc->container->getXPosition());
     if((dist>=0) && (dist<minDist[0]))
       { minDist[0]=dist; areas[0]=pc; }

     dist = - (pc->container->getXPosition()) + (points[0]->x);
     if((dist>=0) && (dist<minDist[1]) &&
        ((pc->container->getXPosition())> (points[1]->x)))
       { minDist[1]=dist; areas[1]=pc; }

     dist = - (pc->container->getXPosition()) + (points[1]->x);
     if((dist>=0) && (dist<minDist[2]))
       { minDist[2]=dist; areas[2]=pc; }
     }                                     //   ENDE FALLS rechts

    if(ldirection==1)                      //  FALLS nach unten ...
     {                                     //   Vorbereich, Mitte und Endbereich pruefen
     dist = (points[0]->y) - (pc->container->getYPosition());
     if((dist>=0) && (dist<minDist[0]))
       { minDist[0]=dist; areas[0]=pc; }

     dist = (pc->container->getYPosition()) - (points[0]->y);
     if((dist>=0) && (dist<minDist[1]) &&
        ((pc->container->getYPosition())< (points[1]->y)))
       { minDist[1]=dist; areas[1]=pc; }

     dist = (pc->container->getYPosition()) - (points[1]->y);
     if((dist>=0) && (dist<minDist[2]))
       { minDist[2]=dist; areas[2]=pc; }
     }                                     //   ENDE FALLS rechts

    if(ldirection==3)                      //  FALLS nach links ...
     {                                     //   Vorbereich, Mitte und Endbereich pruefen
     dist = - (points[0]->y) + (pc->container->getYPosition());
     if((dist>=0) && (dist<minDist[0]))
      { minDist[0]=dist; areas[0]=pc; }

     dist = - (pc->container->getYPosition()) + (points[0]->y);
     if((dist>=0) && (dist<minDist[1]) &&
        ((pc->container->getYPosition())> (points[1]->y)))
       { minDist[1]=dist; areas[1]=pc; }

     dist = - (pc->container->getYPosition()) + (points[1]->y);
     if((dist>=0) && (dist<minDist[2]))
       { minDist[2]=dist; areas[2]=pc; }
     }                                     //   ENDE FALLS rechts

    }                                      //  ENDE WHILE CrossAreaListe
   
   #ifdef DEBUG_ORTHOGONALDRAW
    for(int i=0; i<3; i++)
     {
     if(areas[i]==NULL) printf("Im Bereich %d: nichts gefunden\n",i);
     else printf("Im Bereich %d: (%d,%d)-(%d,%d)\n",i,
                     areas[i]->container->getXPosition(),
                     areas[i]->container->getYPosition(),
                     areas[i]->container->getXPosition()+areas[i]->container->getXSize(),
                     areas[i]->container->getYPosition()+areas[i]->container->getYSize());
     }
   #endif

   // Phase 3: Ermitteln des/der relevanten Querbereiche
   if(simplify &&  !areas[1] &&            //  FALL A: es wird kein Querbereich genommen
      ldirection== direction[0]  &&  ldirection==(direction[1]+2)%4)
    {                                      //   vereinfachen des Linienverlaufs
    setXY(0,&p,0, 0,0,ldirection,0,0);
    setXY(1,&p,0, 0,0,ldirection,-dif(0,ldirection)/2,0);
    setXY(2,&p,0, 0,1,ldirection,-dif(0,ldirection)/2,0);
    setXY(3,&p,0, 1,1,ldirection,0,0);
    }                                      //  ENDE FALL A
   else if(areas[0] && areas[2] && (       //  FALL B: es werden zwei Querbereiche genommen ...
    ( (ldirection==(direction[0]+2)%4) &&  (ldirection== direction[1])                     ) ||
    ( (ldirection== direction[0])      &&  (ldirection==(direction[1]+2)%4) && (!areas[1]) ) )) 
    {
    if(dif(1,ldirection)<0)                //   FALLS Start hoeher als Ziel ...
     {
     setXY(0,&p,0, 0,0,ldirection,0,0);
     setXY(1,&p,0, 0,0,ldirection,-reDistance,0);
     setXY(2,&p,0, 0,0,ldirection,-reDistance,-2*reDistance);
     setXY(3,&p,0, 1,0,ldirection,+reDistance,-2*reDistance);
     setXY(4,&p,0, 1,1,ldirection,+reDistance,0);
     setXY(5,&p,0, 1,1,ldirection,0,0);
     }
    else                                  //   FALLS Start tiefer als Ziel ...
     {
     setXY(0,&p,0, 0,0,ldirection,0,0);
     setXY(1,&p,0, 0,0,ldirection,-reDistance,0);
     setXY(2,&p,0, 0,1,ldirection,-reDistance,-2*reDistance);
     setXY(3,&p,0, 1,1,ldirection,+reDistance,-2*reDistance);
     setXY(4,&p,0, 1,1,ldirection,+reDistance,0);
     setXY(5,&p,0, 1,1,ldirection,0,0);
     }

    if(ldirection==(direction[0]+2)%4)
      {
      areas[0]->addLine(this,2,1,1);
      areas[2]->addLine(this,4,0,0);
      }
    else
      {
      areas[2]->addLine(this,2,0,0);
      areas[0]->addLine(this,4,1,1);
      }

    }                                      //  ENDE FALL B
   else                                    //  FALL A nur ein Querbereich...
    {                                      //   Querbereich ermitteln
    int crossPos=-1;                       //   Crossy-Position (davor, mitte, hinten)

    int qcount=0;                          //   gesammtanzahl an Querbereichen
    for(int i=0; i<3; i++) if(areas[i]) { qcount++; crossPos=i; }
     
    if(qcount>1)                           //   FALLS mehr als eins existiert
     {                                     //   weiter aussuchen ...
     if((direction[0]==-1 && direction[1]==-1)||
        (direction[0]%2!=ldirection%2 && direction[1]%2!=ldirection%2)   )
      {                                    //    viele, viele Faelle
      if(areas[1]) crossPos=1;
      else         crossPos=0;
      }
     else if(direction[0]==(ldirection+2)%4 && areas[0])
      crossPos=0;
     else if(direction[0]==(ldirection+1)%2 && direction[1]==(ldirection+2)%4 && areas[1])
      crossPos=1;
     else if(direction[1]==ldirection       && areas[2])
      crossPos=2;
     else if(direction[0]==ldirection && direction[1]==(ldirection+2)%4)
      {
      if(areas[1]) crossPos=1;
      else         crossPos=0;
      }
     else if(direction[0]==-1)
      {
      if     (direction[1]==(ldirection+2)%4 && areas[1]) crossPos=1;
      else if(direction[1]==(ldirection+2)%4 && areas[0]) crossPos=0;
      else if(direction[1]== ldirection      && areas[2]) crossPos=2;
      else if(areas[1])                                   crossPos=1;
      else                                                crossPos=0;
      }
     else if(direction[1]==-1)
      {
      if     (direction[0]== ldirection      && areas[1]) crossPos=1;
      else if(direction[0]== ldirection      && areas[2]) crossPos=2;
      else if(direction[0]==(ldirection+2)%4 && areas[0]) crossPos=0;
      else if(areas[1])                                   crossPos=1;
      else                                                crossPos=2;
      }
     else 
      {
      printf("Nicht unterstuetzter Fall:\n");
      printf("Directions %d,%d  Areas %d,%d,%d Linienrichtung %d\n",direction[0],direction[1],
              areas[0]!=NULL,areas[1]!=NULL,areas[2]!=NULL,ldirection);
      }
     }                                     //   ENDE FALLS weitersuchen

    #ifdef DEBUG_ORTHOGONALDRAW
     printf("Genommene Cross-Position %d\n",crossPos);
    #endif

    if(crossPos!=-1)                       //   FALLS ein passendes Crossy
     {                                     //   gefunden ...
     int pcount;                           //    Anzahl der Punkte
     int exitDir[2];
     int p0=0,p1=1;
    // if(ldirection>1) { p0=1; p1=0; }

     // generieren des Linienanfangs ---------------------------------------
     if(((ldirection== direction[p0])     && (crossPos!=0))|| 
        ((ldirection==(direction[p0]+2)%4)&& (crossPos==0))|| (direction[p0]==-1) )
       {                                   //    in passender Richtung
       setXY(0,&p,0, 0,0,ldirection,0,0);
       setXY(1,&p,0, 0,0,ldirection,-5,0);
       }
     else if((ldirection+3)%4==direction[p0])//   nach oben
       {
       setXY(0,&p,0, 0,0,ldirection,0,0);
       setXY(1,&p,0, 0,0,ldirection,0,-reDistance);
       setXY(2,&p,0, 0,0,ldirection,-5,-reDistance);
       }
     else if((ldirection+1)%4==direction[p0])//   nach unten
       {
       setXY(0,&p,0, 0,0,ldirection,0,0);
       setXY(1,&p,0, 0,0,ldirection,0,+reDistance);
       setXY(2,&p,0, 0,0,ldirection,-5,+reDistance);
       }
     else                                  //    in Gegenrichtung
       {
       int pos=+1;
       if(crossPos!=0) pos=-1;
       setXY(0,&p,0, 0,0,ldirection,0,0);
       setXY(1,&p,0, 0,0,ldirection,pos*reDistance,0);
       setXY(2,&p,0, 0,0,ldirection,pos*reDistance,-2*reDistance);
       setXY(3,&p,0, 0,0,ldirection,pos*reDistance-5,-2*reDistance);
       }
     
     pcount=p.getNumbPoints();             //    Punkteanzahl holen
    
     // generieren des Linienendes -----------------------------------------
     if(((ldirection== direction[p1])      && (crossPos==2))|| 
        ((ldirection==(direction[p1]+2)%4) && (crossPos!=2))|| (direction[p1]==-1))
       {                                   //    in passender Richtung
       setXY(pcount+0,&p,0, 1,1,ldirection,+5,0);
       setXY(pcount+1,&p,0, 1,1,ldirection,0,0);
       }
     else if((ldirection+3)%4==direction[p1])//   nach oben
       {
       setXY(pcount+0,&p,0, 1,1,ldirection,-5,-reDistance);
       setXY(pcount+1,&p,0, 1,1,ldirection,0,-reDistance);
       setXY(pcount+2,&p,0, 1,1,ldirection,0,0);
       }
     else if((ldirection+1)%4==direction[p1])//   nach unten
       {
       setXY(pcount+0,&p,0, 1,1,ldirection,-5,+reDistance);
       setXY(pcount+1,&p,0, 1,1,ldirection,0,+reDistance);
       setXY(pcount+2,&p,0, 1,1,ldirection,0,0);
       }
     else                                  //    in Gegenrichtung
       {
       int pos=-1;
       if(crossPos!=2) pos=+1;
       setXY(pcount+0,&p,0, 1,1,ldirection,pos*reDistance-5,-2*reDistance);
       setXY(pcount+1,&p,0, 1,1,ldirection,pos*reDistance,-2*reDistance);
       setXY(pcount+2,&p,0, 1,1,ldirection,pos*reDistance,0);
       setXY(pcount+3,&p,0, 1,1,ldirection,0,0);
       }

     if(crossPos==0)
       {                                   //    Ein und Ausgangsrichtung
       exitDir[0]=1;                       //    bestimmen
       exitDir[1]=1;
       }
     if(crossPos==1)
       { 
       exitDir[0]=0;
       exitDir[1]=1;
       }
     if(crossPos==2)
       { 
       exitDir[0]=0;
       exitDir[1]=0;
       }
     if(areas[crossPos]->direction >=2)    //    FALLS Richtung verkehrt...
       {                                   //      Werte negieren
       exitDir[0]=(exitDir[0]+1)%2;
       exitDir[1]=(exitDir[1]+1)%2;
       }
     areas[crossPos]->addLine(this,pcount,exitDir[0],exitDir[1]);
                                           //    Linie eintragen
     
     }                                     //   ENDE FALLS gefunden
    }                                      //  ENDE FALL B (ein querbereich)
   }                                       // ENDE Typ 3 

  } 


void VisRelationTypeOrthogonal::drawReady(void)
  {
  char lineEndType[80];

  if(arrowType==NULL) sprintf(lineEndType,"%s",lineType?lineType:"");
  else if(ex==0)      sprintf(lineEndType,"%s %s",lineType?lineType:"",arrowType?arrowType:"");
  else                sprintf(lineEndType,"%s -arrow first",lineType?lineType:""); 
  VLObjectCreate(nodePtr,"l01","line", 1, &p, lineEndType);

  // laengste horizontale Linie feststellen
  int nr=0;
  int len=0;
  for(int i=0; i<p.getNumbPoints()-1; i++)
   if(p.getY(i)==p.getY(i+1) && abs(p.getX(i)-p.getX(i+1))>len)
    {
    len = abs(p.getX(i)-p.getX(i+1));
    nr=i;
    }

  int x = ( p.getX(nr) + p.getX(nr+1) )/2;
  int y = ( p.getY(nr) + p.getY(nr+1) )/2;

  VisRelationLabelPtrList list=labels; 
  // Fuer jedes Listenelement die Malfunktion aufrufen
  while(list!=NULLVisRelationLabelPtrList) 
    { 
    VisRelationLabel *p=HeadVisRelationLabelPtrList(list); 
    list=TailVisRelationLabelPtrList(list);     
    p->paint(x,y);
    } 


  #ifdef DEBUG_ORTHOGONALDRAW
   printf("Engueltige Line:\n");
   for(int i=0; i<p.getNumbPoints(); i++)
    printf("%d: %d,%d\n",i,p.getX(i),p.getY(i));
  #endif
  }
 
 
 
void VisRelationTypePolyline::draw(VisCrossAreaPtrList cross) 
  { 
  char lineEndType[80];

  if(arrowType==NULL) sprintf(lineEndType,"%s",lineType?lineType:"");
  else                sprintf(lineEndType,"%s %s",lineType?lineType:"",arrowType?arrowType:"");
  if(spline) strcat(lineEndType," -smooth true");

  VLObjectCreate(nodePtr, "line", "line", 4, coordsPtr, lineEndType);

  int nr= (coordsPtr->getNumbPoints()-1)/2;
  int x = (coordsPtr->getX(nr)+coordsPtr->getX(nr+1))/2;
  int y = (coordsPtr->getY(nr)+coordsPtr->getY(nr+1))/2;

  VisRelationLabelPtrList list=labels; 
  // Fuer jedes Listenelement die Malfunktion aufrufen
  while(list!=NULLVisRelationLabelPtrList) 
    { 
    VisRelationLabel *p=HeadVisRelationLabelPtrList(list); 
    list=TailVisRelationLabelPtrList(list);     
    p->paint(x,y);
    } 

  
  #ifdef DEBUGPOLYLINE
   printf("Engueltige Line:\n");
   for(int i=0; i<coordsPtr->getNumbPoints(); i++)
    printf("%d: %d,%d\n",i,coordsPtr->getX(i),coordsPtr->getY(i));
  #endif
  } 

 
// METHODE getXSize
// Berechnet die vollstaendige X-Ausdehnung dieser Label
int VisRelationTypeReference::getXSize(void)
  {
  return sizePtr->getX(0)+frameSizePtr->getX(0)*2; 
  } 

  
// METHODE getYSize
// Berechnet die vollstaendige Y-Ausdehnung dieser Label
int VisRelationTypeReference::getYSize(void)
  {
  return sizePtr->getY(0)+frameSizePtr->getY(0)*2; 
  } 

 
// METHODE draw
// Malen beider Endlabel dieser Linie 
void VisRelationTypeLabelreference::draw(VisCrossAreaPtrList ca)
  {
  for(int i=0; i<2; i++)
   if(area[i]==NULL)
    drawAtEndpoint(i,points[0]->x+i*(getXSize()+3),points[0]->y);
  }


// METHODE drawAtEndpoint
// Malen eines Labels dieser Linie 
void VisRelationTypeLabelreference::drawAtEndpoint(
  int nr,
  int x,int y)
  {
  char objname[40];
  printf("Paint %d %d\n",x,y);
  coordsPtr->setXY(nr,x,y);
  printf("PaintSet %d\n",nr);
  sprintf(objname,"label%d",nr);
  VLObjectCreate(nodePtr, objname, "text",      1, VLPOINT(x,y), finalAttr);
  sprintf(objname,"label%dB",nr);
  VLObjectCreate(nodePtr, objname, "rectangle", 1, VLREGION(x+1,y+1,x+4,y+4), "-fill green");
  }

 

// METHODE draw
// Malen aller Linien dieses Musters 
void VisSimpleRelations::draw(VisCrossAreaPtrList cross) 
  { 
  VisRelationTypePtrList list=subRelations; 

  // Fuer jedes Listenelement die Malfunktion aufrufen
  while(list!=NULLVisRelationTypePtrList) 
    { 
    VisRelationType *p=HeadVisRelationTypePtrList(list); 
    list=TailVisRelationTypePtrList(list);     
    p->draw(cross);
    } 

  // Querbereiche organisieren
  VisCrossAreaPtrList l=cross;
  while(l!=NULLVisCrossAreaPtrList)
    { 
    VisCrossArea *c=HeadVisCrossAreaPtrList(l);
    l=TailVisCrossAreaPtrList(l);
    c->calcConnections();
    }

  list=subRelations;
  // Fuer jedes Listenelement die entgueltig malen (nur bei orthogonalen)
  while(list!=NULLVisRelationTypePtrList) 
    { 
    VisRelationType *p=HeadVisRelationTypePtrList(list); 
    list=TailVisRelationTypePtrList(list);     
    if(p->relationType==2) p->toOrthogonal()->drawReady();
    }
  } 


