
#include "VisConstraintPatternCode.h"
 

PTGNode VisConnectedSets::calcConstraints(
  VisConstraintVariablePtrList list,
  int equalWidth,
  int equalHeight)
  {
  VisConstraintVariablePtrList list1,list2; 
  PTGNode constraints=PTGNull();

  if(equalWidth==1)                          // Falls gleiche Breite gefordert ...
   {
   list1=list;                               //  Listenelemente durchgehen
   while(list1!=NULLVisConstraintVariablePtrList) 
    {
    VisConstraintVariablePtr p1=HeadVisConstraintVariablePtrList(list1); 
    list1=TailVisConstraintVariablePtrList(list1);
    list2=list1;

    while(list2!=NULLVisConstraintVariablePtrList) 
      {
      VisConstraintVariablePtr p2=HeadVisConstraintVariablePtrList(list2); 
      list2=TailVisConstraintVariablePtrList(list2);
                                             //  je zwei miteinander verbinden
      constraints=PTGConcat(constraints,
                            PTGConstraint_Equal(p1->getID('x'),p2->getID('x')) );
      }
    }
   }                                         // ENDE Falls gleiche Breite

  if(equalHeight==1)                         // Falls gleiche Hoehe gefordert ...
   {
   list1=list;                               //  Listenelemente durchgehen
   while(list1!=NULLVisConstraintVariablePtrList) 
    {
    VisConstraintVariablePtr p1=HeadVisConstraintVariablePtrList(list1); 
    list1=TailVisConstraintVariablePtrList(list1);
    list2=list1;

    while(list2!=NULLVisConstraintVariablePtrList) 
      {
      VisConstraintVariablePtr p2=HeadVisConstraintVariablePtrList(list2); 
      list2=TailVisConstraintVariablePtrList(list2);
                                             //  je zwei miteinander verbinden
      constraints=PTGConcat(constraints,
                            PTGConstraint_Equal(p1->getID('y'),p2->getID('y')) );
      }
    }
   }                                         // ENDE Falls gleiche Hoehe
  return constraints;
  }

 

// METHODE setDefaultValues
// Setzen aller Defaultwerte
void VisSet::setDefaultValues(void)
  {
  size=VisIntVector(150,150);
  alignmentPoint=VisIntVector(0,0);
  frameStyle=NULL;
  frameShape="rectangle";
  borderDimensions=0;
  shape=0;
  constraintKind=1;
  distanceMin=0;
  distanceMax=0; 
  }


// METHODE calcConstraints
// Erstellt das Containerinterface 
PTGNode VisSet::calcConstraints(VisMovablePtrList x)
  {
  VisMovablePtrList list1,list2; 
  subItems=x;

  /* by cs: Urspruenglicher Code:
  if(csize.getValueX()==-1) size.x=startSize.x;
  else                      size.x=csize.getValueX();
  if(csize.getValueY()==-1) size.y=startSize.y;
  else                      size.y=csize.getValueY();

  neuer Code: */
  
  if(csize.getValueX()==-1 && csize.getValueY()==-1) 
    csize.setValue(startSize);
  size.x=csize.getValueX();
  size.y=csize.getValueY();


  if(containerInterfacePtr->interfaceType==2)
    {
    (containerInterfacePtr->toType2())->preferedSize=size;
    (containerInterfacePtr->toType2())->alignmentPoint=alignmentPoint;
    constraints=PTGConstraint_SetVariable(csize.getID('r'),size.x/2);
    constraints=PTGConcat(constraints,csize.setValue());
    }
  else
    {
    constraints=csize.setValue();
    if(shape==1)
      constraints=PTGConcat(constraints,PTGC_SetRadius(csize.getID('r'),csize.getID('x')));
    }


  //*********************************************************************************
  // P H A S E  1         1111111111111111111111111111111111111111111111111111111111
  //*********************************************************************************
  // Fuer jedes Listenelement die derzeitigen Constraintvariablen 
  // erstellen und Werte setzen, Begrenzungen erstellen

  list1=x;
  while(list1!=NULLVisMovablePtrList) 
    { 
    VisMovablePtr p=HeadVisMovablePtrList(list1); 
    list1=TailVisMovablePtrList(list1);

    constraints=PTGConcat(constraints, p->relPos.setValue());

    // Bei Kreisen den Mittelpunkt berechnen
    if(p->shape==1)
     {
     if(p->containerInterfacePtr->interfaceType==2)
      {
      constraints=PTGConcat(constraints,PTGObjectCenter2(
                            p->relPos.getID('u'),p->relPos.getID('x'),
                            p->containerInterfacePtr->getXSize()));
      constraints=PTGConcat(constraints,PTGObjectCenter2(
                            p->relPos.getID('v'),p->relPos.getID('y'),
                            p->containerInterfacePtr->getXSize()));
      }
     else
      {
      constraints=PTGConcat(constraints,
                            PTGObjectCenter1(p->relPos.getID('u'),p->relPos.getID('x'),
                                             p->containerInterfacePtr->toType1()->size.getID('x') ));
      constraints=PTGConcat(constraints,
                            PTGObjectCenter1(p->relPos.getID('v'),p->relPos.getID('y'),
                                             p->containerInterfacePtr->toType1()->size.getID('x') ));
      constraints=PTGConcat(constraints,
                            PTGC_SetRadius(p->containerInterfacePtr->toType1()->size.getID('r'),
                                           p->containerInterfacePtr->toType1()->size.getID('x') ));
      }
     }

    // Erstellen der Constraints, so dass untergeordnete Objekte vollstaendig
    // innerhalb dieses Objekts dargestellt werden muessen
    if(p->containerInterfacePtr->interfaceType==2)
     {
     if(containerInterfacePtr->interfaceType==2)
      {
      //-------------------------------------------------
      // GRUPPE 1: beide mit fester Groesse

      if(shape==0)       // 1A: Umfassendes ist ein Rechteck (Unterobjekt egal)
       constraints=PTGConcat(constraints,PTGConstraint_IncludingRectangles1(
            p->relPos.getID('x'),  p->relPos.getID('y'),
            borderDimensions.left, borderDimensions.top,
            borderDimensions.right + p->containerInterfacePtr->toType2()->preferedSize.x
                                   -    containerInterfacePtr->toType2()->preferedSize.x,
            borderDimensions.bottom+ p->containerInterfacePtr->toType2()->preferedSize.y
                                   -    containerInterfacePtr->toType2()->preferedSize.y));
      }
     else
      {
      //-------------------------------------------------
      // GRUPPE 2: Umrahmendes Objekt mit variabler und eingefuegtes mit fester Groesse

      if(shape==0)       // 2A: Umfassendes ist ein Rechteck (Unterobjekt egal)
       constraints=PTGConcat(constraints,PTGConstraint_IncludingRectangles2(
            p->relPos.getID('x'),  p->relPos.getID('y'),
            containerInterfacePtr->toType1()->size.getID('x'),
            containerInterfacePtr->toType1()->size.getID('y'),
            borderDimensions.left, borderDimensions.top,
            borderDimensions.right + p->containerInterfacePtr->toType2()->preferedSize.x,
            borderDimensions.bottom+ p->containerInterfacePtr->toType2()->preferedSize.y));
      }

     if(shape==1 && p->shape==1)  // 1B und 2B: Kreis im Kreis
       constraints=PTGConcat(constraints,PTGConstraint_IncludingCircles12(
            csize.getID('r'),
            p->containerInterfacePtr->toType2()->preferedSize.x/2 - 
               containerInterfacePtr->toType2()->preferedSize.x/2,
            csize.getCommonID('r',p->relPos.point),
            p->relPos.getID('u'),p->relPos.getID('v') ));

     }
    else
     {
     if(containerInterfacePtr->interfaceType==2)
      {
      //-------------------------------------------------
      // GRUPPE 3: Umrahmendes Objekt mit fester und eingefuegtes mit variabler Groesse

      if(shape==0)       // 3A: Umfassendes ist ein Rechteck (Unterobjekt egal)
       constraints=PTGConcat(constraints,PTGConstraint_IncludingRectangles3(
            p->relPos.getID('x'),  p->relPos.getID('y'),
            p->containerInterfacePtr->toType1()->size.getID('x'),
            p->containerInterfacePtr->toType1()->size.getID('y'),
            borderDimensions.left, borderDimensions.top,
            borderDimensions.right - containerInterfacePtr->toType2()->preferedSize.x,
            borderDimensions.bottom- containerInterfacePtr->toType2()->preferedSize.y));
      }
     else
      {
      //-------------------------------------------------
      // GRUPPE 4: Beide mit variabler Groesse

      if(shape==0)       // 4A: Umfassendes ist ein Rechteck (Unterobjekt egal)
       constraints=PTGConcat(constraints,PTGConstraint_IncludingRectangles4(
            p->relPos.getID('x'),  p->relPos.getID('y'),
               containerInterfacePtr->toType1()->size.getID('x'),
               containerInterfacePtr->toType1()->size.getID('y'),
            p->containerInterfacePtr->toType1()->size.getID('x'),
            p->containerInterfacePtr->toType1()->size.getID('y'),
            borderDimensions.left, borderDimensions.top,

            borderDimensions.right,
            borderDimensions.bottom));

/* by cs: Alt:
            borderDimensions.right - containerInterfacePtr->toType2()->preferedSize.x,
            borderDimensions.bottom- containerInterfacePtr->toType2()->preferedSize.y));
*/

      }

     if(shape==1 && p->shape==1)  // 3B und 4B: Kreis im Kreis
       constraints=PTGConcat(constraints,PTGConstraint_IncludingCircles34(
            csize.getID('r'),
            -containerInterfacePtr->toType2()->preferedSize.x/2,
            p->containerInterfacePtr->toType1()->size.getID('r'),
            csize.getCommonID('r',p->relPos.point),
            p->relPos.getID('u'),p->relPos.getID('v') ));


     }

    } // ENDE While



  //*********************************************************************************
  // P H A S E  2             222222222222222222222222222222222222222222222222222222
  //*********************************************************************************
  // Fuer je zwei Elemente dieser Menge die disjunkivitaet gewaehrleisten.

  if(constraintKind%2==1)
   {
   list1=x;
   while(list1!=NULLVisMovablePtrList) 
    {
    VisMovablePtr p1=HeadVisMovablePtrList(list1); 
    list1=TailVisMovablePtrList(list1);
    list2=list1;

    while(list2!=NULLVisMovablePtrList) 
      {
      VisMovablePtr p2=HeadVisMovablePtrList(list2); 
      list2=TailVisMovablePtrList(list2);

      if(p1->containerInterfacePtr->interfaceType==2)
       {
       if(p2->containerInterfacePtr->interfaceType==2)
        {
        //-------------------------------------------------
        // GRUPPE 1: beide mit fester Groesse

        // 1A: Eins ist kein Kreis (mind. ein Rechteck) -> Beides sind Rechtecke
        if((p1->shape!=1) || (p2->shape!=1))
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctRectangles1(
              p1->relPos.getID('x'),  p1->relPos.getID('y'),
              p1->containerInterfacePtr->toType2()->preferedSize.x+distanceMin,
              p1->containerInterfacePtr->toType2()->preferedSize.y+distanceMin,
              p2->relPos.getID('x'),  p2->relPos.getID('y'),
              p2->containerInterfacePtr->toType2()->preferedSize.x+distanceMin,
              p2->containerInterfacePtr->toType2()->preferedSize.y+distanceMin
              /*p1->relPos.getCommonID('x',p2->relPos.point),
              p1->relPos.getCommonID('y',p2->relPos.point)*/
         ));
        else  // 1B: beides sind Kreise
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctCircles1(
             (p1->containerInterfacePtr->toType2()->preferedSize.x+
              p2->containerInterfacePtr->toType2()->preferedSize.x)/2+distanceMin,
              p1->relPos.getCommonID('r',p2->relPos.point),
              p1->relPos.getID('u'),p1->relPos.getID('v'),
              p2->relPos.getID('u'),p2->relPos.getID('v') ));
        }
       else
        {
        //-------------------------------------------------
        // GRUPPE 2: Das zweite Objekt hat variable Groesse
 
        // 2A: Eins ist kein Kreis (mind. ein Rechteck) -> Beides sind Rechtecke
        if((p1->shape!=1) && (p2->shape!=1))
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctRectangles23(
              p2->relPos.getID('x'),  p2->relPos.getID('y'),
              p2->containerInterfacePtr->toType1()->size.getID('x'),
              p2->containerInterfacePtr->toType1()->size.getID('y'),
              p1->relPos.getID('x'),  p1->relPos.getID('y'),
              p1->containerInterfacePtr->toType2()->preferedSize.x+distanceMin,
              p1->containerInterfacePtr->toType2()->preferedSize.y+distanceMin,
              distanceMin));
        else  // 2B: beides sind Kreise
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctCircles23(
              p2->containerInterfacePtr->toType1()->size.getID('r'),
              p1->containerInterfacePtr->toType2()->preferedSize.x+distanceMin,
              p1->relPos.getCommonID('r',p2->relPos.point),
              p1->relPos.getID('u'),p1->relPos.getID('v'),
              p2->relPos.getID('u'),p2->relPos.getID('v') ));
        }
       }
      else
       {
       if(p2->containerInterfacePtr->interfaceType==2)
        {
        //-------------------------------------------------
        // GRUPPE 3: erstes Objekt mit variabler und zweites mit fester Groesse

        // 3A: Eins ist kein Kreis (mind. ein Rechteck) -> Beides sind Rechtecke
        if((p1->shape!=1) && (p2->shape!=1))
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctRectangles23(
              p1->relPos.getID('x'),  p1->relPos.getID('y'),
              p1->containerInterfacePtr->toType1()->size.getID('x'),
              p1->containerInterfacePtr->toType1()->size.getID('y'),
              p2->relPos.getID('x'),  p2->relPos.getID('y'),
              p2->containerInterfacePtr->toType2()->preferedSize.x+distanceMin,
              p2->containerInterfacePtr->toType2()->preferedSize.y+distanceMin,
              distanceMin));
        else  // 3B: beides sind Kreise
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctCircles23(
              p1->containerInterfacePtr->toType1()->size.getID('r'),
              p2->containerInterfacePtr->toType2()->preferedSize.x+distanceMin,
              p1->relPos.getCommonID('r',p2->relPos.point),
              p1->relPos.getID('u'),p1->relPos.getID('v'),
              p2->relPos.getID('u'),p2->relPos.getID('v') ));
        }
       else
        {
        //-------------------------------------------------
        // GRUPPE 4: Beide mit variabler Groesse

        // 4A: Eins ist kein Kreis (mind. ein Rechteck) -> Beides sind Rechtecke
        if((p1->shape!=1) && (p2->shape!=1))
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctRectangles4(
              p1->relPos.getID('x'),  p1->relPos.getID('y'),
              p1->containerInterfacePtr->toType1()->size.getID('x'),
              p1->containerInterfacePtr->toType1()->size.getID('y'),
              p2->relPos.getID('x'),  p2->relPos.getID('y'),
              p2->containerInterfacePtr->toType1()->size.getID('x'),
              p2->containerInterfacePtr->toType1()->size.getID('y'),
              distanceMin));
        else  // 4B: beides sind Kreise
         constraints=PTGConcat(constraints,PTGConstraint_DisjunctCircles4(
              p1->containerInterfacePtr->toType1()->size.getID('r'),
              p2->containerInterfacePtr->toType1()->size.getID('r'),
              distanceMin,
              p1->relPos.getCommonID('r',p2->relPos.point),
              p2->relPos.getID('u'),p2->relPos.getID('v'),
              p2->relPos.getID('u'),p2->relPos.getID('v') ));
        }  // Ende Else
       }  // Ende Else      
      }  // Ende While-Schleife (innen)
    }  // Ende While-Schleide (aussen)
   }  // Ende Falls 

  return constraints;
  }


// METHODE calcSize
// Berechnet die Groesse und traegt sie in das Containter Interface ein 
VisContainerInterfacePtr VisSet::calcSize(void)
  {
  return containerInterfacePtr;
  }


// METHODE drawFrame
// Malt den Rahmen
void VisSet::drawFrame(VisIntVector p1, VisIntVector p2)
  {
  if(frameStyle)
    {
    /*  **** roundedrectangle wird nun eine Ebene tiefer unterstuetzt! ****
    if(strcmp(frameShape,"roundedrectangle")==0)
     {
     VLPointArray p;
     char *str = new char[strlen(frameStyle) + 20];
     sprintf(str,"-smooth true %s",frameStyle);

     VisRoundedRectangle(&p,p1.x,p1.y,p2.x,p2.y,20);
     VLObjectCreate(nodePtr,"frame01","polygon", 1, &p, str);     
     delete [] str;
     }
    else
     {*/
     VLObjectCreate(nodePtr,"frame01",frameShape, 1, 
                    VLREGION(p1.x,p1.y,p2.x,p2.y),
                    frameStyle);
    }
  }


// METHODE draw
// Malen aller Linien dieses Musters 
void VisSet::draw() 
  { 
  VisMovablePtrList list=subItems; 

  if(csize.getValueX()==-1) size.x=startSize.x;
  else                      size.x=csize.getValueX();
  if(csize.getValueY()==-1) size.y=startSize.y;
  else                      size.y=csize.getValueY();
   
  if(containerInterfacePtr->interfaceType==2)
    {
    (containerInterfacePtr->toType2())->xFit();
    (containerInterfacePtr->toType2())->yFit();
    VisIntVector start=containerInterfacePtr->position;
    VisIntVector end=start+size;
    drawFrame(start,end);
    }

  if(containerInterfacePtr->interfaceType==1)
    {
    VisIntVector start=containerInterfacePtr->position;
    VisIntVector end=start+size;
    drawFrame(start,end);
    }

  // Fuer jedes Listenelement die absolute Position ausrechnen
  while(list!=NULLVisMovablePtrList) 
    { 
    VisMovablePtr p=HeadVisMovablePtrList(list); 
    list=TailVisMovablePtrList(list);
    
    p->containerInterfacePtr->position = 
       containerInterfacePtr->position +
       VisIntVector(p->relPos.getValueX(),
                    p->relPos.getValueY() );
    
    if( p->containerInterfacePtr->interfaceType == 2 )
      {
      (p->containerInterfacePtr->toType2())->align = 
          VisIntVector(VisAlignLeft,VisAlignTop);
      (p->containerInterfacePtr->toType2())->size  = 
          (p->containerInterfacePtr->toType2())->preferedSize;
      }
    } 
  } 


