

#include "VisConstraintVariablePtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisConstraintVariablePtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisConstraintVariablePtrList (void)
#else
void FinlVisConstraintVariablePtrList ()
#endif
{
    if (VisConstraintVariablePtrListSpace != (DynP)0)
    {  obstack_free(&(VisConstraintVariablePtrListSpace->space), VisConstraintVariablePtrListSpace->baseptr);
       VisConstraintVariablePtrListSpace->baseptr = obstack_alloc(&(VisConstraintVariablePtrListSpace->space), 0);
    }
}/* FinlVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList ConsVisConstraintVariablePtrList (VisConstraintVariablePtr e, VisConstraintVariablePtrList l)
#else
VisConstraintVariablePtrList ConsVisConstraintVariablePtrList (e, l)
        VisConstraintVariablePtr        e;
        VisConstraintVariablePtrList    l;
#endif
{
    VisConstraintVariablePtrList        h;

    if (VisConstraintVariablePtrListSpace == (DynP)0)
    {   VisConstraintVariablePtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisConstraintVariablePtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisConstraintVariablePtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisConstraintVariablePtrListSpace->space));
        VisConstraintVariablePtrListSpace->baseptr =
                obstack_alloc(&(VisConstraintVariablePtrListSpace->space), 0);
    }

    h = (VisConstraintVariablePtrList)obstack_alloc(&(VisConstraintVariablePtrListSpace->space),
                                  sizeof (struct _VisConstraintVariablePtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtr HeadVisConstraintVariablePtrList (VisConstraintVariablePtrList l)
#else
VisConstraintVariablePtr HeadVisConstraintVariablePtrList (l)
        VisConstraintVariablePtrList    l;
#endif
{
    if (l == NULLVisConstraintVariablePtrList)
    {
        message (DEADLY, "HeadVisConstraintVariablePtrList: empty list", 0, (POSITION*)0);
        /* return ((VisConstraintVariablePtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList TailVisConstraintVariablePtrList (VisConstraintVariablePtrList l)
#else
VisConstraintVariablePtrList TailVisConstraintVariablePtrList (l)
        VisConstraintVariablePtrList    l;
#endif
{
    return ((l==NULLVisConstraintVariablePtrList) ? NULLVisConstraintVariablePtrList : l->tail);
}/* TailVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisConstraintVariablePtrList (VisConstraintVariablePtrList l)
#else
int LengthVisConstraintVariablePtrList (l)
        VisConstraintVariablePtrList    l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtr IthElemVisConstraintVariablePtrList (VisConstraintVariablePtrList l, int i)
#else
VisConstraintVariablePtr IthElemVisConstraintVariablePtrList (l, i)
        VisConstraintVariablePtrList    l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisConstraintVariablePtrList))
        message (DEADLY, "IthElemVisConstraintVariablePtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisConstraintVariablePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList CopyVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtrMapFct cp)
#else
VisConstraintVariablePtrList CopyVisConstraintVariablePtrList (l, cp)
        VisConstraintVariablePtrList l;
        VisConstraintVariablePtrMapFct  cp;
#endif
{
    VisConstraintVariablePtrList NewList=NULLVisConstraintVariablePtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisConstraintVariablePtrList (cp (l->head), NULLVisConstraintVariablePtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList AppVisConstraintVariablePtrList (VisConstraintVariablePtrList l1, VisConstraintVariablePtrList l2)
#else
VisConstraintVariablePtrList AppVisConstraintVariablePtrList (l1, l2)
        VisConstraintVariablePtrList    l1, l2;
#endif
{
    VisConstraintVariablePtrList        NewList;
    VisConstraintVariablePtrList        *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisConstraintVariablePtrList (l1->head, NULLVisConstraintVariablePtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList AppElVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtr e)
#else
VisConstraintVariablePtrList AppElVisConstraintVariablePtrList (l, e)
        VisConstraintVariablePtrList    l;
        VisConstraintVariablePtr        e;
#endif
{
    VisConstraintVariablePtrList        res = l;
    if (!l)
        return (ConsVisConstraintVariablePtrList (e, NULLVisConstraintVariablePtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisConstraintVariablePtrList (e, NULLVisConstraintVariablePtrList);

    return (res);
} /* AppElVisConstraintVariablePtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtr e)
#else
void InsertAfterVisConstraintVariablePtrList (l, e)
        VisConstraintVariablePtrList    l;
        VisConstraintVariablePtr        e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisConstraintVariablePtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisConstraintVariablePtrList (e, l->tail);
}/* InsertAfterVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList OrderedInsertVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtr e, VisConstraintVariablePtrCmpFctType fcmp)
#else
VisConstraintVariablePtrList OrderedInsertVisConstraintVariablePtrList (l, e, fcmp)
        VisConstraintVariablePtrList    l;
        VisConstraintVariablePtr        e;
        VisConstraintVariablePtrCmpFctType fcmp;
#endif
{
    VisConstraintVariablePtrList        p;
    if (!l)
        return (ConsVisConstraintVariablePtrList (e, NULLVisConstraintVariablePtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisConstraintVariablePtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisConstraintVariablePtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrListPtr RefEndConsVisConstraintVariablePtrList (VisConstraintVariablePtrListPtr addr, VisConstraintVariablePtr e)
#else
VisConstraintVariablePtrListPtr RefEndConsVisConstraintVariablePtrList (addr, e)
        VisConstraintVariablePtrListPtr addr;
        VisConstraintVariablePtr                e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisConstraintVariablePtrList: no VisConstraintVariablePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisConstraintVariablePtrList (e, NULLVisConstraintVariablePtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrListPtr RefEndAppVisConstraintVariablePtrList (VisConstraintVariablePtrListPtr addr, VisConstraintVariablePtrList l)
#else
VisConstraintVariablePtrListPtr RefEndAppVisConstraintVariablePtrList (addr, l)
        VisConstraintVariablePtrListPtr addr;
        VisConstraintVariablePtrList            l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisConstraintVariablePtrList: no VisConstraintVariablePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisConstraintVariablePtrList (VisConstraintVariablePtr e, VisConstraintVariablePtrList l, VisConstraintVariablePtrCmpFctType fcmp)
#else
int ElemInVisConstraintVariablePtrList (e, l, fcmp)
        VisConstraintVariablePtr        e;
        VisConstraintVariablePtrList    l;
        VisConstraintVariablePtrCmpFctType      fcmp;
#endif
{
    while (l != NULLVisConstraintVariablePtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList AddToSetVisConstraintVariablePtrList (VisConstraintVariablePtr e, VisConstraintVariablePtrList l, VisConstraintVariablePtrCmpFctType fcmp)
#else
VisConstraintVariablePtrList AddToSetVisConstraintVariablePtrList (e, l, fcmp)
        VisConstraintVariablePtr        e;
        VisConstraintVariablePtrList    l;
        VisConstraintVariablePtrCmpFctType      fcmp;
#endif
{
    if (ElemInVisConstraintVariablePtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisConstraintVariablePtrList (e, l));
}/* AddToSetVisConstraintVariablePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList AddToOrderedSetVisConstraintVariablePtrList (VisConstraintVariablePtr e, VisConstraintVariablePtrList l, VisConstraintVariablePtrCmpFctType fcmp)
#else
VisConstraintVariablePtrList AddToOrderedSetVisConstraintVariablePtrList (e, l, fcmp)
        VisConstraintVariablePtr  e;
        VisConstraintVariablePtrList      l;
        VisConstraintVariablePtrCmpFctType fcmp;
#endif
{   int test;
    VisConstraintVariablePtrList  p;
    if (!l)
        return (ConsVisConstraintVariablePtrList (e, NULLVisConstraintVariablePtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisConstraintVariablePtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisConstraintVariablePtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtrList MapVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtrMapFct f)
#else
VisConstraintVariablePtrList MapVisConstraintVariablePtrList (l, f)
        VisConstraintVariablePtrList    l;
        VisConstraintVariablePtrMapFct f;
#endif
{
    VisConstraintVariablePtrList NewList = NULLVisConstraintVariablePtrList;
    VisConstraintVariablePtrList last = NULLVisConstraintVariablePtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisConstraintVariablePtrList ((f (l->head)), NULLVisConstraintVariablePtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisConstraintVariablePtrList ((f (l->head)), NULLVisConstraintVariablePtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisConstraintVariablePtrList (VisConstraintVariablePtrList l1, VisConstraintVariablePtrList l2, VisConstraintVariablePtrCmpFctType fcmp)
#else
int CompVisConstraintVariablePtrList (l1, l2, fcmp)
        VisConstraintVariablePtrList    l1, l2;
        VisConstraintVariablePtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisConstraintVariablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisConstraintVariablePtr SumVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtrSumFct f, VisConstraintVariablePtr a)
#else
VisConstraintVariablePtr SumVisConstraintVariablePtrList (l, f, a)
        VisConstraintVariablePtrList    l;
        VisConstraintVariablePtr ((*f) ());
        VisConstraintVariablePtr        a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisConstraintVariablePtrList */
