
#ifndef _VisConstraintVariablePtrLIST_H
#define _VisConstraintVariablePtrLIST_H

/* include header file defining VisConstraintVariablePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

#include "VisConstraintVariablePtrFunctionTypes.h"

typedef struct _VisConstraintVariablePtrLE *VisConstraintVariablePtrList;
typedef VisConstraintVariablePtrList    *VisConstraintVariablePtrListPtr;

struct _VisConstraintVariablePtrLE {
VisConstraintVariablePtr                head;
VisConstraintVariablePtrList    tail;
};

#define NULLVisConstraintVariablePtrList                ((VisConstraintVariablePtrList)0)
#define NullVisConstraintVariablePtrList()      ((VisConstraintVariablePtrList)0)
#define SingleVisConstraintVariablePtrList(e)   (ConsVisConstraintVariablePtrList((e),NULLVisConstraintVariablePtrList))

#if defined(__STDC__) || defined(__cplusplus)

extern void FinlVisConstraintVariablePtrList(void);
   /* Deallocates all VisConstraintVariablePtrLists. */
   /* Dynamic storage is allocated on first need */

extern VisConstraintVariablePtrList ConsVisConstraintVariablePtrList (VisConstraintVariablePtr e, VisConstraintVariablePtrList l);
   /* Constructs a VisConstraintVariablePtrList of an element e and a given tail l.
    * e is the first element of the list. */

extern VisConstraintVariablePtr HeadVisConstraintVariablePtrList (VisConstraintVariablePtrList l);
   /* Returns the first element of the list l.
    * The list l must not be empty. */

extern VisConstraintVariablePtrList TailVisConstraintVariablePtrList (VisConstraintVariablePtrList l);
   /* Returns the tail of the list l.
    * If l is empty, an empty list is returned. */

extern int LengthVisConstraintVariablePtrList (VisConstraintVariablePtrList l);
   /* Returns the number of elements in the list l. */

extern VisConstraintVariablePtr IthElemVisConstraintVariablePtrList (VisConstraintVariablePtrList l, int i);
   /* Returns the i-th element of the List l. The head of l
    * is referred to as 1. If the value of
    * i is greater than the length of the list, an error
    * is reported and the program exits.
    */

extern VisConstraintVariablePtrList CopyVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtrMapFct cp);
   /* Copies the list l. Elements are copied by calls of cp. */

extern VisConstraintVariablePtrList AppVisConstraintVariablePtrList (VisConstraintVariablePtrList l1, VisConstraintVariablePtrList l2);
   /* Concatenates two lists l1 and l2. The resulting list contains l2 at
    * the end of a copy of list l1. */

extern VisConstraintVariablePtrList AppElVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtr e);
   /* Appends an element e to the list l.
    * The list l is not copied, it is modified as a side-effect
    * of this function. */

extern void InsertAfterVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtr e);
   /* This function requires a non-empty list l. The element e is inserted
    * just after the first element of l. 
    * The list l is modified as a side-effect of this function. */

extern VisConstraintVariablePtrList OrderedInsertVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtr e, VisConstraintVariablePtrCmpFctType fcmp);
   /* Inserts the element e into the list l maintaining l in
    * ascending order with respect to the compare fcmp. 
    * The list l is modified as a side-effect of this function. */

extern VisConstraintVariablePtrListPtr RefEndConsVisConstraintVariablePtrList (VisConstraintVariablePtrListPtr addr, VisConstraintVariablePtr e);
   /* Appends an element e to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern VisConstraintVariablePtrListPtr RefEndAppVisConstraintVariablePtrList (VisConstraintVariablePtrListPtr addr, VisConstraintVariablePtrList l);
   /* Appends a list l to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern int ElemInVisConstraintVariablePtrList (VisConstraintVariablePtr e, VisConstraintVariablePtrList l, VisConstraintVariablePtrCmpFctType cmpfct);
   /* This function returns true (1) iff the element e is in the List l.
    * List elements are compared by the function cmpfct. */

extern VisConstraintVariablePtrList AddToSetVisConstraintVariablePtrList (VisConstraintVariablePtr e, VisConstraintVariablePtrList l, VisConstraintVariablePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. */

extern VisConstraintVariablePtrList AddToOrderedSetVisConstraintVariablePtrList 
       (VisConstraintVariablePtr e, VisConstraintVariablePtrList l, VisConstraintVariablePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. l is assumed to be ordered increasingly in the sense of
    * cmpfct. */

extern VisConstraintVariablePtrList MapVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtrMapFct f);
   /* Returns a new VisConstraintVariablePtrList obtained by applying f to each element of l. */

extern int CompVisConstraintVariablePtrList (VisConstraintVariablePtrList l1, VisConstraintVariablePtrList l2, VisConstraintVariablePtrCmpFctType f);
   /* Compares the lists l1 and l2 lexicographically by applying f
    * to the corresponding elements. */

extern VisConstraintVariablePtr SumVisConstraintVariablePtrList (VisConstraintVariablePtrList l, VisConstraintVariablePtrSumFct f, VisConstraintVariablePtr a);
   /* Applies the binary function f to the elements of the List:
    *   f( f(... f(a, e1), e2, ...), en)
    * If l is empty a is returned. */

#else

extern void FinlVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList ConsVisConstraintVariablePtrList ();
extern VisConstraintVariablePtr HeadVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList TailVisConstraintVariablePtrList ();
extern int LengthVisConstraintVariablePtrList ();
extern VisConstraintVariablePtr IthElemVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList CopyVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList AppVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList AppElVisConstraintVariablePtrList ();
extern void InsertAfterVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList OrderedInsertVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrListPtr RefEndConsVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrListPtr RefEndAppVisConstraintVariablePtrList ();
extern int ElemInVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList AddToSetVisConstraintVariablePtrList ();
extern VisConstraintVariablePtrList MapVisConstraintVariablePtrList ();
extern int CompVisConstraintVariablePtrList ();
extern VisConstraintVariablePtr SumVisConstraintVariablePtrList ();

#endif

#ifdef MONITOR
#define DAPTO_RESULTVisConstraintVariablePtrList(l) DAPTO_RESULT_PTR(l)
#define DAPTO_ARGVisConstraintVariablePtrList(l)    DAPTO_ARG_PTR (l, VisConstraintVariablePtrList)
#endif

#endif
