

#include "VisContainerInterfacePtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisContainerInterfacePtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisContainerInterfacePtrList (void)
#else
void FinlVisContainerInterfacePtrList ()
#endif
{
    if (VisContainerInterfacePtrListSpace != (DynP)0)
    {  obstack_free(&(VisContainerInterfacePtrListSpace->space), VisContainerInterfacePtrListSpace->baseptr);
       VisContainerInterfacePtrListSpace->baseptr = obstack_alloc(&(VisContainerInterfacePtrListSpace->space), 0);
    }
}/* FinlVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList ConsVisContainerInterfacePtrList (VisContainerInterfacePtr e, VisContainerInterfacePtrList l)
#else
VisContainerInterfacePtrList ConsVisContainerInterfacePtrList (e, l)
        VisContainerInterfacePtr        e;
        VisContainerInterfacePtrList    l;
#endif
{
    VisContainerInterfacePtrList        h;

    if (VisContainerInterfacePtrListSpace == (DynP)0)
    {   VisContainerInterfacePtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisContainerInterfacePtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisContainerInterfacePtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisContainerInterfacePtrListSpace->space));
        VisContainerInterfacePtrListSpace->baseptr =
                obstack_alloc(&(VisContainerInterfacePtrListSpace->space), 0);
    }

    h = (VisContainerInterfacePtrList)obstack_alloc(&(VisContainerInterfacePtrListSpace->space),
                                  sizeof (struct _VisContainerInterfacePtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtr HeadVisContainerInterfacePtrList (VisContainerInterfacePtrList l)
#else
VisContainerInterfacePtr HeadVisContainerInterfacePtrList (l)
        VisContainerInterfacePtrList    l;
#endif
{
    if (l == NULLVisContainerInterfacePtrList)
    {
        message (DEADLY, "HeadVisContainerInterfacePtrList: empty list", 0, (POSITION*)0);
        /* return ((VisContainerInterfacePtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList TailVisContainerInterfacePtrList (VisContainerInterfacePtrList l)
#else
VisContainerInterfacePtrList TailVisContainerInterfacePtrList (l)
        VisContainerInterfacePtrList    l;
#endif
{
    return ((l==NULLVisContainerInterfacePtrList) ? NULLVisContainerInterfacePtrList : l->tail);
}/* TailVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisContainerInterfacePtrList (VisContainerInterfacePtrList l)
#else
int LengthVisContainerInterfacePtrList (l)
        VisContainerInterfacePtrList    l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtr IthElemVisContainerInterfacePtrList (VisContainerInterfacePtrList l, int i)
#else
VisContainerInterfacePtr IthElemVisContainerInterfacePtrList (l, i)
        VisContainerInterfacePtrList    l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisContainerInterfacePtrList))
        message (DEADLY, "IthElemVisContainerInterfacePtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisContainerInterfacePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList CopyVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtrMapFct cp)
#else
VisContainerInterfacePtrList CopyVisContainerInterfacePtrList (l, cp)
        VisContainerInterfacePtrList l;
        VisContainerInterfacePtrMapFct  cp;
#endif
{
    VisContainerInterfacePtrList NewList=NULLVisContainerInterfacePtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisContainerInterfacePtrList (cp (l->head), NULLVisContainerInterfacePtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList AppVisContainerInterfacePtrList (VisContainerInterfacePtrList l1, VisContainerInterfacePtrList l2)
#else
VisContainerInterfacePtrList AppVisContainerInterfacePtrList (l1, l2)
        VisContainerInterfacePtrList    l1, l2;
#endif
{
    VisContainerInterfacePtrList        NewList;
    VisContainerInterfacePtrList        *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisContainerInterfacePtrList (l1->head, NULLVisContainerInterfacePtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList AppElVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtr e)
#else
VisContainerInterfacePtrList AppElVisContainerInterfacePtrList (l, e)
        VisContainerInterfacePtrList    l;
        VisContainerInterfacePtr        e;
#endif
{
    VisContainerInterfacePtrList        res = l;
    if (!l)
        return (ConsVisContainerInterfacePtrList (e, NULLVisContainerInterfacePtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisContainerInterfacePtrList (e, NULLVisContainerInterfacePtrList);

    return (res);
} /* AppElVisContainerInterfacePtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtr e)
#else
void InsertAfterVisContainerInterfacePtrList (l, e)
        VisContainerInterfacePtrList    l;
        VisContainerInterfacePtr        e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisContainerInterfacePtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisContainerInterfacePtrList (e, l->tail);
}/* InsertAfterVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList OrderedInsertVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtr e, VisContainerInterfacePtrCmpFctType fcmp)
#else
VisContainerInterfacePtrList OrderedInsertVisContainerInterfacePtrList (l, e, fcmp)
        VisContainerInterfacePtrList    l;
        VisContainerInterfacePtr        e;
        VisContainerInterfacePtrCmpFctType fcmp;
#endif
{
    VisContainerInterfacePtrList        p;
    if (!l)
        return (ConsVisContainerInterfacePtrList (e, NULLVisContainerInterfacePtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisContainerInterfacePtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisContainerInterfacePtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrListPtr RefEndConsVisContainerInterfacePtrList (VisContainerInterfacePtrListPtr addr, VisContainerInterfacePtr e)
#else
VisContainerInterfacePtrListPtr RefEndConsVisContainerInterfacePtrList (addr, e)
        VisContainerInterfacePtrListPtr addr;
        VisContainerInterfacePtr                e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisContainerInterfacePtrList: no VisContainerInterfacePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisContainerInterfacePtrList (e, NULLVisContainerInterfacePtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrListPtr RefEndAppVisContainerInterfacePtrList (VisContainerInterfacePtrListPtr addr, VisContainerInterfacePtrList l)
#else
VisContainerInterfacePtrListPtr RefEndAppVisContainerInterfacePtrList (addr, l)
        VisContainerInterfacePtrListPtr addr;
        VisContainerInterfacePtrList            l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisContainerInterfacePtrList: no VisContainerInterfacePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisContainerInterfacePtrList (VisContainerInterfacePtr e, VisContainerInterfacePtrList l, VisContainerInterfacePtrCmpFctType fcmp)
#else
int ElemInVisContainerInterfacePtrList (e, l, fcmp)
        VisContainerInterfacePtr        e;
        VisContainerInterfacePtrList    l;
        VisContainerInterfacePtrCmpFctType      fcmp;
#endif
{
    while (l != NULLVisContainerInterfacePtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList AddToSetVisContainerInterfacePtrList (VisContainerInterfacePtr e, VisContainerInterfacePtrList l, VisContainerInterfacePtrCmpFctType fcmp)
#else
VisContainerInterfacePtrList AddToSetVisContainerInterfacePtrList (e, l, fcmp)
        VisContainerInterfacePtr        e;
        VisContainerInterfacePtrList    l;
        VisContainerInterfacePtrCmpFctType      fcmp;
#endif
{
    if (ElemInVisContainerInterfacePtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisContainerInterfacePtrList (e, l));
}/* AddToSetVisContainerInterfacePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList AddToOrderedSetVisContainerInterfacePtrList (VisContainerInterfacePtr e, VisContainerInterfacePtrList l, VisContainerInterfacePtrCmpFctType fcmp)
#else
VisContainerInterfacePtrList AddToOrderedSetVisContainerInterfacePtrList (e, l, fcmp)
        VisContainerInterfacePtr  e;
        VisContainerInterfacePtrList      l;
        VisContainerInterfacePtrCmpFctType fcmp;
#endif
{   int test;
    VisContainerInterfacePtrList  p;
    if (!l)
        return (ConsVisContainerInterfacePtrList (e, NULLVisContainerInterfacePtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisContainerInterfacePtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisContainerInterfacePtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtrList MapVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtrMapFct f)
#else
VisContainerInterfacePtrList MapVisContainerInterfacePtrList (l, f)
        VisContainerInterfacePtrList    l;
        VisContainerInterfacePtrMapFct f;
#endif
{
    VisContainerInterfacePtrList NewList = NULLVisContainerInterfacePtrList;
    VisContainerInterfacePtrList last = NULLVisContainerInterfacePtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisContainerInterfacePtrList ((f (l->head)), NULLVisContainerInterfacePtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisContainerInterfacePtrList ((f (l->head)), NULLVisContainerInterfacePtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisContainerInterfacePtrList (VisContainerInterfacePtrList l1, VisContainerInterfacePtrList l2, VisContainerInterfacePtrCmpFctType fcmp)
#else
int CompVisContainerInterfacePtrList (l1, l2, fcmp)
        VisContainerInterfacePtrList    l1, l2;
        VisContainerInterfacePtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisContainerInterfacePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisContainerInterfacePtr SumVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtrSumFct f, VisContainerInterfacePtr a)
#else
VisContainerInterfacePtr SumVisContainerInterfacePtrList (l, f, a)
        VisContainerInterfacePtrList    l;
        VisContainerInterfacePtr ((*f) ());
        VisContainerInterfacePtr        a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisContainerInterfacePtrList */
