
#ifndef _VisContainerInterfacePtrLIST_H
#define _VisContainerInterfacePtrLIST_H

/* include header file defining VisContainerInterfacePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

#include "VisContainerInterfacePtrFunctionTypes.h"

typedef struct _VisContainerInterfacePtrLE *VisContainerInterfacePtrList;
typedef VisContainerInterfacePtrList    *VisContainerInterfacePtrListPtr;

struct _VisContainerInterfacePtrLE {
VisContainerInterfacePtr                head;
VisContainerInterfacePtrList    tail;
};

#define NULLVisContainerInterfacePtrList                ((VisContainerInterfacePtrList)0)
#define NullVisContainerInterfacePtrList()      ((VisContainerInterfacePtrList)0)
#define SingleVisContainerInterfacePtrList(e)   (ConsVisContainerInterfacePtrList((e),NULLVisContainerInterfacePtrList))

#if defined(__STDC__) || defined(__cplusplus)

extern void FinlVisContainerInterfacePtrList(void);
   /* Deallocates all VisContainerInterfacePtrLists. */
   /* Dynamic storage is allocated on first need */

extern VisContainerInterfacePtrList ConsVisContainerInterfacePtrList (VisContainerInterfacePtr e, VisContainerInterfacePtrList l);
   /* Constructs a VisContainerInterfacePtrList of an element e and a given tail l.
    * e is the first element of the list. */

extern VisContainerInterfacePtr HeadVisContainerInterfacePtrList (VisContainerInterfacePtrList l);
   /* Returns the first element of the list l.
    * The list l must not be empty. */

extern VisContainerInterfacePtrList TailVisContainerInterfacePtrList (VisContainerInterfacePtrList l);
   /* Returns the tail of the list l.
    * If l is empty, an empty list is returned. */

extern int LengthVisContainerInterfacePtrList (VisContainerInterfacePtrList l);
   /* Returns the number of elements in the list l. */

extern VisContainerInterfacePtr IthElemVisContainerInterfacePtrList (VisContainerInterfacePtrList l, int i);
   /* Returns the i-th element of the List l. The head of l
    * is referred to as 1. If the value of
    * i is greater than the length of the list, an error
    * is reported and the program exits.
    */

extern VisContainerInterfacePtrList CopyVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtrMapFct cp);
   /* Copies the list l. Elements are copied by calls of cp. */

extern VisContainerInterfacePtrList AppVisContainerInterfacePtrList (VisContainerInterfacePtrList l1, VisContainerInterfacePtrList l2);
   /* Concatenates two lists l1 and l2. The resulting list contains l2 at
    * the end of a copy of list l1. */

extern VisContainerInterfacePtrList AppElVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtr e);
   /* Appends an element e to the list l.
    * The list l is not copied, it is modified as a side-effect
    * of this function. */

extern void InsertAfterVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtr e);
   /* This function requires a non-empty list l. The element e is inserted
    * just after the first element of l. 
    * The list l is modified as a side-effect of this function. */

extern VisContainerInterfacePtrList OrderedInsertVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtr e, VisContainerInterfacePtrCmpFctType fcmp);
   /* Inserts the element e into the list l maintaining l in
    * ascending order with respect to the compare fcmp. 
    * The list l is modified as a side-effect of this function. */

extern VisContainerInterfacePtrListPtr RefEndConsVisContainerInterfacePtrList (VisContainerInterfacePtrListPtr addr, VisContainerInterfacePtr e);
   /* Appends an element e to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern VisContainerInterfacePtrListPtr RefEndAppVisContainerInterfacePtrList (VisContainerInterfacePtrListPtr addr, VisContainerInterfacePtrList l);
   /* Appends a list l to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern int ElemInVisContainerInterfacePtrList (VisContainerInterfacePtr e, VisContainerInterfacePtrList l, VisContainerInterfacePtrCmpFctType cmpfct);
   /* This function returns true (1) iff the element e is in the List l.
    * List elements are compared by the function cmpfct. */

extern VisContainerInterfacePtrList AddToSetVisContainerInterfacePtrList (VisContainerInterfacePtr e, VisContainerInterfacePtrList l, VisContainerInterfacePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. */

extern VisContainerInterfacePtrList AddToOrderedSetVisContainerInterfacePtrList 
       (VisContainerInterfacePtr e, VisContainerInterfacePtrList l, VisContainerInterfacePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. l is assumed to be ordered increasingly in the sense of
    * cmpfct. */

extern VisContainerInterfacePtrList MapVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtrMapFct f);
   /* Returns a new VisContainerInterfacePtrList obtained by applying f to each element of l. */

extern int CompVisContainerInterfacePtrList (VisContainerInterfacePtrList l1, VisContainerInterfacePtrList l2, VisContainerInterfacePtrCmpFctType f);
   /* Compares the lists l1 and l2 lexicographically by applying f
    * to the corresponding elements. */

extern VisContainerInterfacePtr SumVisContainerInterfacePtrList (VisContainerInterfacePtrList l, VisContainerInterfacePtrSumFct f, VisContainerInterfacePtr a);
   /* Applies the binary function f to the elements of the List:
    *   f( f(... f(a, e1), e2, ...), en)
    * If l is empty a is returned. */

#else

extern void FinlVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList ConsVisContainerInterfacePtrList ();
extern VisContainerInterfacePtr HeadVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList TailVisContainerInterfacePtrList ();
extern int LengthVisContainerInterfacePtrList ();
extern VisContainerInterfacePtr IthElemVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList CopyVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList AppVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList AppElVisContainerInterfacePtrList ();
extern void InsertAfterVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList OrderedInsertVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrListPtr RefEndConsVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrListPtr RefEndAppVisContainerInterfacePtrList ();
extern int ElemInVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList AddToSetVisContainerInterfacePtrList ();
extern VisContainerInterfacePtrList MapVisContainerInterfacePtrList ();
extern int CompVisContainerInterfacePtrList ();
extern VisContainerInterfacePtr SumVisContainerInterfacePtrList ();

#endif

#ifdef MONITOR
#define DAPTO_RESULTVisContainerInterfacePtrList(l) DAPTO_RESULT_PTR(l)
#define DAPTO_ARGVisContainerInterfacePtrList(l)    DAPTO_ARG_PTR (l, VisContainerInterfacePtrList)
#endif

#endif
