

#include "VisCrossAreaPtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisCrossAreaPtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisCrossAreaPtrList (void)
#else
void FinlVisCrossAreaPtrList ()
#endif
{
    if (VisCrossAreaPtrListSpace != (DynP)0)
    {  obstack_free(&(VisCrossAreaPtrListSpace->space), VisCrossAreaPtrListSpace->baseptr);
       VisCrossAreaPtrListSpace->baseptr = obstack_alloc(&(VisCrossAreaPtrListSpace->space), 0);
    }
}/* FinlVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList ConsVisCrossAreaPtrList (VisCrossAreaPtr e, VisCrossAreaPtrList l)
#else
VisCrossAreaPtrList ConsVisCrossAreaPtrList (e, l)
        VisCrossAreaPtr e;
        VisCrossAreaPtrList     l;
#endif
{
    VisCrossAreaPtrList h;

    if (VisCrossAreaPtrListSpace == (DynP)0)
    {   VisCrossAreaPtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisCrossAreaPtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisCrossAreaPtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisCrossAreaPtrListSpace->space));
        VisCrossAreaPtrListSpace->baseptr =
                obstack_alloc(&(VisCrossAreaPtrListSpace->space), 0);
    }

    h = (VisCrossAreaPtrList)obstack_alloc(&(VisCrossAreaPtrListSpace->space),
                                  sizeof (struct _VisCrossAreaPtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtr HeadVisCrossAreaPtrList (VisCrossAreaPtrList l)
#else
VisCrossAreaPtr HeadVisCrossAreaPtrList (l)
        VisCrossAreaPtrList     l;
#endif
{
    if (l == NULLVisCrossAreaPtrList)
    {
        message (DEADLY, "HeadVisCrossAreaPtrList: empty list", 0, (POSITION*)0);
        /* return ((VisCrossAreaPtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList TailVisCrossAreaPtrList (VisCrossAreaPtrList l)
#else
VisCrossAreaPtrList TailVisCrossAreaPtrList (l)
        VisCrossAreaPtrList     l;
#endif
{
    return ((l==NULLVisCrossAreaPtrList) ? NULLVisCrossAreaPtrList : l->tail);
}/* TailVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisCrossAreaPtrList (VisCrossAreaPtrList l)
#else
int LengthVisCrossAreaPtrList (l)
        VisCrossAreaPtrList     l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtr IthElemVisCrossAreaPtrList (VisCrossAreaPtrList l, int i)
#else
VisCrossAreaPtr IthElemVisCrossAreaPtrList (l, i)
        VisCrossAreaPtrList     l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisCrossAreaPtrList))
        message (DEADLY, "IthElemVisCrossAreaPtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisCrossAreaPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList CopyVisCrossAreaPtrList (VisCrossAreaPtrList l, VisCrossAreaPtrMapFct cp)
#else
VisCrossAreaPtrList CopyVisCrossAreaPtrList (l, cp)
        VisCrossAreaPtrList l;
        VisCrossAreaPtrMapFct   cp;
#endif
{
    VisCrossAreaPtrList NewList=NULLVisCrossAreaPtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisCrossAreaPtrList (cp (l->head), NULLVisCrossAreaPtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList AppVisCrossAreaPtrList (VisCrossAreaPtrList l1, VisCrossAreaPtrList l2)
#else
VisCrossAreaPtrList AppVisCrossAreaPtrList (l1, l2)
        VisCrossAreaPtrList     l1, l2;
#endif
{
    VisCrossAreaPtrList NewList;
    VisCrossAreaPtrList *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisCrossAreaPtrList (l1->head, NULLVisCrossAreaPtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList AppElVisCrossAreaPtrList (VisCrossAreaPtrList l, VisCrossAreaPtr e)
#else
VisCrossAreaPtrList AppElVisCrossAreaPtrList (l, e)
        VisCrossAreaPtrList     l;
        VisCrossAreaPtr e;
#endif
{
    VisCrossAreaPtrList res = l;
    if (!l)
        return (ConsVisCrossAreaPtrList (e, NULLVisCrossAreaPtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisCrossAreaPtrList (e, NULLVisCrossAreaPtrList);

    return (res);
} /* AppElVisCrossAreaPtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisCrossAreaPtrList (VisCrossAreaPtrList l, VisCrossAreaPtr e)
#else
void InsertAfterVisCrossAreaPtrList (l, e)
        VisCrossAreaPtrList     l;
        VisCrossAreaPtr e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisCrossAreaPtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisCrossAreaPtrList (e, l->tail);
}/* InsertAfterVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList OrderedInsertVisCrossAreaPtrList (VisCrossAreaPtrList l, VisCrossAreaPtr e, VisCrossAreaPtrCmpFctType fcmp)
#else
VisCrossAreaPtrList OrderedInsertVisCrossAreaPtrList (l, e, fcmp)
        VisCrossAreaPtrList     l;
        VisCrossAreaPtr e;
        VisCrossAreaPtrCmpFctType fcmp;
#endif
{
    VisCrossAreaPtrList p;
    if (!l)
        return (ConsVisCrossAreaPtrList (e, NULLVisCrossAreaPtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisCrossAreaPtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisCrossAreaPtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrListPtr RefEndConsVisCrossAreaPtrList (VisCrossAreaPtrListPtr addr, VisCrossAreaPtr e)
#else
VisCrossAreaPtrListPtr RefEndConsVisCrossAreaPtrList (addr, e)
        VisCrossAreaPtrListPtr  addr;
        VisCrossAreaPtr         e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisCrossAreaPtrList: no VisCrossAreaPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisCrossAreaPtrList (e, NULLVisCrossAreaPtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrListPtr RefEndAppVisCrossAreaPtrList (VisCrossAreaPtrListPtr addr, VisCrossAreaPtrList l)
#else
VisCrossAreaPtrListPtr RefEndAppVisCrossAreaPtrList (addr, l)
        VisCrossAreaPtrListPtr  addr;
        VisCrossAreaPtrList             l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisCrossAreaPtrList: no VisCrossAreaPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisCrossAreaPtrList (VisCrossAreaPtr e, VisCrossAreaPtrList l, VisCrossAreaPtrCmpFctType fcmp)
#else
int ElemInVisCrossAreaPtrList (e, l, fcmp)
        VisCrossAreaPtr e;
        VisCrossAreaPtrList     l;
        VisCrossAreaPtrCmpFctType       fcmp;
#endif
{
    while (l != NULLVisCrossAreaPtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList AddToSetVisCrossAreaPtrList (VisCrossAreaPtr e, VisCrossAreaPtrList l, VisCrossAreaPtrCmpFctType fcmp)
#else
VisCrossAreaPtrList AddToSetVisCrossAreaPtrList (e, l, fcmp)
        VisCrossAreaPtr e;
        VisCrossAreaPtrList     l;
        VisCrossAreaPtrCmpFctType       fcmp;
#endif
{
    if (ElemInVisCrossAreaPtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisCrossAreaPtrList (e, l));
}/* AddToSetVisCrossAreaPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList AddToOrderedSetVisCrossAreaPtrList (VisCrossAreaPtr e, VisCrossAreaPtrList l, VisCrossAreaPtrCmpFctType fcmp)
#else
VisCrossAreaPtrList AddToOrderedSetVisCrossAreaPtrList (e, l, fcmp)
        VisCrossAreaPtr  e;
        VisCrossAreaPtrList      l;
        VisCrossAreaPtrCmpFctType fcmp;
#endif
{   int test;
    VisCrossAreaPtrList  p;
    if (!l)
        return (ConsVisCrossAreaPtrList (e, NULLVisCrossAreaPtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisCrossAreaPtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisCrossAreaPtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtrList MapVisCrossAreaPtrList (VisCrossAreaPtrList l, VisCrossAreaPtrMapFct f)
#else
VisCrossAreaPtrList MapVisCrossAreaPtrList (l, f)
        VisCrossAreaPtrList     l;
        VisCrossAreaPtrMapFct f;
#endif
{
    VisCrossAreaPtrList NewList = NULLVisCrossAreaPtrList;
    VisCrossAreaPtrList last = NULLVisCrossAreaPtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisCrossAreaPtrList ((f (l->head)), NULLVisCrossAreaPtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisCrossAreaPtrList ((f (l->head)), NULLVisCrossAreaPtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisCrossAreaPtrList (VisCrossAreaPtrList l1, VisCrossAreaPtrList l2, VisCrossAreaPtrCmpFctType fcmp)
#else
int CompVisCrossAreaPtrList (l1, l2, fcmp)
        VisCrossAreaPtrList     l1, l2;
        VisCrossAreaPtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisCrossAreaPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisCrossAreaPtr SumVisCrossAreaPtrList (VisCrossAreaPtrList l, VisCrossAreaPtrSumFct f, VisCrossAreaPtr a)
#else
VisCrossAreaPtr SumVisCrossAreaPtrList (l, f, a)
        VisCrossAreaPtrList     l;
        VisCrossAreaPtr ((*f) ());
        VisCrossAreaPtr a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisCrossAreaPtrList */
