

#include "VisMovablePtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisMovablePtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisMovablePtrList (void)
#else
void FinlVisMovablePtrList ()
#endif
{
    if (VisMovablePtrListSpace != (DynP)0)
    {  obstack_free(&(VisMovablePtrListSpace->space), VisMovablePtrListSpace->baseptr);
       VisMovablePtrListSpace->baseptr = obstack_alloc(&(VisMovablePtrListSpace->space), 0);
    }
}/* FinlVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList ConsVisMovablePtrList (VisMovablePtr e, VisMovablePtrList l)
#else
VisMovablePtrList ConsVisMovablePtrList (e, l)
        VisMovablePtr   e;
        VisMovablePtrList       l;
#endif
{
    VisMovablePtrList   h;

    if (VisMovablePtrListSpace == (DynP)0)
    {   VisMovablePtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisMovablePtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisMovablePtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisMovablePtrListSpace->space));
        VisMovablePtrListSpace->baseptr =
                obstack_alloc(&(VisMovablePtrListSpace->space), 0);
    }

    h = (VisMovablePtrList)obstack_alloc(&(VisMovablePtrListSpace->space),
                                  sizeof (struct _VisMovablePtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtr HeadVisMovablePtrList (VisMovablePtrList l)
#else
VisMovablePtr HeadVisMovablePtrList (l)
        VisMovablePtrList       l;
#endif
{
    if (l == NULLVisMovablePtrList)
    {
        message (DEADLY, "HeadVisMovablePtrList: empty list", 0, (POSITION*)0);
        /* return ((VisMovablePtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList TailVisMovablePtrList (VisMovablePtrList l)
#else
VisMovablePtrList TailVisMovablePtrList (l)
        VisMovablePtrList       l;
#endif
{
    return ((l==NULLVisMovablePtrList) ? NULLVisMovablePtrList : l->tail);
}/* TailVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisMovablePtrList (VisMovablePtrList l)
#else
int LengthVisMovablePtrList (l)
        VisMovablePtrList       l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtr IthElemVisMovablePtrList (VisMovablePtrList l, int i)
#else
VisMovablePtr IthElemVisMovablePtrList (l, i)
        VisMovablePtrList       l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisMovablePtrList))
        message (DEADLY, "IthElemVisMovablePtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisMovablePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList CopyVisMovablePtrList (VisMovablePtrList l, VisMovablePtrMapFct cp)
#else
VisMovablePtrList CopyVisMovablePtrList (l, cp)
        VisMovablePtrList l;
        VisMovablePtrMapFct     cp;
#endif
{
    VisMovablePtrList NewList=NULLVisMovablePtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisMovablePtrList (cp (l->head), NULLVisMovablePtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList AppVisMovablePtrList (VisMovablePtrList l1, VisMovablePtrList l2)
#else
VisMovablePtrList AppVisMovablePtrList (l1, l2)
        VisMovablePtrList       l1, l2;
#endif
{
    VisMovablePtrList   NewList;
    VisMovablePtrList   *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisMovablePtrList (l1->head, NULLVisMovablePtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList AppElVisMovablePtrList (VisMovablePtrList l, VisMovablePtr e)
#else
VisMovablePtrList AppElVisMovablePtrList (l, e)
        VisMovablePtrList       l;
        VisMovablePtr   e;
#endif
{
    VisMovablePtrList   res = l;
    if (!l)
        return (ConsVisMovablePtrList (e, NULLVisMovablePtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisMovablePtrList (e, NULLVisMovablePtrList);

    return (res);
} /* AppElVisMovablePtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisMovablePtrList (VisMovablePtrList l, VisMovablePtr e)
#else
void InsertAfterVisMovablePtrList (l, e)
        VisMovablePtrList       l;
        VisMovablePtr   e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisMovablePtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisMovablePtrList (e, l->tail);
}/* InsertAfterVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList OrderedInsertVisMovablePtrList (VisMovablePtrList l, VisMovablePtr e, VisMovablePtrCmpFctType fcmp)
#else
VisMovablePtrList OrderedInsertVisMovablePtrList (l, e, fcmp)
        VisMovablePtrList       l;
        VisMovablePtr   e;
        VisMovablePtrCmpFctType fcmp;
#endif
{
    VisMovablePtrList   p;
    if (!l)
        return (ConsVisMovablePtrList (e, NULLVisMovablePtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisMovablePtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisMovablePtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrListPtr RefEndConsVisMovablePtrList (VisMovablePtrListPtr addr, VisMovablePtr e)
#else
VisMovablePtrListPtr RefEndConsVisMovablePtrList (addr, e)
        VisMovablePtrListPtr    addr;
        VisMovablePtr           e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisMovablePtrList: no VisMovablePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisMovablePtrList (e, NULLVisMovablePtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrListPtr RefEndAppVisMovablePtrList (VisMovablePtrListPtr addr, VisMovablePtrList l)
#else
VisMovablePtrListPtr RefEndAppVisMovablePtrList (addr, l)
        VisMovablePtrListPtr    addr;
        VisMovablePtrList               l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisMovablePtrList: no VisMovablePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisMovablePtrList (VisMovablePtr e, VisMovablePtrList l, VisMovablePtrCmpFctType fcmp)
#else
int ElemInVisMovablePtrList (e, l, fcmp)
        VisMovablePtr   e;
        VisMovablePtrList       l;
        VisMovablePtrCmpFctType fcmp;
#endif
{
    while (l != NULLVisMovablePtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList AddToSetVisMovablePtrList (VisMovablePtr e, VisMovablePtrList l, VisMovablePtrCmpFctType fcmp)
#else
VisMovablePtrList AddToSetVisMovablePtrList (e, l, fcmp)
        VisMovablePtr   e;
        VisMovablePtrList       l;
        VisMovablePtrCmpFctType fcmp;
#endif
{
    if (ElemInVisMovablePtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisMovablePtrList (e, l));
}/* AddToSetVisMovablePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList AddToOrderedSetVisMovablePtrList (VisMovablePtr e, VisMovablePtrList l, VisMovablePtrCmpFctType fcmp)
#else
VisMovablePtrList AddToOrderedSetVisMovablePtrList (e, l, fcmp)
        VisMovablePtr  e;
        VisMovablePtrList      l;
        VisMovablePtrCmpFctType fcmp;
#endif
{   int test;
    VisMovablePtrList  p;
    if (!l)
        return (ConsVisMovablePtrList (e, NULLVisMovablePtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisMovablePtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisMovablePtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtrList MapVisMovablePtrList (VisMovablePtrList l, VisMovablePtrMapFct f)
#else
VisMovablePtrList MapVisMovablePtrList (l, f)
        VisMovablePtrList       l;
        VisMovablePtrMapFct f;
#endif
{
    VisMovablePtrList NewList = NULLVisMovablePtrList;
    VisMovablePtrList last = NULLVisMovablePtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisMovablePtrList ((f (l->head)), NULLVisMovablePtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisMovablePtrList ((f (l->head)), NULLVisMovablePtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisMovablePtrList (VisMovablePtrList l1, VisMovablePtrList l2, VisMovablePtrCmpFctType fcmp)
#else
int CompVisMovablePtrList (l1, l2, fcmp)
        VisMovablePtrList       l1, l2;
        VisMovablePtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisMovablePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisMovablePtr SumVisMovablePtrList (VisMovablePtrList l, VisMovablePtrSumFct f, VisMovablePtr a)
#else
VisMovablePtr SumVisMovablePtrList (l, f, a)
        VisMovablePtrList       l;
        VisMovablePtr ((*f) ());
        VisMovablePtr   a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisMovablePtrList */
