

#include "VisRelationLabelPtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisRelationLabelPtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisRelationLabelPtrList (void)
#else
void FinlVisRelationLabelPtrList ()
#endif
{
    if (VisRelationLabelPtrListSpace != (DynP)0)
    {  obstack_free(&(VisRelationLabelPtrListSpace->space), VisRelationLabelPtrListSpace->baseptr);
       VisRelationLabelPtrListSpace->baseptr = obstack_alloc(&(VisRelationLabelPtrListSpace->space), 0);
    }
}/* FinlVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList ConsVisRelationLabelPtrList (VisRelationLabelPtr e, VisRelationLabelPtrList l)
#else
VisRelationLabelPtrList ConsVisRelationLabelPtrList (e, l)
        VisRelationLabelPtr     e;
        VisRelationLabelPtrList l;
#endif
{
    VisRelationLabelPtrList     h;

    if (VisRelationLabelPtrListSpace == (DynP)0)
    {   VisRelationLabelPtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisRelationLabelPtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisRelationLabelPtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisRelationLabelPtrListSpace->space));
        VisRelationLabelPtrListSpace->baseptr =
                obstack_alloc(&(VisRelationLabelPtrListSpace->space), 0);
    }

    h = (VisRelationLabelPtrList)obstack_alloc(&(VisRelationLabelPtrListSpace->space),
                                  sizeof (struct _VisRelationLabelPtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtr HeadVisRelationLabelPtrList (VisRelationLabelPtrList l)
#else
VisRelationLabelPtr HeadVisRelationLabelPtrList (l)
        VisRelationLabelPtrList l;
#endif
{
    if (l == NULLVisRelationLabelPtrList)
    {
        message (DEADLY, "HeadVisRelationLabelPtrList: empty list", 0, (POSITION*)0);
        /* return ((VisRelationLabelPtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList TailVisRelationLabelPtrList (VisRelationLabelPtrList l)
#else
VisRelationLabelPtrList TailVisRelationLabelPtrList (l)
        VisRelationLabelPtrList l;
#endif
{
    return ((l==NULLVisRelationLabelPtrList) ? NULLVisRelationLabelPtrList : l->tail);
}/* TailVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisRelationLabelPtrList (VisRelationLabelPtrList l)
#else
int LengthVisRelationLabelPtrList (l)
        VisRelationLabelPtrList l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtr IthElemVisRelationLabelPtrList (VisRelationLabelPtrList l, int i)
#else
VisRelationLabelPtr IthElemVisRelationLabelPtrList (l, i)
        VisRelationLabelPtrList l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisRelationLabelPtrList))
        message (DEADLY, "IthElemVisRelationLabelPtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisRelationLabelPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList CopyVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtrMapFct cp)
#else
VisRelationLabelPtrList CopyVisRelationLabelPtrList (l, cp)
        VisRelationLabelPtrList l;
        VisRelationLabelPtrMapFct       cp;
#endif
{
    VisRelationLabelPtrList NewList=NULLVisRelationLabelPtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisRelationLabelPtrList (cp (l->head), NULLVisRelationLabelPtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList AppVisRelationLabelPtrList (VisRelationLabelPtrList l1, VisRelationLabelPtrList l2)
#else
VisRelationLabelPtrList AppVisRelationLabelPtrList (l1, l2)
        VisRelationLabelPtrList l1, l2;
#endif
{
    VisRelationLabelPtrList     NewList;
    VisRelationLabelPtrList     *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisRelationLabelPtrList (l1->head, NULLVisRelationLabelPtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList AppElVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtr e)
#else
VisRelationLabelPtrList AppElVisRelationLabelPtrList (l, e)
        VisRelationLabelPtrList l;
        VisRelationLabelPtr     e;
#endif
{
    VisRelationLabelPtrList     res = l;
    if (!l)
        return (ConsVisRelationLabelPtrList (e, NULLVisRelationLabelPtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisRelationLabelPtrList (e, NULLVisRelationLabelPtrList);

    return (res);
} /* AppElVisRelationLabelPtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtr e)
#else
void InsertAfterVisRelationLabelPtrList (l, e)
        VisRelationLabelPtrList l;
        VisRelationLabelPtr     e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisRelationLabelPtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisRelationLabelPtrList (e, l->tail);
}/* InsertAfterVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList OrderedInsertVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtr e, VisRelationLabelPtrCmpFctType fcmp)
#else
VisRelationLabelPtrList OrderedInsertVisRelationLabelPtrList (l, e, fcmp)
        VisRelationLabelPtrList l;
        VisRelationLabelPtr     e;
        VisRelationLabelPtrCmpFctType fcmp;
#endif
{
    VisRelationLabelPtrList     p;
    if (!l)
        return (ConsVisRelationLabelPtrList (e, NULLVisRelationLabelPtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisRelationLabelPtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisRelationLabelPtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrListPtr RefEndConsVisRelationLabelPtrList (VisRelationLabelPtrListPtr addr, VisRelationLabelPtr e)
#else
VisRelationLabelPtrListPtr RefEndConsVisRelationLabelPtrList (addr, e)
        VisRelationLabelPtrListPtr      addr;
        VisRelationLabelPtr             e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisRelationLabelPtrList: no VisRelationLabelPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisRelationLabelPtrList (e, NULLVisRelationLabelPtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrListPtr RefEndAppVisRelationLabelPtrList (VisRelationLabelPtrListPtr addr, VisRelationLabelPtrList l)
#else
VisRelationLabelPtrListPtr RefEndAppVisRelationLabelPtrList (addr, l)
        VisRelationLabelPtrListPtr      addr;
        VisRelationLabelPtrList         l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisRelationLabelPtrList: no VisRelationLabelPtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisRelationLabelPtrList (VisRelationLabelPtr e, VisRelationLabelPtrList l, VisRelationLabelPtrCmpFctType fcmp)
#else
int ElemInVisRelationLabelPtrList (e, l, fcmp)
        VisRelationLabelPtr     e;
        VisRelationLabelPtrList l;
        VisRelationLabelPtrCmpFctType   fcmp;
#endif
{
    while (l != NULLVisRelationLabelPtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList AddToSetVisRelationLabelPtrList (VisRelationLabelPtr e, VisRelationLabelPtrList l, VisRelationLabelPtrCmpFctType fcmp)
#else
VisRelationLabelPtrList AddToSetVisRelationLabelPtrList (e, l, fcmp)
        VisRelationLabelPtr     e;
        VisRelationLabelPtrList l;
        VisRelationLabelPtrCmpFctType   fcmp;
#endif
{
    if (ElemInVisRelationLabelPtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisRelationLabelPtrList (e, l));
}/* AddToSetVisRelationLabelPtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList AddToOrderedSetVisRelationLabelPtrList (VisRelationLabelPtr e, VisRelationLabelPtrList l, VisRelationLabelPtrCmpFctType fcmp)
#else
VisRelationLabelPtrList AddToOrderedSetVisRelationLabelPtrList (e, l, fcmp)
        VisRelationLabelPtr  e;
        VisRelationLabelPtrList      l;
        VisRelationLabelPtrCmpFctType fcmp;
#endif
{   int test;
    VisRelationLabelPtrList  p;
    if (!l)
        return (ConsVisRelationLabelPtrList (e, NULLVisRelationLabelPtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisRelationLabelPtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisRelationLabelPtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtrList MapVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtrMapFct f)
#else
VisRelationLabelPtrList MapVisRelationLabelPtrList (l, f)
        VisRelationLabelPtrList l;
        VisRelationLabelPtrMapFct f;
#endif
{
    VisRelationLabelPtrList NewList = NULLVisRelationLabelPtrList;
    VisRelationLabelPtrList last = NULLVisRelationLabelPtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisRelationLabelPtrList ((f (l->head)), NULLVisRelationLabelPtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisRelationLabelPtrList ((f (l->head)), NULLVisRelationLabelPtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisRelationLabelPtrList (VisRelationLabelPtrList l1, VisRelationLabelPtrList l2, VisRelationLabelPtrCmpFctType fcmp)
#else
int CompVisRelationLabelPtrList (l1, l2, fcmp)
        VisRelationLabelPtrList l1, l2;
        VisRelationLabelPtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisRelationLabelPtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationLabelPtr SumVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtrSumFct f, VisRelationLabelPtr a)
#else
VisRelationLabelPtr SumVisRelationLabelPtrList (l, f, a)
        VisRelationLabelPtrList l;
        VisRelationLabelPtr ((*f) ());
        VisRelationLabelPtr     a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisRelationLabelPtrList */
