
#ifndef _VisRelationLabelPtrLIST_H
#define _VisRelationLabelPtrLIST_H

/* include header file defining VisRelationLabelPtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

#include "VisRelationLabelPtrFunctionTypes.h"

typedef struct _VisRelationLabelPtrLE *VisRelationLabelPtrList;
typedef VisRelationLabelPtrList    *VisRelationLabelPtrListPtr;

struct _VisRelationLabelPtrLE {
VisRelationLabelPtr             head;
VisRelationLabelPtrList tail;
};

#define NULLVisRelationLabelPtrList             ((VisRelationLabelPtrList)0)
#define NullVisRelationLabelPtrList()   ((VisRelationLabelPtrList)0)
#define SingleVisRelationLabelPtrList(e)        (ConsVisRelationLabelPtrList((e),NULLVisRelationLabelPtrList))

#if defined(__STDC__) || defined(__cplusplus)

extern void FinlVisRelationLabelPtrList(void);
   /* Deallocates all VisRelationLabelPtrLists. */
   /* Dynamic storage is allocated on first need */

extern VisRelationLabelPtrList ConsVisRelationLabelPtrList (VisRelationLabelPtr e, VisRelationLabelPtrList l);
   /* Constructs a VisRelationLabelPtrList of an element e and a given tail l.
    * e is the first element of the list. */

extern VisRelationLabelPtr HeadVisRelationLabelPtrList (VisRelationLabelPtrList l);
   /* Returns the first element of the list l.
    * The list l must not be empty. */

extern VisRelationLabelPtrList TailVisRelationLabelPtrList (VisRelationLabelPtrList l);
   /* Returns the tail of the list l.
    * If l is empty, an empty list is returned. */

extern int LengthVisRelationLabelPtrList (VisRelationLabelPtrList l);
   /* Returns the number of elements in the list l. */

extern VisRelationLabelPtr IthElemVisRelationLabelPtrList (VisRelationLabelPtrList l, int i);
   /* Returns the i-th element of the List l. The head of l
    * is referred to as 1. If the value of
    * i is greater than the length of the list, an error
    * is reported and the program exits.
    */

extern VisRelationLabelPtrList CopyVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtrMapFct cp);
   /* Copies the list l. Elements are copied by calls of cp. */

extern VisRelationLabelPtrList AppVisRelationLabelPtrList (VisRelationLabelPtrList l1, VisRelationLabelPtrList l2);
   /* Concatenates two lists l1 and l2. The resulting list contains l2 at
    * the end of a copy of list l1. */

extern VisRelationLabelPtrList AppElVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtr e);
   /* Appends an element e to the list l.
    * The list l is not copied, it is modified as a side-effect
    * of this function. */

extern void InsertAfterVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtr e);
   /* This function requires a non-empty list l. The element e is inserted
    * just after the first element of l. 
    * The list l is modified as a side-effect of this function. */

extern VisRelationLabelPtrList OrderedInsertVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtr e, VisRelationLabelPtrCmpFctType fcmp);
   /* Inserts the element e into the list l maintaining l in
    * ascending order with respect to the compare fcmp. 
    * The list l is modified as a side-effect of this function. */

extern VisRelationLabelPtrListPtr RefEndConsVisRelationLabelPtrList (VisRelationLabelPtrListPtr addr, VisRelationLabelPtr e);
   /* Appends an element e to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern VisRelationLabelPtrListPtr RefEndAppVisRelationLabelPtrList (VisRelationLabelPtrListPtr addr, VisRelationLabelPtrList l);
   /* Appends a list l to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern int ElemInVisRelationLabelPtrList (VisRelationLabelPtr e, VisRelationLabelPtrList l, VisRelationLabelPtrCmpFctType cmpfct);
   /* This function returns true (1) iff the element e is in the List l.
    * List elements are compared by the function cmpfct. */

extern VisRelationLabelPtrList AddToSetVisRelationLabelPtrList (VisRelationLabelPtr e, VisRelationLabelPtrList l, VisRelationLabelPtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. */

extern VisRelationLabelPtrList AddToOrderedSetVisRelationLabelPtrList 
       (VisRelationLabelPtr e, VisRelationLabelPtrList l, VisRelationLabelPtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. l is assumed to be ordered increasingly in the sense of
    * cmpfct. */

extern VisRelationLabelPtrList MapVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtrMapFct f);
   /* Returns a new VisRelationLabelPtrList obtained by applying f to each element of l. */

extern int CompVisRelationLabelPtrList (VisRelationLabelPtrList l1, VisRelationLabelPtrList l2, VisRelationLabelPtrCmpFctType f);
   /* Compares the lists l1 and l2 lexicographically by applying f
    * to the corresponding elements. */

extern VisRelationLabelPtr SumVisRelationLabelPtrList (VisRelationLabelPtrList l, VisRelationLabelPtrSumFct f, VisRelationLabelPtr a);
   /* Applies the binary function f to the elements of the List:
    *   f( f(... f(a, e1), e2, ...), en)
    * If l is empty a is returned. */

#else

extern void FinlVisRelationLabelPtrList ();
extern VisRelationLabelPtrList ConsVisRelationLabelPtrList ();
extern VisRelationLabelPtr HeadVisRelationLabelPtrList ();
extern VisRelationLabelPtrList TailVisRelationLabelPtrList ();
extern int LengthVisRelationLabelPtrList ();
extern VisRelationLabelPtr IthElemVisRelationLabelPtrList ();
extern VisRelationLabelPtrList CopyVisRelationLabelPtrList ();
extern VisRelationLabelPtrList AppVisRelationLabelPtrList ();
extern VisRelationLabelPtrList AppElVisRelationLabelPtrList ();
extern void InsertAfterVisRelationLabelPtrList ();
extern VisRelationLabelPtrList OrderedInsertVisRelationLabelPtrList ();
extern VisRelationLabelPtrListPtr RefEndConsVisRelationLabelPtrList ();
extern VisRelationLabelPtrListPtr RefEndAppVisRelationLabelPtrList ();
extern int ElemInVisRelationLabelPtrList ();
extern VisRelationLabelPtrList AddToSetVisRelationLabelPtrList ();
extern VisRelationLabelPtrList MapVisRelationLabelPtrList ();
extern int CompVisRelationLabelPtrList ();
extern VisRelationLabelPtr SumVisRelationLabelPtrList ();

#endif

#ifdef MONITOR
#define DAPTO_RESULTVisRelationLabelPtrList(l) DAPTO_RESULT_PTR(l)
#define DAPTO_ARGVisRelationLabelPtrList(l)    DAPTO_ARG_PTR (l, VisRelationLabelPtrList)
#endif

#endif
