

#include "VisRelationTypePtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisRelationTypePtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisRelationTypePtrList (void)
#else
void FinlVisRelationTypePtrList ()
#endif
{
    if (VisRelationTypePtrListSpace != (DynP)0)
    {  obstack_free(&(VisRelationTypePtrListSpace->space), VisRelationTypePtrListSpace->baseptr);
       VisRelationTypePtrListSpace->baseptr = obstack_alloc(&(VisRelationTypePtrListSpace->space), 0);
    }
}/* FinlVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList ConsVisRelationTypePtrList (VisRelationTypePtr e, VisRelationTypePtrList l)
#else
VisRelationTypePtrList ConsVisRelationTypePtrList (e, l)
        VisRelationTypePtr      e;
        VisRelationTypePtrList  l;
#endif
{
    VisRelationTypePtrList      h;

    if (VisRelationTypePtrListSpace == (DynP)0)
    {   VisRelationTypePtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisRelationTypePtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisRelationTypePtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisRelationTypePtrListSpace->space));
        VisRelationTypePtrListSpace->baseptr =
                obstack_alloc(&(VisRelationTypePtrListSpace->space), 0);
    }

    h = (VisRelationTypePtrList)obstack_alloc(&(VisRelationTypePtrListSpace->space),
                                  sizeof (struct _VisRelationTypePtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtr HeadVisRelationTypePtrList (VisRelationTypePtrList l)
#else
VisRelationTypePtr HeadVisRelationTypePtrList (l)
        VisRelationTypePtrList  l;
#endif
{
    if (l == NULLVisRelationTypePtrList)
    {
        message (DEADLY, "HeadVisRelationTypePtrList: empty list", 0, (POSITION*)0);
        /* return ((VisRelationTypePtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList TailVisRelationTypePtrList (VisRelationTypePtrList l)
#else
VisRelationTypePtrList TailVisRelationTypePtrList (l)
        VisRelationTypePtrList  l;
#endif
{
    return ((l==NULLVisRelationTypePtrList) ? NULLVisRelationTypePtrList : l->tail);
}/* TailVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisRelationTypePtrList (VisRelationTypePtrList l)
#else
int LengthVisRelationTypePtrList (l)
        VisRelationTypePtrList  l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtr IthElemVisRelationTypePtrList (VisRelationTypePtrList l, int i)
#else
VisRelationTypePtr IthElemVisRelationTypePtrList (l, i)
        VisRelationTypePtrList  l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisRelationTypePtrList))
        message (DEADLY, "IthElemVisRelationTypePtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisRelationTypePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList CopyVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtrMapFct cp)
#else
VisRelationTypePtrList CopyVisRelationTypePtrList (l, cp)
        VisRelationTypePtrList l;
        VisRelationTypePtrMapFct        cp;
#endif
{
    VisRelationTypePtrList NewList=NULLVisRelationTypePtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisRelationTypePtrList (cp (l->head), NULLVisRelationTypePtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList AppVisRelationTypePtrList (VisRelationTypePtrList l1, VisRelationTypePtrList l2)
#else
VisRelationTypePtrList AppVisRelationTypePtrList (l1, l2)
        VisRelationTypePtrList  l1, l2;
#endif
{
    VisRelationTypePtrList      NewList;
    VisRelationTypePtrList      *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisRelationTypePtrList (l1->head, NULLVisRelationTypePtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList AppElVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtr e)
#else
VisRelationTypePtrList AppElVisRelationTypePtrList (l, e)
        VisRelationTypePtrList  l;
        VisRelationTypePtr      e;
#endif
{
    VisRelationTypePtrList      res = l;
    if (!l)
        return (ConsVisRelationTypePtrList (e, NULLVisRelationTypePtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisRelationTypePtrList (e, NULLVisRelationTypePtrList);

    return (res);
} /* AppElVisRelationTypePtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtr e)
#else
void InsertAfterVisRelationTypePtrList (l, e)
        VisRelationTypePtrList  l;
        VisRelationTypePtr      e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisRelationTypePtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisRelationTypePtrList (e, l->tail);
}/* InsertAfterVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList OrderedInsertVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtr e, VisRelationTypePtrCmpFctType fcmp)
#else
VisRelationTypePtrList OrderedInsertVisRelationTypePtrList (l, e, fcmp)
        VisRelationTypePtrList  l;
        VisRelationTypePtr      e;
        VisRelationTypePtrCmpFctType fcmp;
#endif
{
    VisRelationTypePtrList      p;
    if (!l)
        return (ConsVisRelationTypePtrList (e, NULLVisRelationTypePtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisRelationTypePtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisRelationTypePtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrListPtr RefEndConsVisRelationTypePtrList (VisRelationTypePtrListPtr addr, VisRelationTypePtr e)
#else
VisRelationTypePtrListPtr RefEndConsVisRelationTypePtrList (addr, e)
        VisRelationTypePtrListPtr       addr;
        VisRelationTypePtr              e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisRelationTypePtrList: no VisRelationTypePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisRelationTypePtrList (e, NULLVisRelationTypePtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrListPtr RefEndAppVisRelationTypePtrList (VisRelationTypePtrListPtr addr, VisRelationTypePtrList l)
#else
VisRelationTypePtrListPtr RefEndAppVisRelationTypePtrList (addr, l)
        VisRelationTypePtrListPtr       addr;
        VisRelationTypePtrList          l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisRelationTypePtrList: no VisRelationTypePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisRelationTypePtrList (VisRelationTypePtr e, VisRelationTypePtrList l, VisRelationTypePtrCmpFctType fcmp)
#else
int ElemInVisRelationTypePtrList (e, l, fcmp)
        VisRelationTypePtr      e;
        VisRelationTypePtrList  l;
        VisRelationTypePtrCmpFctType    fcmp;
#endif
{
    while (l != NULLVisRelationTypePtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList AddToSetVisRelationTypePtrList (VisRelationTypePtr e, VisRelationTypePtrList l, VisRelationTypePtrCmpFctType fcmp)
#else
VisRelationTypePtrList AddToSetVisRelationTypePtrList (e, l, fcmp)
        VisRelationTypePtr      e;
        VisRelationTypePtrList  l;
        VisRelationTypePtrCmpFctType    fcmp;
#endif
{
    if (ElemInVisRelationTypePtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisRelationTypePtrList (e, l));
}/* AddToSetVisRelationTypePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList AddToOrderedSetVisRelationTypePtrList (VisRelationTypePtr e, VisRelationTypePtrList l, VisRelationTypePtrCmpFctType fcmp)
#else
VisRelationTypePtrList AddToOrderedSetVisRelationTypePtrList (e, l, fcmp)
        VisRelationTypePtr  e;
        VisRelationTypePtrList      l;
        VisRelationTypePtrCmpFctType fcmp;
#endif
{   int test;
    VisRelationTypePtrList  p;
    if (!l)
        return (ConsVisRelationTypePtrList (e, NULLVisRelationTypePtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisRelationTypePtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisRelationTypePtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtrList MapVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtrMapFct f)
#else
VisRelationTypePtrList MapVisRelationTypePtrList (l, f)
        VisRelationTypePtrList  l;
        VisRelationTypePtrMapFct f;
#endif
{
    VisRelationTypePtrList NewList = NULLVisRelationTypePtrList;
    VisRelationTypePtrList last = NULLVisRelationTypePtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisRelationTypePtrList ((f (l->head)), NULLVisRelationTypePtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisRelationTypePtrList ((f (l->head)), NULLVisRelationTypePtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisRelationTypePtrList (VisRelationTypePtrList l1, VisRelationTypePtrList l2, VisRelationTypePtrCmpFctType fcmp)
#else
int CompVisRelationTypePtrList (l1, l2, fcmp)
        VisRelationTypePtrList  l1, l2;
        VisRelationTypePtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisRelationTypePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypePtr SumVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtrSumFct f, VisRelationTypePtr a)
#else
VisRelationTypePtr SumVisRelationTypePtrList (l, f, a)
        VisRelationTypePtrList  l;
        VisRelationTypePtr ((*f) ());
        VisRelationTypePtr      a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisRelationTypePtrList */
