
#ifndef _VisRelationTypePtrLIST_H
#define _VisRelationTypePtrLIST_H

/* include header file defining VisRelationTypePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

#include "VisRelationTypePtrFunctionTypes.h"

typedef struct _VisRelationTypePtrLE *VisRelationTypePtrList;
typedef VisRelationTypePtrList    *VisRelationTypePtrListPtr;

struct _VisRelationTypePtrLE {
VisRelationTypePtr              head;
VisRelationTypePtrList  tail;
};

#define NULLVisRelationTypePtrList              ((VisRelationTypePtrList)0)
#define NullVisRelationTypePtrList()    ((VisRelationTypePtrList)0)
#define SingleVisRelationTypePtrList(e) (ConsVisRelationTypePtrList((e),NULLVisRelationTypePtrList))

#if defined(__STDC__) || defined(__cplusplus)

extern void FinlVisRelationTypePtrList(void);
   /* Deallocates all VisRelationTypePtrLists. */
   /* Dynamic storage is allocated on first need */

extern VisRelationTypePtrList ConsVisRelationTypePtrList (VisRelationTypePtr e, VisRelationTypePtrList l);
   /* Constructs a VisRelationTypePtrList of an element e and a given tail l.
    * e is the first element of the list. */

extern VisRelationTypePtr HeadVisRelationTypePtrList (VisRelationTypePtrList l);
   /* Returns the first element of the list l.
    * The list l must not be empty. */

extern VisRelationTypePtrList TailVisRelationTypePtrList (VisRelationTypePtrList l);
   /* Returns the tail of the list l.
    * If l is empty, an empty list is returned. */

extern int LengthVisRelationTypePtrList (VisRelationTypePtrList l);
   /* Returns the number of elements in the list l. */

extern VisRelationTypePtr IthElemVisRelationTypePtrList (VisRelationTypePtrList l, int i);
   /* Returns the i-th element of the List l. The head of l
    * is referred to as 1. If the value of
    * i is greater than the length of the list, an error
    * is reported and the program exits.
    */

extern VisRelationTypePtrList CopyVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtrMapFct cp);
   /* Copies the list l. Elements are copied by calls of cp. */

extern VisRelationTypePtrList AppVisRelationTypePtrList (VisRelationTypePtrList l1, VisRelationTypePtrList l2);
   /* Concatenates two lists l1 and l2. The resulting list contains l2 at
    * the end of a copy of list l1. */

extern VisRelationTypePtrList AppElVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtr e);
   /* Appends an element e to the list l.
    * The list l is not copied, it is modified as a side-effect
    * of this function. */

extern void InsertAfterVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtr e);
   /* This function requires a non-empty list l. The element e is inserted
    * just after the first element of l. 
    * The list l is modified as a side-effect of this function. */

extern VisRelationTypePtrList OrderedInsertVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtr e, VisRelationTypePtrCmpFctType fcmp);
   /* Inserts the element e into the list l maintaining l in
    * ascending order with respect to the compare fcmp. 
    * The list l is modified as a side-effect of this function. */

extern VisRelationTypePtrListPtr RefEndConsVisRelationTypePtrList (VisRelationTypePtrListPtr addr, VisRelationTypePtr e);
   /* Appends an element e to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern VisRelationTypePtrListPtr RefEndAppVisRelationTypePtrList (VisRelationTypePtrListPtr addr, VisRelationTypePtrList l);
   /* Appends a list l to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern int ElemInVisRelationTypePtrList (VisRelationTypePtr e, VisRelationTypePtrList l, VisRelationTypePtrCmpFctType cmpfct);
   /* This function returns true (1) iff the element e is in the List l.
    * List elements are compared by the function cmpfct. */

extern VisRelationTypePtrList AddToSetVisRelationTypePtrList (VisRelationTypePtr e, VisRelationTypePtrList l, VisRelationTypePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. */

extern VisRelationTypePtrList AddToOrderedSetVisRelationTypePtrList 
       (VisRelationTypePtr e, VisRelationTypePtrList l, VisRelationTypePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. l is assumed to be ordered increasingly in the sense of
    * cmpfct. */

extern VisRelationTypePtrList MapVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtrMapFct f);
   /* Returns a new VisRelationTypePtrList obtained by applying f to each element of l. */

extern int CompVisRelationTypePtrList (VisRelationTypePtrList l1, VisRelationTypePtrList l2, VisRelationTypePtrCmpFctType f);
   /* Compares the lists l1 and l2 lexicographically by applying f
    * to the corresponding elements. */

extern VisRelationTypePtr SumVisRelationTypePtrList (VisRelationTypePtrList l, VisRelationTypePtrSumFct f, VisRelationTypePtr a);
   /* Applies the binary function f to the elements of the List:
    *   f( f(... f(a, e1), e2, ...), en)
    * If l is empty a is returned. */

#else

extern void FinlVisRelationTypePtrList ();
extern VisRelationTypePtrList ConsVisRelationTypePtrList ();
extern VisRelationTypePtr HeadVisRelationTypePtrList ();
extern VisRelationTypePtrList TailVisRelationTypePtrList ();
extern int LengthVisRelationTypePtrList ();
extern VisRelationTypePtr IthElemVisRelationTypePtrList ();
extern VisRelationTypePtrList CopyVisRelationTypePtrList ();
extern VisRelationTypePtrList AppVisRelationTypePtrList ();
extern VisRelationTypePtrList AppElVisRelationTypePtrList ();
extern void InsertAfterVisRelationTypePtrList ();
extern VisRelationTypePtrList OrderedInsertVisRelationTypePtrList ();
extern VisRelationTypePtrListPtr RefEndConsVisRelationTypePtrList ();
extern VisRelationTypePtrListPtr RefEndAppVisRelationTypePtrList ();
extern int ElemInVisRelationTypePtrList ();
extern VisRelationTypePtrList AddToSetVisRelationTypePtrList ();
extern VisRelationTypePtrList MapVisRelationTypePtrList ();
extern int CompVisRelationTypePtrList ();
extern VisRelationTypePtr SumVisRelationTypePtrList ();

#endif

#ifdef MONITOR
#define DAPTO_RESULTVisRelationTypePtrList(l) DAPTO_RESULT_PTR(l)
#define DAPTO_ARGVisRelationTypePtrList(l)    DAPTO_ARG_PTR (l, VisRelationTypePtrList)
#endif

#endif
