

#include "VisRelationTypeReferencePtrList.h"
#include "err.h"
#include "obstack.h"

typedef struct {
  Obstack space;
  void *baseptr;
} Dyn, *DynP;

static DynP VisRelationTypeReferencePtrListSpace = (DynP)0;

#if defined(__STDC__) || defined(__cplusplus)
void FinlVisRelationTypeReferencePtrList (void)
#else
void FinlVisRelationTypeReferencePtrList ()
#endif
{
    if (VisRelationTypeReferencePtrListSpace != (DynP)0)
    {  obstack_free(&(VisRelationTypeReferencePtrListSpace->space), VisRelationTypeReferencePtrListSpace->baseptr);
       VisRelationTypeReferencePtrListSpace->baseptr = obstack_alloc(&(VisRelationTypeReferencePtrListSpace->space), 0);
    }
}/* FinlVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList ConsVisRelationTypeReferencePtrList (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l)
#else
VisRelationTypeReferencePtrList ConsVisRelationTypeReferencePtrList (e, l)
        VisRelationTypeReferencePtr     e;
        VisRelationTypeReferencePtrList l;
#endif
{
    VisRelationTypeReferencePtrList     h;

    if (VisRelationTypeReferencePtrListSpace == (DynP)0)
    {   VisRelationTypeReferencePtrListSpace = (DynP) malloc (sizeof(Dyn));
        if (VisRelationTypeReferencePtrListSpace == (DynP)0)
        {  message (DEADLY, "no space for VisRelationTypeReferencePtrList", 0, (POSITION*)0);
           exit (1);
        }
        obstack_init(&(VisRelationTypeReferencePtrListSpace->space));
        VisRelationTypeReferencePtrListSpace->baseptr =
                obstack_alloc(&(VisRelationTypeReferencePtrListSpace->space), 0);
    }

    h = (VisRelationTypeReferencePtrList)obstack_alloc(&(VisRelationTypeReferencePtrListSpace->space),
                                  sizeof (struct _VisRelationTypeReferencePtrLE));
    h->head = e;
    h->tail= l;
    return (h);
}/* ConsVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtr HeadVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l)
#else
VisRelationTypeReferencePtr HeadVisRelationTypeReferencePtrList (l)
        VisRelationTypeReferencePtrList l;
#endif
{
    if (l == NULLVisRelationTypeReferencePtrList)
    {
        message (DEADLY, "HeadVisRelationTypeReferencePtrList: empty list", 0, (POSITION*)0);
        /* return ((VisRelationTypeReferencePtr)0); */
    } /* if */
    return (l->head);
}/* HeadVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList TailVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l)
#else
VisRelationTypeReferencePtrList TailVisRelationTypeReferencePtrList (l)
        VisRelationTypeReferencePtrList l;
#endif
{
    return ((l==NULLVisRelationTypeReferencePtrList) ? NULLVisRelationTypeReferencePtrList : l->tail);
}/* TailVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int LengthVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l)
#else
int LengthVisRelationTypeReferencePtrList (l)
        VisRelationTypeReferencePtrList l;
#endif
{
    int res = 0;

    for (; l; l = l->tail)
        res++;
    return (res);
}/* LengthVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtr IthElemVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, int i)
#else
VisRelationTypeReferencePtr IthElemVisRelationTypeReferencePtrList (l, i)
        VisRelationTypeReferencePtrList l;
        int     i;
#endif
{
    while ((i>1) && l)
    {
        i--;
        l = l->tail;
    }

    if ((i<=0) || (l==NULLVisRelationTypeReferencePtrList))
        message (DEADLY, "IthElemVisRelationTypeReferencePtrList: no such element",
                 0, (POSITION*)0);
    return (l->head);
}/* IthVisRelationTypeReferencePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList CopyVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrMapFct cp)
#else
VisRelationTypeReferencePtrList CopyVisRelationTypeReferencePtrList (l, cp)
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtrMapFct       cp;
#endif
{
    VisRelationTypeReferencePtrList NewList=NULLVisRelationTypeReferencePtrList, *addr = &NewList;

    while (l)
    {
        (*addr) = ConsVisRelationTypeReferencePtrList (cp (l->head), NULLVisRelationTypeReferencePtrList);
        addr = &((*addr)->tail);
        l = l->tail;
    }
    return (NewList);
}/* CopyVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList AppVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l1, VisRelationTypeReferencePtrList l2)
#else
VisRelationTypeReferencePtrList AppVisRelationTypeReferencePtrList (l1, l2)
        VisRelationTypeReferencePtrList l1, l2;
#endif
{
    VisRelationTypeReferencePtrList     NewList;
    VisRelationTypeReferencePtrList     *addr = &NewList;

    if (!l1) return (l2);
    if (!l2) return (l1);

    while (l1) {
        (*addr) = ConsVisRelationTypeReferencePtrList (l1->head, NULLVisRelationTypeReferencePtrList);
        addr = &((*addr)->tail);
        l1 = l1->tail;
    }
    (*addr) = l2;

    return (NewList);
}/* AppVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList AppElVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtr e)
#else
VisRelationTypeReferencePtrList AppElVisRelationTypeReferencePtrList (l, e)
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtr     e;
#endif
{
    VisRelationTypeReferencePtrList     res = l;
    if (!l)
        return (ConsVisRelationTypeReferencePtrList (e, NULLVisRelationTypeReferencePtrList));

    while (l->tail)
        l = l->tail;
    l->tail = ConsVisRelationTypeReferencePtrList (e, NULLVisRelationTypeReferencePtrList);

    return (res);
} /* AppElVisRelationTypeReferencePtrList */


#if defined(__STDC__) || defined(__cplusplus)
void InsertAfterVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtr e)
#else
void InsertAfterVisRelationTypeReferencePtrList (l, e)
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtr     e;
#endif
{
    if (!l)
        message (DEADLY, "InserAfterVisRelationTypeReferencePtrList: null list", 0, (POSITION*)0);
    else
        l->tail = ConsVisRelationTypeReferencePtrList (e, l->tail);
}/* InsertAfterVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList OrderedInsertVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrCmpFctType fcmp)
#else
VisRelationTypeReferencePtrList OrderedInsertVisRelationTypeReferencePtrList (l, e, fcmp)
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtr     e;
        VisRelationTypeReferencePtrCmpFctType fcmp;
#endif
{
    VisRelationTypeReferencePtrList     p;
    if (!l)
        return (ConsVisRelationTypeReferencePtrList (e, NULLVisRelationTypeReferencePtrList));
    if (fcmp (e, l->head) <= 0)
        return (ConsVisRelationTypeReferencePtrList (e, l));
    p = l;
    while (p->tail && (fcmp (e, p->tail->head) > 0))
        p = p->tail;
    p->tail = ConsVisRelationTypeReferencePtrList (e, p->tail);
    return (l);
}/* OrderedInsertVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrListPtr RefEndConsVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrListPtr addr, VisRelationTypeReferencePtr e)
#else
VisRelationTypeReferencePtrListPtr RefEndConsVisRelationTypeReferencePtrList (addr, e)
        VisRelationTypeReferencePtrListPtr      addr;
        VisRelationTypeReferencePtr             e;
#endif
{
    if (!addr)
    {
        message (DEADLY, "RefEndConsVisRelationTypeReferencePtrList: no VisRelationTypeReferencePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    (*addr) = ConsVisRelationTypeReferencePtrList (e, NULLVisRelationTypeReferencePtrList);
    return (&((*addr)->tail));
}/* RefEndConsVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrListPtr RefEndAppVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrListPtr addr, VisRelationTypeReferencePtrList l)
#else
VisRelationTypeReferencePtrListPtr RefEndAppVisRelationTypeReferencePtrList (addr, l)
        VisRelationTypeReferencePtrListPtr      addr;
        VisRelationTypeReferencePtrList         l;
#endif
{
    if (!addr) {
        message (DEADLY, "RefEndAppVisRelationTypeReferencePtrList: no VisRelationTypeReferencePtrList ref",
                 0, (POSITION*)0);
        return (addr);
    }
    if (!l)
        return addr;

    (*addr) = l;

    while (l->tail)
        l = l->tail;
    return (&(l->tail));
}/* RefEndAppVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int ElemInVisRelationTypeReferencePtrList (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrCmpFctType fcmp)
#else
int ElemInVisRelationTypeReferencePtrList (e, l, fcmp)
        VisRelationTypeReferencePtr     e;
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtrCmpFctType   fcmp;
#endif
{
    while (l != NULLVisRelationTypeReferencePtrList) {
        if (fcmp (e, l->head) == 0)
            return (1);
        l = l->tail;
    }
    return (0);
}/* ElemInVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList AddToSetVisRelationTypeReferencePtrList (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrCmpFctType fcmp)
#else
VisRelationTypeReferencePtrList AddToSetVisRelationTypeReferencePtrList (e, l, fcmp)
        VisRelationTypeReferencePtr     e;
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtrCmpFctType   fcmp;
#endif
{
    if (ElemInVisRelationTypeReferencePtrList (e, l, fcmp))
        return (l);
    else
        return (ConsVisRelationTypeReferencePtrList (e, l));
}/* AddToSetVisRelationTypeReferencePtrList */


#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList AddToOrderedSetVisRelationTypeReferencePtrList (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrCmpFctType fcmp)
#else
VisRelationTypeReferencePtrList AddToOrderedSetVisRelationTypeReferencePtrList (e, l, fcmp)
        VisRelationTypeReferencePtr  e;
        VisRelationTypeReferencePtrList      l;
        VisRelationTypeReferencePtrCmpFctType fcmp;
#endif
{   int test;
    VisRelationTypeReferencePtrList  p;
    if (!l)
        return (ConsVisRelationTypeReferencePtrList (e, NULLVisRelationTypeReferencePtrList));
    if ((test = fcmp (e, l->head)) < 0)
        return (ConsVisRelationTypeReferencePtrList (e, l));
    if (test == 0) return l;
    p = l;
    while (p->tail && ((test = fcmp (e, p->tail->head)) > 0))
        p = p->tail;
    if (test) p->tail = ConsVisRelationTypeReferencePtrList (e, p->tail);
    return (l);
}/* AddToOrderedSetVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtrList MapVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrMapFct f)
#else
VisRelationTypeReferencePtrList MapVisRelationTypeReferencePtrList (l, f)
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtrMapFct f;
#endif
{
    VisRelationTypeReferencePtrList NewList = NULLVisRelationTypeReferencePtrList;
    VisRelationTypeReferencePtrList last = NULLVisRelationTypeReferencePtrList;

    while (l)
    {
        if (!NewList) {
            NewList = ConsVisRelationTypeReferencePtrList ((f (l->head)), NULLVisRelationTypeReferencePtrList);
            last = NewList;
        }
        else
        {
            last->tail = ConsVisRelationTypeReferencePtrList ((f (l->head)), NULLVisRelationTypeReferencePtrList);
            last = last->tail;
        }
        l = l->tail;
    }
    return (NewList);
}/* MapVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
int CompVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l1, VisRelationTypeReferencePtrList l2, VisRelationTypeReferencePtrCmpFctType fcmp)
#else
int CompVisRelationTypeReferencePtrList (l1, l2, fcmp)
        VisRelationTypeReferencePtrList l1, l2;
        VisRelationTypeReferencePtrCmpFctType fcmp;
#endif
{
    int res = 0;
    while (l1 && l2 && (res == 0)) {
        res = (fcmp (l1->head, l2->head));
        l1 = l1->tail;
        l2 = l2->tail;
    }
    if (l1 && !l2)
        return (1);
    if (!l1 && l2)
        return (-1);
    return (res);
}/* CompVisRelationTypeReferencePtrList */

#if defined(__STDC__) || defined(__cplusplus)
VisRelationTypeReferencePtr SumVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrSumFct f, VisRelationTypeReferencePtr a)
#else
VisRelationTypeReferencePtr SumVisRelationTypeReferencePtrList (l, f, a)
        VisRelationTypeReferencePtrList l;
        VisRelationTypeReferencePtr ((*f) ());
        VisRelationTypeReferencePtr     a;
#endif
{
    while (l) {
        a = (f (a, l->head));
        l = l->tail;
    }
    return (a);
}/* SumVisRelationTypeReferencePtrList */
