
#ifndef _VisRelationTypeReferencePtrLIST_H
#define _VisRelationTypeReferencePtrLIST_H

/* include header file defining VisRelationTypeReferencePtr if VisBasicCode is set: */
#define EMPTYVisBasicCodeHDR
#ifndef EMPTYHDR
#include "VisBasicCode.h"
#endif
#undef EMPTYVisBasicCodeHDR

#include "VisRelationTypeReferencePtrFunctionTypes.h"

typedef struct _VisRelationTypeReferencePtrLE *VisRelationTypeReferencePtrList;
typedef VisRelationTypeReferencePtrList    *VisRelationTypeReferencePtrListPtr;

struct _VisRelationTypeReferencePtrLE {
VisRelationTypeReferencePtr             head;
VisRelationTypeReferencePtrList tail;
};

#define NULLVisRelationTypeReferencePtrList             ((VisRelationTypeReferencePtrList)0)
#define NullVisRelationTypeReferencePtrList()   ((VisRelationTypeReferencePtrList)0)
#define SingleVisRelationTypeReferencePtrList(e)        (ConsVisRelationTypeReferencePtrList((e),NULLVisRelationTypeReferencePtrList))

#if defined(__STDC__) || defined(__cplusplus)

extern void FinlVisRelationTypeReferencePtrList(void);
   /* Deallocates all VisRelationTypeReferencePtrLists. */
   /* Dynamic storage is allocated on first need */

extern VisRelationTypeReferencePtrList ConsVisRelationTypeReferencePtrList (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l);
   /* Constructs a VisRelationTypeReferencePtrList of an element e and a given tail l.
    * e is the first element of the list. */

extern VisRelationTypeReferencePtr HeadVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l);
   /* Returns the first element of the list l.
    * The list l must not be empty. */

extern VisRelationTypeReferencePtrList TailVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l);
   /* Returns the tail of the list l.
    * If l is empty, an empty list is returned. */

extern int LengthVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l);
   /* Returns the number of elements in the list l. */

extern VisRelationTypeReferencePtr IthElemVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, int i);
   /* Returns the i-th element of the List l. The head of l
    * is referred to as 1. If the value of
    * i is greater than the length of the list, an error
    * is reported and the program exits.
    */

extern VisRelationTypeReferencePtrList CopyVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrMapFct cp);
   /* Copies the list l. Elements are copied by calls of cp. */

extern VisRelationTypeReferencePtrList AppVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l1, VisRelationTypeReferencePtrList l2);
   /* Concatenates two lists l1 and l2. The resulting list contains l2 at
    * the end of a copy of list l1. */

extern VisRelationTypeReferencePtrList AppElVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtr e);
   /* Appends an element e to the list l.
    * The list l is not copied, it is modified as a side-effect
    * of this function. */

extern void InsertAfterVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtr e);
   /* This function requires a non-empty list l. The element e is inserted
    * just after the first element of l. 
    * The list l is modified as a side-effect of this function. */

extern VisRelationTypeReferencePtrList OrderedInsertVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrCmpFctType fcmp);
   /* Inserts the element e into the list l maintaining l in
    * ascending order with respect to the compare fcmp. 
    * The list l is modified as a side-effect of this function. */

extern VisRelationTypeReferencePtrListPtr RefEndConsVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrListPtr addr, VisRelationTypeReferencePtr e);
   /* Appends an element e to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern VisRelationTypeReferencePtrListPtr RefEndAppVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrListPtr addr, VisRelationTypeReferencePtrList l);
   /* Appends a list l to the end of a list given by its address addr.
    * The address where the next element may be appended is returned.
    * The list is modified as a side-effect of this function. */

extern int ElemInVisRelationTypeReferencePtrList (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrCmpFctType cmpfct);
   /* This function returns true (1) iff the element e is in the List l.
    * List elements are compared by the function cmpfct. */

extern VisRelationTypeReferencePtrList AddToSetVisRelationTypeReferencePtrList (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. */

extern VisRelationTypeReferencePtrList AddToOrderedSetVisRelationTypeReferencePtrList 
       (VisRelationTypeReferencePtr e, VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrCmpFctType cmpfct);
   /* A list is returned that has e as an element.
    * l is checked whether it already contains e using the compare
    * function cmpfct. l is assumed to be ordered increasingly in the sense of
    * cmpfct. */

extern VisRelationTypeReferencePtrList MapVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrMapFct f);
   /* Returns a new VisRelationTypeReferencePtrList obtained by applying f to each element of l. */

extern int CompVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l1, VisRelationTypeReferencePtrList l2, VisRelationTypeReferencePtrCmpFctType f);
   /* Compares the lists l1 and l2 lexicographically by applying f
    * to the corresponding elements. */

extern VisRelationTypeReferencePtr SumVisRelationTypeReferencePtrList (VisRelationTypeReferencePtrList l, VisRelationTypeReferencePtrSumFct f, VisRelationTypeReferencePtr a);
   /* Applies the binary function f to the elements of the List:
    *   f( f(... f(a, e1), e2, ...), en)
    * If l is empty a is returned. */

#else

extern void FinlVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList ConsVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtr HeadVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList TailVisRelationTypeReferencePtrList ();
extern int LengthVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtr IthElemVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList CopyVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList AppVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList AppElVisRelationTypeReferencePtrList ();
extern void InsertAfterVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList OrderedInsertVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrListPtr RefEndConsVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrListPtr RefEndAppVisRelationTypeReferencePtrList ();
extern int ElemInVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList AddToSetVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtrList MapVisRelationTypeReferencePtrList ();
extern int CompVisRelationTypeReferencePtrList ();
extern VisRelationTypeReferencePtr SumVisRelationTypeReferencePtrList ();

#endif

#ifdef MONITOR
#define DAPTO_RESULTVisRelationTypeReferencePtrList(l) DAPTO_RESULT_PTR(l)
#define DAPTO_ARGVisRelationTypeReferencePtrList(l)    DAPTO_ARG_PTR (l, VisRelationTypeReferencePtrList)
#endif

#endif
