namespace eval ::font {
    variable fontlist {}
    variable fontheights {}
    variable fontlabel {}
}

proc ::font::init {} {
    new "default"       "Defaultfont" "-family Helvetica -size 12"
    new "defaultItalic" "Defaultfont2" "-family Helvetica -size 12 -slant italic"
    new "defaultBold"   "Defaultfont3" "-family Helvetica -size 12 -weight bold"
    new "fixed"         "Sourcecodefont" "-family Courier -size 12"
    new "fixedItalic"   "Sourcecodefont2" "-family Courier -size 12 -slant italic"
    new "fixedBold"     "Sourcecodefont3" "-family Courier -size 12 -weight bold"
}

proc ::font::new {fontname fontlabel fontspec} {
    eval {font create $fontname} $fontspec
    set height [expr [font metrics $fontname -ascent] + [font metrics $fontname -descent]]

    lappend ::font::fontlist $fontname
    lappend ::font::fontheights $height
    lappend ::font::fontlabel $fontlabel
}

proc ::font::measure {fontname text} {
    set ind [lsearch -exact $::font::fontlist $fontname]
    if {$ind < 0} {
	error "Bad font name $fontname"
    }

    set maxwidth -1
    set lines 0
    set height [lindex $::font::fontheights $ind]
    foreach line [split $text "\n"] {
	set width [expr [font measure $fontname $line] + 2]
	if {$maxwidth < $width} {set maxwidth $width}
	incr lines
    }
	
    return [list $maxwidth [expr $lines * $height]]
}
