# ----------------------------------------------------------------------
# Module Dialog
# ----------------------------------------------------------------------
# Code for Dialog procedures to edit attributes of nodes
# This module is generated. ** DO NOT EDIT **

namespace eval ::dialog {
variable curr_id ""
}

proc ::dialog::editStatechart {id args} {
	variable dlgdata
	variable dlgfields
	variable curr_id
	if {[array exists dlgdata]} {
		set dlgdata_contents [array get dlgdata]
		unset dlgdata
	}
	if {[array exists dlgfields]} {
		set dlgfields_contents [array get dlgfields]
		unset dlgfields
	}

	set selfocus ""
	foreach {opt val} $args {
		switch -- $opt {
			 -selectattr {set selfocus $val}
		}
	}

	# Assign Attribute values to global variable dlgdata

	array set attrs [::vl::getAttrs $id]
	set dlgdata(persName) $attrs(persName)
	set dlgdata(persName,values) ""
	set title "Edit Statechart Properties"

	# Set current edited node context
	set curr_id $id
	::vl::run dlg [::vl::getRoot $id] 0

	# Post-Process Attribute values

	# Create Dialog
	set win [::CDlg::Create editStatechart $title]
	set info [::CDlg::Info $win]
	set controls [::CDlg::Controls $win]

	# Fill in control buttons first. 
	# If anything goes wrong, the window can be dismissed

	button $controls.ok -text "Ok" -command [format {
		if {[::dialog::_editStatechart_ok %s]} {
			grab release %s
			destroy %s
		}} $id $win $win]
	button $controls.cancel -text "Cancel" -command [format {
		grab release %s
		destroy %s
	} $win $win]
	pack $controls.ok $controls.cancel -side left -expand true

	# Compute Maximum Label Width
	set width 0
	foreach label [list \
		"persName"] {
		set lwidth [expr [string length $label] + 2]
		if {$width < $lwidth} { set width $lwidth }
	}
	# Now fill in the information editors
	set focus ""

	set attr "persName"
	set label "persName"
	set thisname "$info.ed$attr"
	set args "-variable ::dialog::dlgdata($attr)"
	set dlgfields($attr) [eval {::CDlg::EditEntryH $thisname \
		$label $width} $args]
	if {"$selfocus" == "$attr" || $focus == ""} {
		set focus $dlgfields($attr)
	}
	# Position the window on the screen and wait for user interaction
	::CDlg::Center $win
	::CDlg::Wait $win $focus

	# Restore dlgdata and dlgfields contents to old values
	unset dlgdata
	unset dlgfields
	if {[info exists dlgdata_contents]} {
		array set dlgdata $dlgdata_contents
	}
	if {[info exists dlgfields_contents]} {
		array set dlgfields $dlgfields_contents
	}
}

proc ::dialog::_editStatechart_ok {id} {
	variable dlgdata
	variable dlgfields
	set ok 1

	if {! $ok} {
		return 0
	}
	# Store Values

	array set attrs [::vl::getAttrs $id]
	if {$dlgdata(persName) != $attrs(persName)} {
		set new_attrs(persName) $dlgdata(persName)
	}
	if {[array exists new_attrs]} {
		::vl::setAttrs $id [array get new_attrs]
	}
	return 1
}

proc ::dialog::editSimpleState {id args} {
	variable dlgdata
	variable dlgfields
	variable curr_id
	if {[array exists dlgdata]} {
		set dlgdata_contents [array get dlgdata]
		unset dlgdata
	}
	if {[array exists dlgfields]} {
		set dlgfields_contents [array get dlgfields]
		unset dlgfields
	}

	set selfocus ""
	foreach {opt val} $args {
		switch -- $opt {
			 -selectattr {set selfocus $val}
		}
	}

	# Assign Attribute values to global variable dlgdata

	array set attrs [::vl::getAttrs $id]
	set dlgdata(persName) $attrs(persName)
	set dlgdata(persName,values) ""
	set title "Edit SimpleState Properties"

	# Set current edited node context
	set curr_id $id
	::vl::run dlg [::vl::getRoot $id] 0

	# Post-Process Attribute values

	# Create Dialog
	set win [::CDlg::Create editSimpleState $title]
	set info [::CDlg::Info $win]
	set controls [::CDlg::Controls $win]

	# Fill in control buttons first. 
	# If anything goes wrong, the window can be dismissed

	button $controls.ok -text "Ok" -command [format {
		if {[::dialog::_editSimpleState_ok %s]} {
			grab release %s
			destroy %s
		}} $id $win $win]
	button $controls.cancel -text "Cancel" -command [format {
		grab release %s
		destroy %s
	} $win $win]
	pack $controls.ok $controls.cancel -side left -expand true

	# Compute Maximum Label Width
	set width 0
	foreach label [list \
		"persName"] {
		set lwidth [expr [string length $label] + 2]
		if {$width < $lwidth} { set width $lwidth }
	}
	# Now fill in the information editors
	set focus ""

	set attr "persName"
	set label "persName"
	set thisname "$info.ed$attr"
	set args "-variable ::dialog::dlgdata($attr)"
	set dlgfields($attr) [eval {::CDlg::EditEntryH $thisname \
		$label $width} $args]
	if {"$selfocus" == "$attr" || $focus == ""} {
		set focus $dlgfields($attr)
	}
	# Position the window on the screen and wait for user interaction
	::CDlg::Center $win
	::CDlg::Wait $win $focus

	# Restore dlgdata and dlgfields contents to old values
	unset dlgdata
	unset dlgfields
	if {[info exists dlgdata_contents]} {
		array set dlgdata $dlgdata_contents
	}
	if {[info exists dlgfields_contents]} {
		array set dlgfields $dlgfields_contents
	}
}

proc ::dialog::_editSimpleState_ok {id} {
	variable dlgdata
	variable dlgfields
	set ok 1

	if {! $ok} {
		return 0
	}
	# Store Values

	array set attrs [::vl::getAttrs $id]
	if {$dlgdata(persName) != $attrs(persName)} {
		set new_attrs(persName) $dlgdata(persName)
	}
	if {[array exists new_attrs]} {
		::vl::setAttrs $id [array get new_attrs]
	}
	return 1
}

proc ::dialog::editXORSuperstate {id args} {
	variable dlgdata
	variable dlgfields
	variable curr_id
	if {[array exists dlgdata]} {
		set dlgdata_contents [array get dlgdata]
		unset dlgdata
	}
	if {[array exists dlgfields]} {
		set dlgfields_contents [array get dlgfields]
		unset dlgfields
	}

	set selfocus ""
	foreach {opt val} $args {
		switch -- $opt {
			 -selectattr {set selfocus $val}
		}
	}

	# Assign Attribute values to global variable dlgdata

	array set attrs [::vl::getAttrs $id]
	set dlgdata(persName) $attrs(persName)
	set dlgdata(persName,values) ""
	set title "Edit XORSuperstate Properties"

	# Set current edited node context
	set curr_id $id
	::vl::run dlg [::vl::getRoot $id] 0

	# Post-Process Attribute values

	# Create Dialog
	set win [::CDlg::Create editXORSuperstate $title]
	set info [::CDlg::Info $win]
	set controls [::CDlg::Controls $win]

	# Fill in control buttons first. 
	# If anything goes wrong, the window can be dismissed

	button $controls.ok -text "Ok" -command [format {
		if {[::dialog::_editXORSuperstate_ok %s]} {
			grab release %s
			destroy %s
		}} $id $win $win]
	button $controls.cancel -text "Cancel" -command [format {
		grab release %s
		destroy %s
	} $win $win]
	pack $controls.ok $controls.cancel -side left -expand true

	# Compute Maximum Label Width
	set width 0
	foreach label [list \
		"persName"] {
		set lwidth [expr [string length $label] + 2]
		if {$width < $lwidth} { set width $lwidth }
	}
	# Now fill in the information editors
	set focus ""

	set attr "persName"
	set label "persName"
	set thisname "$info.ed$attr"
	set args "-variable ::dialog::dlgdata($attr)"
	set dlgfields($attr) [eval {::CDlg::EditEntryH $thisname \
		$label $width} $args]
	if {"$selfocus" == "$attr" || $focus == ""} {
		set focus $dlgfields($attr)
	}
	# Position the window on the screen and wait for user interaction
	::CDlg::Center $win
	::CDlg::Wait $win $focus

	# Restore dlgdata and dlgfields contents to old values
	unset dlgdata
	unset dlgfields
	if {[info exists dlgdata_contents]} {
		array set dlgdata $dlgdata_contents
	}
	if {[info exists dlgfields_contents]} {
		array set dlgfields $dlgfields_contents
	}
}

proc ::dialog::_editXORSuperstate_ok {id} {
	variable dlgdata
	variable dlgfields
	set ok 1

	if {! $ok} {
		return 0
	}
	# Store Values

	array set attrs [::vl::getAttrs $id]
	if {$dlgdata(persName) != $attrs(persName)} {
		set new_attrs(persName) $dlgdata(persName)
	}
	if {[array exists new_attrs]} {
		::vl::setAttrs $id [array get new_attrs]
	}
	return 1
}

proc ::dialog::editANDSuperstate {id args} {
	variable dlgdata
	variable dlgfields
	variable curr_id
	if {[array exists dlgdata]} {
		set dlgdata_contents [array get dlgdata]
		unset dlgdata
	}
	if {[array exists dlgfields]} {
		set dlgfields_contents [array get dlgfields]
		unset dlgfields
	}

	set selfocus ""
	foreach {opt val} $args {
		switch -- $opt {
			 -selectattr {set selfocus $val}
		}
	}

	# Assign Attribute values to global variable dlgdata

	array set attrs [::vl::getAttrs $id]
	set dlgdata(persName) $attrs(persName)
	set dlgdata(persName,values) ""
	set title "Edit ANDSuperstate Properties"

	# Set current edited node context
	set curr_id $id
	::vl::run dlg [::vl::getRoot $id] 0

	# Post-Process Attribute values

	# Create Dialog
	set win [::CDlg::Create editANDSuperstate $title]
	set info [::CDlg::Info $win]
	set controls [::CDlg::Controls $win]

	# Fill in control buttons first. 
	# If anything goes wrong, the window can be dismissed

	button $controls.ok -text "Ok" -command [format {
		if {[::dialog::_editANDSuperstate_ok %s]} {
			grab release %s
			destroy %s
		}} $id $win $win]
	button $controls.cancel -text "Cancel" -command [format {
		grab release %s
		destroy %s
	} $win $win]
	pack $controls.ok $controls.cancel -side left -expand true

	# Compute Maximum Label Width
	set width 0
	foreach label [list \
		"persName"] {
		set lwidth [expr [string length $label] + 2]
		if {$width < $lwidth} { set width $lwidth }
	}
	# Now fill in the information editors
	set focus ""

	set attr "persName"
	set label "persName"
	set thisname "$info.ed$attr"
	set args "-variable ::dialog::dlgdata($attr)"
	set dlgfields($attr) [eval {::CDlg::EditEntryH $thisname \
		$label $width} $args]
	if {"$selfocus" == "$attr" || $focus == ""} {
		set focus $dlgfields($attr)
	}
	# Position the window on the screen and wait for user interaction
	::CDlg::Center $win
	::CDlg::Wait $win $focus

	# Restore dlgdata and dlgfields contents to old values
	unset dlgdata
	unset dlgfields
	if {[info exists dlgdata_contents]} {
		array set dlgdata $dlgdata_contents
	}
	if {[info exists dlgfields_contents]} {
		array set dlgfields $dlgfields_contents
	}
}

proc ::dialog::_editANDSuperstate_ok {id} {
	variable dlgdata
	variable dlgfields
	set ok 1

	if {! $ok} {
		return 0
	}
	# Store Values

	array set attrs [::vl::getAttrs $id]
	if {$dlgdata(persName) != $attrs(persName)} {
		set new_attrs(persName) $dlgdata(persName)
	}
	if {[array exists new_attrs]} {
		::vl::setAttrs $id [array get new_attrs]
	}
	return 1
}

proc ::dialog::editTransition {id args} {
	variable dlgdata
	variable dlgfields
	variable curr_id
	if {[array exists dlgdata]} {
		set dlgdata_contents [array get dlgdata]
		unset dlgdata
	}
	if {[array exists dlgfields]} {
		set dlgfields_contents [array get dlgfields]
		unset dlgfields
	}

	set selfocus ""
	foreach {opt val} $args {
		switch -- $opt {
			 -selectattr {set selfocus $val}
		}
	}

	# Assign Attribute values to global variable dlgdata

	array set attrs [::vl::getAttrs $id]
	set dlgdata(persEvent) $attrs(persEvent)
	set dlgdata(persEvent,values) ""
	set title "Edit Transition Properties"

	# Set current edited node context
	set curr_id $id
	::vl::run dlg [::vl::getRoot $id] 0

	# Post-Process Attribute values

	# Create Dialog
	set win [::CDlg::Create editTransition $title]
	set info [::CDlg::Info $win]
	set controls [::CDlg::Controls $win]

	# Fill in control buttons first. 
	# If anything goes wrong, the window can be dismissed

	button $controls.ok -text "Ok" -command [format {
		if {[::dialog::_editTransition_ok %s]} {
			grab release %s
			destroy %s
		}} $id $win $win]
	button $controls.cancel -text "Cancel" -command [format {
		grab release %s
		destroy %s
	} $win $win]
	pack $controls.ok $controls.cancel -side left -expand true

	# Compute Maximum Label Width
	set width 0
	foreach label [list \
		"persEvent"] {
		set lwidth [expr [string length $label] + 2]
		if {$width < $lwidth} { set width $lwidth }
	}
	# Now fill in the information editors
	set focus ""

	set attr "persEvent"
	set label "persEvent"
	set thisname "$info.ed$attr"
	set args "-variable ::dialog::dlgdata($attr)"
	set dlgfields($attr) [eval {::CDlg::EditEntryH $thisname \
		$label $width} $args]
	if {"$selfocus" == "$attr" || $focus == ""} {
		set focus $dlgfields($attr)
	}
	# Position the window on the screen and wait for user interaction
	::CDlg::Center $win
	::CDlg::Wait $win $focus

	# Restore dlgdata and dlgfields contents to old values
	unset dlgdata
	unset dlgfields
	if {[info exists dlgdata_contents]} {
		array set dlgdata $dlgdata_contents
	}
	if {[info exists dlgfields_contents]} {
		array set dlgfields $dlgfields_contents
	}
}

proc ::dialog::_editTransition_ok {id} {
	variable dlgdata
	variable dlgfields
	set ok 1

	if {! $ok} {
		return 0
	}
	# Store Values

	array set attrs [::vl::getAttrs $id]
	if {$dlgdata(persEvent) != $attrs(persEvent)} {
		set new_attrs(persEvent) $dlgdata(persEvent)
	}
	if {[array exists new_attrs]} {
		::vl::setAttrs $id [array get new_attrs]
	}
	return 1
}

