#include "gen_treeio.h"
#include "nodecode.h"
#include "treecon.h"
#include "treeact.h"
#include "node.h"
#include "err.h"
#include "tcl_vpt.h"
#include "string.h"
#include "err.h"

extern void on_delete(NODEPTR n);

/* Prototypes of Functions */

static NODEPTR _CreateRule_1();
static NODEPTR _CreateRule_2();
static NODEPTR _CreateRule_3();
static NODEPTR _CreateRule_4();
static NODEPTR _CreatepSimpleState();
static NODEPTR _CreateRule_5();
static NODEPTR _CreateRule_6();
static NODEPTR _CreateRule_7();
static NODEPTR _CreatepXORSuperstate();
static NODEPTR _CreateRule_8();
static NODEPTR _CreateRule_9();
static NODEPTR _CreateRule_10();
static NODEPTR _CreatepANDSuperstate();
static NODEPTR _CreateRule_11();
static NODEPTR _CreatepANDRegion();
static NODEPTR _CreateRule_12();
static NODEPTR _CreatepTransition();

/* Node Creation Functions */

static NODEPTR _CreateRule_1()
{
	_TPPRule_1 currn = (_TPPRule_1)MkRule_1(
		NoPosition,
		Mkp_List_Substate(NoPosition, NULLNODEPTR));
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_1. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_2()
{
	_TPPRule_2 currn = (_TPPRule_2)MkRule_2(
		NoPosition,
		Mkp_List_Transition(NoPosition, NULLNODEPTR));
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_2. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_3()
{
	_TPPRule_3 currn = (_TPPRule_3)MkRule_3(
		NoPosition,
		_CreateRule_1(),
		_CreateRule_2(),
		VLPointArray(), VLString());
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_3. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_4()
{
	_TPPRule_4 currn = (_TPPRule_4)MkRule_4(
		NoPosition,
		_CreateRule_3());
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_4. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreatepSimpleState()
{
	_TPPpSimpleState currn = (_TPPpSimpleState)MkpSimpleState(
		NoPosition,
		_CreateRule_5(),
		VLPointArray());
	if (!currn) fprintf(stderr, "*** Liga refused to construct production pSimpleState. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_5()
{
	_TPPRule_5 currn = (_TPPRule_5)MkRule_5(
		NoPosition,
		VLPointArray(), VLString(), new VLProperty());
	currn->_ATTERM_3->setNode((NODEPTR) currn);
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_5. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_6()
{
	_TPPRule_6 currn = (_TPPRule_6)MkRule_6(
		NoPosition);
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_6. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_7()
{
	_TPPRule_7 currn = (_TPPRule_7)MkRule_7(
		NoPosition,
		Mkp_List_Substate(NoPosition, NULLNODEPTR));
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_7. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreatepXORSuperstate()
{
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate)MkpXORSuperstate(
		NoPosition,
		_CreateRule_8(),
		VLPointArray());
	if (!currn) fprintf(stderr, "*** Liga refused to construct production pXORSuperstate. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_8()
{
	_TPPRule_8 currn = (_TPPRule_8)MkRule_8(
		NoPosition,
		_CreateRule_6(),
		_CreateRule_7(),
		VLPointArray(), VLPointArray(), new VLProperty(), VLString());
	currn->_ATTERM_3->setNode((NODEPTR) currn);
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_8. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_9()
{
	_TPPRule_9 currn = (_TPPRule_9)MkRule_9(
		NoPosition);
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_9. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_10()
{
	_TPPRule_10 currn = (_TPPRule_10)MkRule_10(
		NoPosition,
		Mkp_List_ANDRegion(NoPosition, NULLNODEPTR));
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_10. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreatepANDSuperstate()
{
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate)MkpANDSuperstate(
		NoPosition,
		_CreateRule_11(),
		VLPointArray());
	if (!currn) fprintf(stderr, "*** Liga refused to construct production pANDSuperstate. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_11()
{
	_TPPRule_11 currn = (_TPPRule_11)MkRule_11(
		NoPosition,
		_CreateRule_9(),
		_CreateRule_10(),
		VLPointArray(), new VLProperty(), VLString());
	currn->_ATTERM_2->setNode((NODEPTR) currn);
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_11. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreatepANDRegion()
{
	_TPPpANDRegion currn = (_TPPpANDRegion)MkpANDRegion(
		NoPosition,
		Mkp_List_Substate(NoPosition, NULLNODEPTR),
		VLPointArray(), VLPointArray());
	if (!currn) fprintf(stderr, "*** Liga refused to construct production pANDRegion. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreateRule_12()
{
	_TPPRule_12 currn = (_TPPRule_12)MkRule_12(
		NoPosition,
		VLPointArray());
	if (!currn) fprintf(stderr, "*** Liga refused to construct production Rule_12. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _CreatepTransition()
{
	_TPPpTransition currn = (_TPPpTransition)MkpTransition(
		NoPosition,
		_CreateRule_12(),
		VLPointArray(), VLPointArray(), VLPointArray(), VLPointArray(), VLPointArray(), VLPointArray(), new VLProperty(), new VLProperty(), VLString());
	currn->_ATTERM_7->setNode((NODEPTR) currn);
	currn->_ATTERM_8->setNode((NODEPTR) currn);
	if (!currn) fprintf(stderr, "*** Liga refused to construct production pTransition. Specify a dummy attribute to avoid errors\n");
	return (NODEPTR) currn;
}

static NODEPTR _Createp_List_Substate()
{
	return (NODEPTR) Mkp_List_Substate(NoPosition, NULLNODEPTR);
}

static NODEPTR _Createp_List_ANDRegion()
{
	return (NODEPTR) Mkp_List_ANDRegion(NoPosition, NULLNODEPTR);
}

static NODEPTR _Createp_List_Transition()
{
	return (NODEPTR) Mkp_List_Transition(NoPosition, NULLNODEPTR);
}


/* Node Removal Functions */

static void _DeleteRule_1(NODEPTR n)
{
	_TPPRule_1 currn = (_TPPRule_1)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeleteRule_2(NODEPTR n)
{
	_TPPRule_2 currn = (_TPPRule_2)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeleteRule_3(NODEPTR n)
{
	_TPPRule_3 currn = (_TPPRule_3)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	(*RI[currn->_desc2->_prod].delrule)((NODEPTR)(currn->_desc2));
	delete currn;
}

static void _DeleteRule_4(NODEPTR n)
{
	_TPPRule_4 currn = (_TPPRule_4)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeletepSimpleState(NODEPTR n)
{
	_TPPpSimpleState currn = (_TPPpSimpleState)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeleteRule_5(NODEPTR n)
{
	_TPPRule_5 currn = (_TPPRule_5)n;
	if (! currn) return;
	delete currn->_ATTERM_3;
	delete currn;
}

static void _DeleteRule_6(NODEPTR n)
{
	_TPPRule_6 currn = (_TPPRule_6)n;
	if (! currn) return;
	delete currn;
}

static void _DeleteRule_7(NODEPTR n)
{
	_TPPRule_7 currn = (_TPPRule_7)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeletepXORSuperstate(NODEPTR n)
{
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeleteRule_8(NODEPTR n)
{
	_TPPRule_8 currn = (_TPPRule_8)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	(*RI[currn->_desc2->_prod].delrule)((NODEPTR)(currn->_desc2));
	delete currn->_ATTERM_3;
	delete currn;
}

static void _DeleteRule_9(NODEPTR n)
{
	_TPPRule_9 currn = (_TPPRule_9)n;
	if (! currn) return;
	delete currn;
}

static void _DeleteRule_10(NODEPTR n)
{
	_TPPRule_10 currn = (_TPPRule_10)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeletepANDSuperstate(NODEPTR n)
{
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeleteRule_11(NODEPTR n)
{
	_TPPRule_11 currn = (_TPPRule_11)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	(*RI[currn->_desc2->_prod].delrule)((NODEPTR)(currn->_desc2));
	delete currn->_ATTERM_2;
	delete currn;
}

static void _DeletepANDRegion(NODEPTR n)
{
	_TPPpANDRegion currn = (_TPPpANDRegion)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn;
}

static void _DeleteRule_12(NODEPTR n)
{
	_TPPRule_12 currn = (_TPPRule_12)n;
	if (! currn) return;
	delete currn;
}

static void _DeletepTransition(NODEPTR n)
{
	_TPPpTransition currn = (_TPPpTransition)n;
	if (! currn) return;
	(*RI[currn->_desc1->_prod].delrule)((NODEPTR)(currn->_desc1));
	delete currn->_ATTERM_7;
	delete currn->_ATTERM_8;
	delete currn;
}

static void _Deletep_List_Substate(NODEPTR n)
{
	_TPPp_List_Substate currn = (_TPPp_List_Substate)n;
	_TPPLST_Substatep_List_Substate desc, help;
	if (! currn) return;
	desc = (_TPPLST_Substatep_List_Substate) (currn->_desc1);
	while (desc) {
		if (desc->_desc1) /* Last List Context is empty! */
			(*RI[desc->_desc1->_prod].delrule)((NODEPTR)(desc->_desc1));
		help = desc;
		desc = (_TPPLST_Substatep_List_Substate) (desc->_desc2);
		if (desc != NULLNODEPTR)
			delete help;
		else  /* Last inner list node has a different type! */
			delete (_TPPLST_0p_List_Substate)help;
	}
	delete currn;
}

static void _Deletep_List_ANDRegion(NODEPTR n)
{
	_TPPp_List_ANDRegion currn = (_TPPp_List_ANDRegion)n;
	_TPPLST_ANDRegionp_List_ANDRegion desc, help;
	if (! currn) return;
	desc = (_TPPLST_ANDRegionp_List_ANDRegion) (currn->_desc1);
	while (desc) {
		if (desc->_desc1) /* Last List Context is empty! */
			(*RI[desc->_desc1->_prod].delrule)((NODEPTR)(desc->_desc1));
		help = desc;
		desc = (_TPPLST_ANDRegionp_List_ANDRegion) (desc->_desc2);
		if (desc != NULLNODEPTR)
			delete help;
		else  /* Last inner list node has a different type! */
			delete (_TPPLST_0p_List_ANDRegion)help;
	}
	delete currn;
}

static void _Deletep_List_Transition(NODEPTR n)
{
	_TPPp_List_Transition currn = (_TPPp_List_Transition)n;
	_TPPLST_Transitionp_List_Transition desc, help;
	if (! currn) return;
	desc = (_TPPLST_Transitionp_List_Transition) (currn->_desc1);
	while (desc) {
		if (desc->_desc1) /* Last List Context is empty! */
			(*RI[desc->_desc1->_prod].delrule)((NODEPTR)(desc->_desc1));
		help = desc;
		desc = (_TPPLST_Transitionp_List_Transition) (desc->_desc2);
		if (desc != NULLNODEPTR)
			delete help;
		else  /* Last inner list node has a different type! */
			delete (_TPPLST_0p_List_Transition)help;
	}
	delete currn;
}


/* Get Descendant Functions */

static Tcl_Obj *_GetDescRule_1(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_1 currn = (_TPPRule_1)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_2(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_2 currn = (_TPPRule_2)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_3(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_3 currn = (_TPPRule_3)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	if (!which || which == 2)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc2));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_4(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_4 currn = (_TPPRule_4)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescpSimpleState(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPpSimpleState currn = (_TPPpSimpleState)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_5(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_5 currn = (_TPPRule_5)n;
	if (! currn) return result;
	return result;
}

static Tcl_Obj *_GetDescRule_6(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_6 currn = (_TPPRule_6)n;
	if (! currn) return result;
	return result;
}

static Tcl_Obj *_GetDescRule_7(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_7 currn = (_TPPRule_7)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescpXORSuperstate(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_8(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_8 currn = (_TPPRule_8)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	if (!which || which == 2)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc2));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_9(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_9 currn = (_TPPRule_9)n;
	if (! currn) return result;
	return result;
}

static Tcl_Obj *_GetDescRule_10(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_10 currn = (_TPPRule_10)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescpANDSuperstate(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_11(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_11 currn = (_TPPRule_11)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	if (!which || which == 2)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc2));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescpANDRegion(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPpANDRegion currn = (_TPPpANDRegion)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescRule_12(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPRule_12 currn = (_TPPRule_12)n;
	if (! currn) return result;
	return result;
}

static Tcl_Obj *_GetDescpTransition(NODEPTR n, int which)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPpTransition currn = (_TPPpTransition)n;
	if (! currn) return result;
	if (!which || which == 1)
	{
		Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
			TclVP_NewVoidPointerObj(currn->_desc1));
		if (which != 0) return result;
	}
	return result;
}

static Tcl_Obj *_GetDescp_List_Substate(NODEPTR n, int)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPp_List_Substate currn = (_TPPp_List_Substate)n;
	_TPPLST_Substatep_List_Substate desc;
	if (! currn) return result;
	desc = (_TPPLST_Substatep_List_Substate) (currn->_desc1);
	while (desc) {
		if (desc->_desc1) /* Last List Context is empty! */
			Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
				TclVP_NewVoidPointerObj(desc->_desc1));
		desc = (_TPPLST_Substatep_List_Substate) desc->_desc2;
	}
	return result;
}

static Tcl_Obj *_GetDescp_List_ANDRegion(NODEPTR n, int)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPp_List_ANDRegion currn = (_TPPp_List_ANDRegion)n;
	_TPPLST_ANDRegionp_List_ANDRegion desc;
	if (! currn) return result;
	desc = (_TPPLST_ANDRegionp_List_ANDRegion) (currn->_desc1);
	while (desc) {
		if (desc->_desc1) /* Last List Context is empty! */
			Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
				TclVP_NewVoidPointerObj(desc->_desc1));
		desc = (_TPPLST_ANDRegionp_List_ANDRegion) desc->_desc2;
	}
	return result;
}

static Tcl_Obj *_GetDescp_List_Transition(NODEPTR n, int)
{
	Tcl_Obj *result = Tcl_NewObj();
	_TPPp_List_Transition currn = (_TPPp_List_Transition)n;
	_TPPLST_Transitionp_List_Transition desc;
	if (! currn) return result;
	desc = (_TPPLST_Transitionp_List_Transition) (currn->_desc1);
	while (desc) {
		if (desc->_desc1) /* Last List Context is empty! */
			Tcl_ListObjAppendElement((Tcl_Interp*)0, result,
				TclVP_NewVoidPointerObj(desc->_desc1));
		desc = (_TPPLST_Transitionp_List_Transition) desc->_desc2;
	}
	return result;
}


/* Attribute Set and Get Functions */

#define _GetAttrsRule_1 (Tcl_Obj *(*)(NODEPTR))0
#define _SetAttrRule_1 (void (*)(NODEPTR,char*,Tcl_Obj*))0

#define _GetVLValuesRule_1 (Tcl_Obj *(*)(NODEPTR))0
#define _GetVLPropertyIdsRule_1 (Tcl_Obj *(*)(NODEPTR))0
#define _GetAttrsRule_2 (Tcl_Obj *(*)(NODEPTR))0
#define _SetAttrRule_2 (void (*)(NODEPTR,char*,Tcl_Obj*))0

#define _GetVLValuesRule_2 (Tcl_Obj *(*)(NODEPTR))0
#define _GetVLPropertyIdsRule_2 (Tcl_Obj *(*)(NODEPTR))0
static Tcl_Obj *_GetAttrsRule_3(NODEPTR n)
{
	Tcl_Obj *attrs[4];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_3 currn = (_TPPRule_3)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Size", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	return Tcl_NewListObj(4, attrs);
}

static void _SetAttrRule_3(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPRule_3 _currn = (_TPPRule_3)n;
	if (! _currn) return;
	if (strcmp("persview0Size", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
	if (strcmp("persName", attr) == 0)
		_currn->_ATTERM_2.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
#define _TERM2 (_currn->_ATTERM_2)
	_TERMACT2_Rule_3
#undef _TERM1
#undef _TERM2
}

static Tcl_Obj *_GetVLPropertyIdsRule_3(NODEPTR n)
{
	Tcl_Obj *attrs[0+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_3 currn = (_TPPRule_3)n;
	if (! currn) return Tcl_NewObj();
	return Tcl_NewListObj(0, attrs);
}

static Tcl_Obj *_GetVLValuesRule_3(NODEPTR n)
{
	Tcl_Obj *attrs[4];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_3 currn = (_TPPRule_3)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Size", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	return Tcl_NewListObj(4, attrs);
}

#define _GetAttrsRule_4 (Tcl_Obj *(*)(NODEPTR))0
#define _SetAttrRule_4 (void (*)(NODEPTR,char*,Tcl_Obj*))0

#define _GetVLValuesRule_4 (Tcl_Obj *(*)(NODEPTR))0
#define _GetVLPropertyIdsRule_4 (Tcl_Obj *(*)(NODEPTR))0
static Tcl_Obj *_GetAttrspSimpleState(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpSimpleState currn = (_TPPpSimpleState)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static void _SetAttrpSimpleState(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPpSimpleState _currn = (_TPPpSimpleState)n;
	if (! _currn) return;
	if (strcmp("persview0Pos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
	_TERMACT2_pSimpleState
#undef _TERM1
}

static Tcl_Obj *_GetVLPropertyIdspSimpleState(NODEPTR n)
{
	Tcl_Obj *attrs[0+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpSimpleState currn = (_TPPpSimpleState)n;
	if (! currn) return Tcl_NewObj();
	return Tcl_NewListObj(0, attrs);
}

static Tcl_Obj *_GetVLValuespSimpleState(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpSimpleState currn = (_TPPpSimpleState)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static Tcl_Obj *_GetAttrsRule_5(NODEPTR n)
{
	Tcl_Obj *attrs[6];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_5 currn = (_TPPRule_5)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedPos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	*(atptr++) = Tcl_NewStringObj("persEndpoint", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_3);
	return Tcl_NewListObj(6, attrs);
}

static void _SetAttrRule_5(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPRule_5 _currn = (_TPPRule_5)n;
	if (! _currn) return;
	if (strcmp("persview0SavedPos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
	if (strcmp("persName", attr) == 0)
		_currn->_ATTERM_2.setVLValue(value);
	if (strcmp("persEndpoint", attr) == 0) {
		VLPropertyPtr vlp = (VLPropertyPtr) 0;
		if (TclVP_GetVoidPointerFromObj((Tcl_Interp *)0, value, (void **) &vlp) == TCL_OK)
			_currn->_ATTERM_3->associateWith(vlp);
		else
			_currn->_ATTERM_3->removeAssociations();
	}
#define _TERM1 (_currn->_ATTERM_1)
#define _TERM2 (_currn->_ATTERM_2)
#define _TERM3 (_currn->_ATTERM_3)
	_TERMACT2_Rule_5
#undef _TERM1
#undef _TERM2
#undef _TERM3
}

static Tcl_Obj *_GetVLPropertyIdsRule_5(NODEPTR n)
{
	Tcl_Obj *attrs[2+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_5 currn = (_TPPRule_5)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persEndpoint", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_3->m_data);
	return Tcl_NewListObj(2, attrs);
}

static Tcl_Obj *_GetVLValuesRule_5(NODEPTR n)
{
	Tcl_Obj *attrs[4];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_5 currn = (_TPPRule_5)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedPos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	return Tcl_NewListObj(4, attrs);
}

#define _GetAttrsRule_6 (Tcl_Obj *(*)(NODEPTR))0
#define _SetAttrRule_6 (void (*)(NODEPTR,char*,Tcl_Obj*))0

#define _GetVLValuesRule_6 (Tcl_Obj *(*)(NODEPTR))0
#define _GetVLPropertyIdsRule_6 (Tcl_Obj *(*)(NODEPTR))0
#define _GetAttrsRule_7 (Tcl_Obj *(*)(NODEPTR))0
#define _SetAttrRule_7 (void (*)(NODEPTR,char*,Tcl_Obj*))0

#define _GetVLValuesRule_7 (Tcl_Obj *(*)(NODEPTR))0
#define _GetVLPropertyIdsRule_7 (Tcl_Obj *(*)(NODEPTR))0
static Tcl_Obj *_GetAttrspXORSuperstate(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static void _SetAttrpXORSuperstate(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPpXORSuperstate _currn = (_TPPpXORSuperstate)n;
	if (! _currn) return;
	if (strcmp("persview0Pos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
	_TERMACT2_pXORSuperstate
#undef _TERM1
}

static Tcl_Obj *_GetVLPropertyIdspXORSuperstate(NODEPTR n)
{
	Tcl_Obj *attrs[0+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate)n;
	if (! currn) return Tcl_NewObj();
	return Tcl_NewListObj(0, attrs);
}

static Tcl_Obj *_GetVLValuespXORSuperstate(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static Tcl_Obj *_GetAttrsRule_8(NODEPTR n)
{
	Tcl_Obj *attrs[8];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_8 currn = (_TPPRule_8)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedPos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0Size", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	*(atptr++) = Tcl_NewStringObj("persEndpoint", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_3);
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_4.getObj();
	return Tcl_NewListObj(8, attrs);
}

static void _SetAttrRule_8(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPRule_8 _currn = (_TPPRule_8)n;
	if (! _currn) return;
	if (strcmp("persview0SavedPos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
	if (strcmp("persview0Size", attr) == 0)
		_currn->_ATTERM_2.setVLValue(value);
	if (strcmp("persEndpoint", attr) == 0) {
		VLPropertyPtr vlp = (VLPropertyPtr) 0;
		if (TclVP_GetVoidPointerFromObj((Tcl_Interp *)0, value, (void **) &vlp) == TCL_OK)
			_currn->_ATTERM_3->associateWith(vlp);
		else
			_currn->_ATTERM_3->removeAssociations();
	}
	if (strcmp("persName", attr) == 0)
		_currn->_ATTERM_4.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
#define _TERM2 (_currn->_ATTERM_2)
#define _TERM3 (_currn->_ATTERM_3)
#define _TERM4 (_currn->_ATTERM_4)
	_TERMACT2_Rule_8
#undef _TERM1
#undef _TERM2
#undef _TERM3
#undef _TERM4
}

static Tcl_Obj *_GetVLPropertyIdsRule_8(NODEPTR n)
{
	Tcl_Obj *attrs[2+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_8 currn = (_TPPRule_8)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persEndpoint", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_3->m_data);
	return Tcl_NewListObj(2, attrs);
}

static Tcl_Obj *_GetVLValuesRule_8(NODEPTR n)
{
	Tcl_Obj *attrs[6];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_8 currn = (_TPPRule_8)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedPos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0Size", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_4.getObj();
	return Tcl_NewListObj(6, attrs);
}

#define _GetAttrsRule_9 (Tcl_Obj *(*)(NODEPTR))0
#define _SetAttrRule_9 (void (*)(NODEPTR,char*,Tcl_Obj*))0

#define _GetVLValuesRule_9 (Tcl_Obj *(*)(NODEPTR))0
#define _GetVLPropertyIdsRule_9 (Tcl_Obj *(*)(NODEPTR))0
#define _GetAttrsRule_10 (Tcl_Obj *(*)(NODEPTR))0
#define _SetAttrRule_10 (void (*)(NODEPTR,char*,Tcl_Obj*))0

#define _GetVLValuesRule_10 (Tcl_Obj *(*)(NODEPTR))0
#define _GetVLPropertyIdsRule_10 (Tcl_Obj *(*)(NODEPTR))0
static Tcl_Obj *_GetAttrspANDSuperstate(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static void _SetAttrpANDSuperstate(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPpANDSuperstate _currn = (_TPPpANDSuperstate)n;
	if (! _currn) return;
	if (strcmp("persview0Pos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
	_TERMACT2_pANDSuperstate
#undef _TERM1
}

static Tcl_Obj *_GetVLPropertyIdspANDSuperstate(NODEPTR n)
{
	Tcl_Obj *attrs[0+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate)n;
	if (! currn) return Tcl_NewObj();
	return Tcl_NewListObj(0, attrs);
}

static Tcl_Obj *_GetVLValuespANDSuperstate(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static Tcl_Obj *_GetAttrsRule_11(NODEPTR n)
{
	Tcl_Obj *attrs[6];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_11 currn = (_TPPRule_11)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedPos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persEndpoint", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_2);
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_3.getObj();
	return Tcl_NewListObj(6, attrs);
}

static void _SetAttrRule_11(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPRule_11 _currn = (_TPPRule_11)n;
	if (! _currn) return;
	if (strcmp("persview0SavedPos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
	if (strcmp("persEndpoint", attr) == 0) {
		VLPropertyPtr vlp = (VLPropertyPtr) 0;
		if (TclVP_GetVoidPointerFromObj((Tcl_Interp *)0, value, (void **) &vlp) == TCL_OK)
			_currn->_ATTERM_2->associateWith(vlp);
		else
			_currn->_ATTERM_2->removeAssociations();
	}
	if (strcmp("persName", attr) == 0)
		_currn->_ATTERM_3.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
#define _TERM2 (_currn->_ATTERM_2)
#define _TERM3 (_currn->_ATTERM_3)
	_TERMACT2_Rule_11
#undef _TERM1
#undef _TERM2
#undef _TERM3
}

static Tcl_Obj *_GetVLPropertyIdsRule_11(NODEPTR n)
{
	Tcl_Obj *attrs[2+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_11 currn = (_TPPRule_11)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persEndpoint", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_2->m_data);
	return Tcl_NewListObj(2, attrs);
}

static Tcl_Obj *_GetVLValuesRule_11(NODEPTR n)
{
	Tcl_Obj *attrs[4];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_11 currn = (_TPPRule_11)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedPos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persName", -1);
	*(atptr++) = currn->_ATTERM_3.getObj();
	return Tcl_NewListObj(4, attrs);
}

static Tcl_Obj *_GetAttrspANDRegion(NODEPTR n)
{
	Tcl_Obj *attrs[4];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpANDRegion currn = (_TPPpANDRegion)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0Size", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	return Tcl_NewListObj(4, attrs);
}

static void _SetAttrpANDRegion(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPpANDRegion _currn = (_TPPpANDRegion)n;
	if (! _currn) return;
	if (strcmp("persview0Pos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
	if (strcmp("persview0Size", attr) == 0)
		_currn->_ATTERM_2.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
#define _TERM2 (_currn->_ATTERM_2)
	_TERMACT2_pANDRegion
#undef _TERM1
#undef _TERM2
}

static Tcl_Obj *_GetVLPropertyIdspANDRegion(NODEPTR n)
{
	Tcl_Obj *attrs[0+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpANDRegion currn = (_TPPpANDRegion)n;
	if (! currn) return Tcl_NewObj();
	return Tcl_NewListObj(0, attrs);
}

static Tcl_Obj *_GetVLValuespANDRegion(NODEPTR n)
{
	Tcl_Obj *attrs[4];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpANDRegion currn = (_TPPpANDRegion)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0Size", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	return Tcl_NewListObj(4, attrs);
}

static Tcl_Obj *_GetAttrsRule_12(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_12 currn = (_TPPRule_12)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static void _SetAttrRule_12(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPRule_12 _currn = (_TPPRule_12)n;
	if (! _currn) return;
	if (strcmp("persview0Pos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
	_TERMACT2_Rule_12
#undef _TERM1
}

static Tcl_Obj *_GetVLPropertyIdsRule_12(NODEPTR n)
{
	Tcl_Obj *attrs[0+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_12 currn = (_TPPRule_12)n;
	if (! currn) return Tcl_NewObj();
	return Tcl_NewListObj(0, attrs);
}

static Tcl_Obj *_GetVLValuesRule_12(NODEPTR n)
{
	Tcl_Obj *attrs[2];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPRule_12 currn = (_TPPRule_12)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	return Tcl_NewListObj(2, attrs);
}

static Tcl_Obj *_GetAttrspTransition(NODEPTR n)
{
	Tcl_Obj *attrs[18];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpTransition currn = (_TPPpTransition)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0FromOffset", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0ToOffset", -1);
	*(atptr++) = currn->_ATTERM_3.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedFromOffset", -1);
	*(atptr++) = currn->_ATTERM_4.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedToOffset", -1);
	*(atptr++) = currn->_ATTERM_5.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0IntermediatePoints", -1);
	*(atptr++) = currn->_ATTERM_6.getObj();
	*(atptr++) = Tcl_NewStringObj("persFrom", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_7);
	*(atptr++) = Tcl_NewStringObj("persTo", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_8);
	*(atptr++) = Tcl_NewStringObj("persEvent", -1);
	*(atptr++) = currn->_ATTERM_9.getObj();
	return Tcl_NewListObj(18, attrs);
}

static void _SetAttrpTransition(NODEPTR n, char *attr, Tcl_Obj *value)
{
	_TPPpTransition _currn = (_TPPpTransition)n;
	if (! _currn) return;
	if (strcmp("persview0Pos", attr) == 0)
		_currn->_ATTERM_1.setVLValue(value);
	if (strcmp("persview0FromOffset", attr) == 0)
		_currn->_ATTERM_2.setVLValue(value);
	if (strcmp("persview0ToOffset", attr) == 0)
		_currn->_ATTERM_3.setVLValue(value);
	if (strcmp("persview0SavedFromOffset", attr) == 0)
		_currn->_ATTERM_4.setVLValue(value);
	if (strcmp("persview0SavedToOffset", attr) == 0)
		_currn->_ATTERM_5.setVLValue(value);
	if (strcmp("persview0IntermediatePoints", attr) == 0)
		_currn->_ATTERM_6.setVLValue(value);
	if (strcmp("persFrom", attr) == 0) {
		VLPropertyPtr vlp = (VLPropertyPtr) 0;
		if (TclVP_GetVoidPointerFromObj((Tcl_Interp *)0, value, (void **) &vlp) == TCL_OK)
			_currn->_ATTERM_7->associateWith(vlp);
		else
			_currn->_ATTERM_7->removeAssociations();
	}
	if (strcmp("persTo", attr) == 0) {
		VLPropertyPtr vlp = (VLPropertyPtr) 0;
		if (TclVP_GetVoidPointerFromObj((Tcl_Interp *)0, value, (void **) &vlp) == TCL_OK)
			_currn->_ATTERM_8->associateWith(vlp);
		else
			_currn->_ATTERM_8->removeAssociations();
	}
	if (strcmp("persEvent", attr) == 0)
		_currn->_ATTERM_9.setVLValue(value);
#define _TERM1 (_currn->_ATTERM_1)
#define _TERM2 (_currn->_ATTERM_2)
#define _TERM3 (_currn->_ATTERM_3)
#define _TERM4 (_currn->_ATTERM_4)
#define _TERM5 (_currn->_ATTERM_5)
#define _TERM6 (_currn->_ATTERM_6)
#define _TERM7 (_currn->_ATTERM_7)
#define _TERM8 (_currn->_ATTERM_8)
#define _TERM9 (_currn->_ATTERM_9)
	_TERMACT2_pTransition
#undef _TERM1
#undef _TERM2
#undef _TERM3
#undef _TERM4
#undef _TERM5
#undef _TERM6
#undef _TERM7
#undef _TERM8
#undef _TERM9
}

static Tcl_Obj *_GetVLPropertyIdspTransition(NODEPTR n)
{
	Tcl_Obj *attrs[4+1]; /* +1, damit es auch mit 0 funktioniert */
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpTransition currn = (_TPPpTransition)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persFrom", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_7->m_data);
	*(atptr++) = Tcl_NewStringObj("persTo", -1);
	*(atptr++) = TclVP_NewVoidPointerObj(currn->_ATTERM_8->m_data);
	return Tcl_NewListObj(4, attrs);
}

static Tcl_Obj *_GetVLValuespTransition(NODEPTR n)
{
	Tcl_Obj *attrs[14];
	Tcl_Obj **atptr = &(attrs[0]);
	_TPPpTransition currn = (_TPPpTransition)n;
	if (! currn) return Tcl_NewObj();
	*(atptr++) = Tcl_NewStringObj("persview0Pos", -1);
	*(atptr++) = currn->_ATTERM_1.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0FromOffset", -1);
	*(atptr++) = currn->_ATTERM_2.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0ToOffset", -1);
	*(atptr++) = currn->_ATTERM_3.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedFromOffset", -1);
	*(atptr++) = currn->_ATTERM_4.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0SavedToOffset", -1);
	*(atptr++) = currn->_ATTERM_5.getObj();
	*(atptr++) = Tcl_NewStringObj("persview0IntermediatePoints", -1);
	*(atptr++) = currn->_ATTERM_6.getObj();
	*(atptr++) = Tcl_NewStringObj("persEvent", -1);
	*(atptr++) = currn->_ATTERM_9.getObj();
	return Tcl_NewListObj(14, attrs);
}


/* Functions for Insertion into and removal from nodes */

static int _Insertp_List_Substate(NODEPTR root, NODEPTR element, int position, int repl)
{
	_TPPLST_Substatep_List_Substate *descadr;

	if (element->_father != NULLNODEPTR) {
		if (element->_father == root) {
			int elpos = 0;
			descadr = (_TPPLST_Substatep_List_Substate *) &(((_TPPp_List_Substate)root)->_desc1);
			while ((*descadr)->_desc2) {
				if ((NODEPTR) ((*descadr)->_desc1) == element) break;
				elpos++;
				descadr = (_TPPLST_Substatep_List_Substate *) &((*descadr)->_desc2);
			}
			if (position > elpos) position--;
		}
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	NODEPTR elem = MkSubstate(NoPosition, element);
	if (elem == NULLNODEPTR) return 1;
	descadr = (_TPPLST_Substatep_List_Substate *) &(((_TPPp_List_Substate)root)->_desc1);
	while (position != 0) {
		if ((*descadr)->_desc2) {  /* Another son exists, go on. */
			descadr = (_TPPLST_Substatep_List_Substate *) &((*descadr)->_desc2);
			position--;
		}
		else if (position < 0) break; else return 2;
	}
	if ((NODEPTR)((*descadr)->_desc2) == NULLNODEPTR) repl = 0;
	if (repl) {
		NODEPTR delnode = (NODEPTR)((*descadr)->_desc1);
		(*descadr)->_desc1 = (_TSPSubstate)elem;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
	} else {
		_TSPLST__List_Substate remain = (_TSPLST__List_Substate) (*descadr);
		*descadr = new _TPLST_Substatep_List_Substate;
		(*descadr)->_prod = RULELST_Substatep_List_Substate;
		(*descadr)->_desc1 = (_TSPSubstate)elem;
		(*descadr)->_desc2 = remain;
	}
	elem->_father = root;
	return 0;
}

static void _Extractp_List_Substate(NODEPTR root, NODEPTR elem)
{
	_TPPLST_Substatep_List_Substate *descadr = 
		(_TPPLST_Substatep_List_Substate *) &(((_TPPp_List_Substate)root)->_desc1);
	if (root == NULLNODEPTR || elem == NULLNODEPTR) return;
	while ((*descadr) != NULLNODEPTR && (NODEPTR)((*descadr)->_desc1) != elem) {
		descadr = (_TPPLST_Substatep_List_Substate *) &((*descadr)->_desc2);
	}
	if ((*descadr) == NULLNODEPTR) /* Not found */
		return;
	_TPPLST_Substatep_List_Substate remain = (_TPPLST_Substatep_List_Substate) (*descadr);
	*descadr = (_TPPLST_Substatep_List_Substate)((*descadr)->_desc2);
	delete remain;
	elem->_father = NULLNODEPTR;
}

static int _Insertp_List_ANDRegion(NODEPTR root, NODEPTR element, int position, int repl)
{
	_TPPLST_ANDRegionp_List_ANDRegion *descadr;

	if (element->_father != NULLNODEPTR) {
		if (element->_father == root) {
			int elpos = 0;
			descadr = (_TPPLST_ANDRegionp_List_ANDRegion *) &(((_TPPp_List_ANDRegion)root)->_desc1);
			while ((*descadr)->_desc2) {
				if ((NODEPTR) ((*descadr)->_desc1) == element) break;
				elpos++;
				descadr = (_TPPLST_ANDRegionp_List_ANDRegion *) &((*descadr)->_desc2);
			}
			if (position > elpos) position--;
		}
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	NODEPTR elem = MkANDRegion(NoPosition, element);
	if (elem == NULLNODEPTR) return 1;
	descadr = (_TPPLST_ANDRegionp_List_ANDRegion *) &(((_TPPp_List_ANDRegion)root)->_desc1);
	while (position != 0) {
		if ((*descadr)->_desc2) {  /* Another son exists, go on. */
			descadr = (_TPPLST_ANDRegionp_List_ANDRegion *) &((*descadr)->_desc2);
			position--;
		}
		else if (position < 0) break; else return 2;
	}
	if ((NODEPTR)((*descadr)->_desc2) == NULLNODEPTR) repl = 0;
	if (repl) {
		NODEPTR delnode = (NODEPTR)((*descadr)->_desc1);
		(*descadr)->_desc1 = (_TSPANDRegion)elem;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
	} else {
		_TSPLST__List_ANDRegion remain = (_TSPLST__List_ANDRegion) (*descadr);
		*descadr = new _TPLST_ANDRegionp_List_ANDRegion;
		(*descadr)->_prod = RULELST_ANDRegionp_List_ANDRegion;
		(*descadr)->_desc1 = (_TSPANDRegion)elem;
		(*descadr)->_desc2 = remain;
	}
	elem->_father = root;
	return 0;
}

static void _Extractp_List_ANDRegion(NODEPTR root, NODEPTR elem)
{
	_TPPLST_ANDRegionp_List_ANDRegion *descadr = 
		(_TPPLST_ANDRegionp_List_ANDRegion *) &(((_TPPp_List_ANDRegion)root)->_desc1);
	if (root == NULLNODEPTR || elem == NULLNODEPTR) return;
	while ((*descadr) != NULLNODEPTR && (NODEPTR)((*descadr)->_desc1) != elem) {
		descadr = (_TPPLST_ANDRegionp_List_ANDRegion *) &((*descadr)->_desc2);
	}
	if ((*descadr) == NULLNODEPTR) /* Not found */
		return;
	_TPPLST_ANDRegionp_List_ANDRegion remain = (_TPPLST_ANDRegionp_List_ANDRegion) (*descadr);
	*descadr = (_TPPLST_ANDRegionp_List_ANDRegion)((*descadr)->_desc2);
	delete remain;
	elem->_father = NULLNODEPTR;
}

static int _Insertp_List_Transition(NODEPTR root, NODEPTR element, int position, int repl)
{
	_TPPLST_Transitionp_List_Transition *descadr;

	if (element->_father != NULLNODEPTR) {
		if (element->_father == root) {
			int elpos = 0;
			descadr = (_TPPLST_Transitionp_List_Transition *) &(((_TPPp_List_Transition)root)->_desc1);
			while ((*descadr)->_desc2) {
				if ((NODEPTR) ((*descadr)->_desc1) == element) break;
				elpos++;
				descadr = (_TPPLST_Transitionp_List_Transition *) &((*descadr)->_desc2);
			}
			if (position > elpos) position--;
		}
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	NODEPTR elem = MkTransition(NoPosition, element);
	if (elem == NULLNODEPTR) return 1;
	descadr = (_TPPLST_Transitionp_List_Transition *) &(((_TPPp_List_Transition)root)->_desc1);
	while (position != 0) {
		if ((*descadr)->_desc2) {  /* Another son exists, go on. */
			descadr = (_TPPLST_Transitionp_List_Transition *) &((*descadr)->_desc2);
			position--;
		}
		else if (position < 0) break; else return 2;
	}
	if ((NODEPTR)((*descadr)->_desc2) == NULLNODEPTR) repl = 0;
	if (repl) {
		NODEPTR delnode = (NODEPTR)((*descadr)->_desc1);
		(*descadr)->_desc1 = (_TSPTransition)elem;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
	} else {
		_TSPLST__List_Transition remain = (_TSPLST__List_Transition) (*descadr);
		*descadr = new _TPLST_Transitionp_List_Transition;
		(*descadr)->_prod = RULELST_Transitionp_List_Transition;
		(*descadr)->_desc1 = (_TSPTransition)elem;
		(*descadr)->_desc2 = remain;
	}
	elem->_father = root;
	return 0;
}

static void _Extractp_List_Transition(NODEPTR root, NODEPTR elem)
{
	_TPPLST_Transitionp_List_Transition *descadr = 
		(_TPPLST_Transitionp_List_Transition *) &(((_TPPp_List_Transition)root)->_desc1);
	if (root == NULLNODEPTR || elem == NULLNODEPTR) return;
	while ((*descadr) != NULLNODEPTR && (NODEPTR)((*descadr)->_desc1) != elem) {
		descadr = (_TPPLST_Transitionp_List_Transition *) &((*descadr)->_desc2);
	}
	if ((*descadr) == NULLNODEPTR) /* Not found */
		return;
	_TPPLST_Transitionp_List_Transition remain = (_TPPLST_Transitionp_List_Transition) (*descadr);
	*descadr = (_TPPLST_Transitionp_List_Transition)((*descadr)->_desc2);
	delete remain;
	elem->_father = NULLNODEPTR;
}

static int _InsertRule_1(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_1 currn = (_TPPRule_1) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = Mk_List_Substate(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSP_List_Substate) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_1(NODEPTR root, NODEPTR elem)
{
	_TPPRule_1 currn = (_TPPRule_1) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSP_List_Substate) Mkp_List_Substate(NoPosition, NULLNODEPTR);
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_2(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_2 currn = (_TPPRule_2) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = Mk_List_Transition(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSP_List_Transition) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_2(NODEPTR root, NODEPTR elem)
{
	_TPPRule_2 currn = (_TPPRule_2) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSP_List_Transition) Mkp_List_Transition(NoPosition, NULLNODEPTR);
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_3(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_3 currn = (_TPPRule_3) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkStateList(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPStateList) elem;
	} else if (position == 2) {
		elem = MkTransitionList(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc2;
		currn->_desc2 = (_TSPTransitionList) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_3(NODEPTR root, NODEPTR elem)
{
	_TPPRule_3 currn = (_TPPRule_3) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPStateList) _CreateRule_1();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	} else if ((NODEPTR)(currn->_desc2) == elem) {
		currn->_desc2 = (_TSPTransitionList) _CreateRule_2();
		currn->_desc2->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_4(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_4 currn = (_TPPRule_4) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkStatechart(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPStatechart) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_4(NODEPTR root, NODEPTR elem)
{
	_TPPRule_4 currn = (_TPPRule_4) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPStatechart) _CreateRule_3();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertpSimpleState(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPpSimpleState currn = (_TPPpSimpleState) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkSimpleState(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPSimpleState) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractpSimpleState(NODEPTR root, NODEPTR elem)
{
	_TPPpSimpleState currn = (_TPPpSimpleState) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPSimpleState) _CreateRule_5();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_5(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_5 currn = (_TPPRule_5) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_5(NODEPTR root, NODEPTR elem)
{
	_TPPRule_5 currn = (_TPPRule_5) root;
	
}
static int _InsertRule_6(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_6 currn = (_TPPRule_6) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_6(NODEPTR root, NODEPTR elem)
{
	_TPPRule_6 currn = (_TPPRule_6) root;
	
}
static int _InsertRule_7(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_7 currn = (_TPPRule_7) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = Mk_List_Substate(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSP_List_Substate) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_7(NODEPTR root, NODEPTR elem)
{
	_TPPRule_7 currn = (_TPPRule_7) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSP_List_Substate) Mkp_List_Substate(NoPosition, NULLNODEPTR);
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertpXORSuperstate(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkXORSuperstate(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPXORSuperstate) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractpXORSuperstate(NODEPTR root, NODEPTR elem)
{
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPXORSuperstate) _CreateRule_8();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_8(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_8 currn = (_TPPRule_8) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkXORName(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPXORName) elem;
	} else if (position == 2) {
		elem = MkXORSubstates(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc2;
		currn->_desc2 = (_TSPXORSubstates) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_8(NODEPTR root, NODEPTR elem)
{
	_TPPRule_8 currn = (_TPPRule_8) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPXORName) _CreateRule_6();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	} else if ((NODEPTR)(currn->_desc2) == elem) {
		currn->_desc2 = (_TSPXORSubstates) _CreateRule_7();
		currn->_desc2->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_9(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_9 currn = (_TPPRule_9) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_9(NODEPTR root, NODEPTR elem)
{
	_TPPRule_9 currn = (_TPPRule_9) root;
	
}
static int _InsertRule_10(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_10 currn = (_TPPRule_10) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = Mk_List_ANDRegion(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSP_List_ANDRegion) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_10(NODEPTR root, NODEPTR elem)
{
	_TPPRule_10 currn = (_TPPRule_10) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSP_List_ANDRegion) Mkp_List_ANDRegion(NoPosition, NULLNODEPTR);
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertpANDSuperstate(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkANDSuperstate(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPANDSuperstate) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractpANDSuperstate(NODEPTR root, NODEPTR elem)
{
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPANDSuperstate) _CreateRule_11();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_11(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_11 currn = (_TPPRule_11) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkANDName(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPANDName) elem;
	} else if (position == 2) {
		elem = MkANDRegions(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc2;
		currn->_desc2 = (_TSPANDRegions) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_11(NODEPTR root, NODEPTR elem)
{
	_TPPRule_11 currn = (_TPPRule_11) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPANDName) _CreateRule_9();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	} else if ((NODEPTR)(currn->_desc2) == elem) {
		currn->_desc2 = (_TSPANDRegions) _CreateRule_10();
		currn->_desc2->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertpANDRegion(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPpANDRegion currn = (_TPPpANDRegion) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = Mk_List_Substate(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSP_List_Substate) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractpANDRegion(NODEPTR root, NODEPTR elem)
{
	_TPPpANDRegion currn = (_TPPpANDRegion) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSP_List_Substate) Mkp_List_Substate(NoPosition, NULLNODEPTR);
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}
static int _InsertRule_12(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPRule_12 currn = (_TPPRule_12) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractRule_12(NODEPTR root, NODEPTR elem)
{
	_TPPRule_12 currn = (_TPPRule_12) root;
	
}
static int _InsertpTransition(NODEPTR root, NODEPTR element, int position, int repl)
{
	NODEPTR elem = NULLNODEPTR, delnode = NULLNODEPTR;
	_TPPpTransition currn = (_TPPpTransition) root;
	if ((NODEPTR)element->_father != NULLNODEPTR) {
		(*RI[element->_father->_prod].extract)(element->_father, element);
		if ((NODEPTR)element->_father != NULLNODEPTR) return 4;
	}
	position++;           /* Indexes start from 1 here! */
	if (!repl) return 3;  /* Can only replace */
	if (position == 1) {
		elem = MkTransitionLabel(NoPosition, element);
		if (elem == NULLNODEPTR) return 1;
		delnode = (NODEPTR) currn->_desc1;
		currn->_desc1 = (_TSPTransitionLabel) elem;
	}
	if (elem != NULLNODEPTR) {
		elem->_father = root;
		on_delete(delnode);
		(*RI[delnode->_prod].delrule)(delnode);
		return 0;
	} else return 2;
}

static void _ExtractpTransition(NODEPTR root, NODEPTR elem)
{
	_TPPpTransition currn = (_TPPpTransition) root;
	if ((NODEPTR)(currn->_desc1) == elem) {
		currn->_desc1 = (_TSPTransitionLabel) _CreateRule_12();
		currn->_desc1->_father = root;
		elem->_father = NULLNODEPTR;
	}
}

/* Get Minimum and Maximum Repetition of List Nodes */

static void _GetMinMaxRule_1(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_1 currn = (_TPPRule_1)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 0;
		*max = 0;
		return;
	}
}

static void _GetMinMaxRule_2(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_2 currn = (_TPPRule_2)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 0;
		*max = 0;
		return;
	}
}

static void _GetMinMaxRule_3(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_3 currn = (_TPPRule_3)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
	if ((NODEPTR) currn->_desc2 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}

static void _GetMinMaxRule_4(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_4 currn = (_TPPRule_4)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}

static void _GetMinMaxpSimpleState(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPpSimpleState currn = (_TPPpSimpleState)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}

static void _GetMinMaxRule_5(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_5 currn = (_TPPRule_5)father;
}

static void _GetMinMaxRule_6(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_6 currn = (_TPPRule_6)father;
}

static void _GetMinMaxRule_7(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_7 currn = (_TPPRule_7)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 0;
		*max = 0;
		return;
	}
}

static void _GetMinMaxpXORSuperstate(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPpXORSuperstate currn = (_TPPpXORSuperstate)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}

static void _GetMinMaxRule_8(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_8 currn = (_TPPRule_8)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
	if ((NODEPTR) currn->_desc2 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}

static void _GetMinMaxRule_9(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_9 currn = (_TPPRule_9)father;
}

static void _GetMinMaxRule_10(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_10 currn = (_TPPRule_10)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 2;
		*max = 0;
		return;
	}
}

static void _GetMinMaxpANDSuperstate(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPpANDSuperstate currn = (_TPPpANDSuperstate)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}

static void _GetMinMaxRule_11(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_11 currn = (_TPPRule_11)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
	if ((NODEPTR) currn->_desc2 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}

static void _GetMinMaxpANDRegion(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPpANDRegion currn = (_TPPpANDRegion)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 0;
		*max = 0;
		return;
	}
}

static void _GetMinMaxRule_12(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPRule_12 currn = (_TPPRule_12)father;
}

static void _GetMinMaxpTransition(NODEPTR father, NODEPTR son, int *min, int *max)
{
	_TPPpTransition currn = (_TPPpTransition)father;
	if ((NODEPTR) currn->_desc1 == son) {
		*min = 1;
		*max = 1;
		return;
	}
}


/* Rule Information Table */

Ruleinfo RI[ RI_LEN ];

void InitRuleTable()
{
	int i;
	for(i = 0; i < RI_LEN; i++)
	{
		RI[i].rulename = "(none)";
		RI[i].ruletype = 2;
		RI[i].create = (NODEPTR (*)(void))0;
		RI[i].delrule = (void (*)(NODEPTR))0;
		RI[i].getdesc = (Tcl_Obj *(*)(NODEPTR,int))0;
		RI[i].getattrs = (Tcl_Obj *(*)(NODEPTR))0;
		RI[i].getvlpropertyids = (Tcl_Obj *(*)(NODEPTR))0;
		RI[i].getvlvalues = (Tcl_Obj *(*)(NODEPTR))0;
		RI[i].setattr = (void(*)(NODEPTR,char*,Tcl_Obj*))0;
		RI[i].insert = (int (*)(NODEPTR,NODEPTR,int,int))0;
		RI[i].extract = (void (*)(NODEPTR,NODEPTR))0;
		RI[i].getminmax = (void (*)(NODEPTR,NODEPTR,int*,int*))0;
	}

	RI[RULERule_1].rulename = "Rule_1";
	RI[RULERule_1].ruletype = 0;
	RI[RULERule_1].create = _CreateRule_1;
	RI[RULERule_1].delrule = _DeleteRule_1;
	RI[RULERule_1].getdesc = _GetDescRule_1;
	RI[RULERule_1].getattrs = _GetAttrsRule_1;
	RI[RULERule_1].getvlpropertyids = _GetVLPropertyIdsRule_1;
	RI[RULERule_1].getvlvalues = _GetVLValuesRule_1;
	RI[RULERule_1].setattr = _SetAttrRule_1;
	RI[RULERule_1].insert = _InsertRule_1;
	RI[RULERule_1].extract = _ExtractRule_1;
	RI[RULERule_1].getminmax = _GetMinMaxRule_1;
	RI[RULERule_2].rulename = "Rule_2";
	RI[RULERule_2].ruletype = 0;
	RI[RULERule_2].create = _CreateRule_2;
	RI[RULERule_2].delrule = _DeleteRule_2;
	RI[RULERule_2].getdesc = _GetDescRule_2;
	RI[RULERule_2].getattrs = _GetAttrsRule_2;
	RI[RULERule_2].getvlpropertyids = _GetVLPropertyIdsRule_2;
	RI[RULERule_2].getvlvalues = _GetVLValuesRule_2;
	RI[RULERule_2].setattr = _SetAttrRule_2;
	RI[RULERule_2].insert = _InsertRule_2;
	RI[RULERule_2].extract = _ExtractRule_2;
	RI[RULERule_2].getminmax = _GetMinMaxRule_2;
	RI[RULERule_3].rulename = "Rule_3";
	RI[RULERule_3].ruletype = 0;
	RI[RULERule_3].create = _CreateRule_3;
	RI[RULERule_3].delrule = _DeleteRule_3;
	RI[RULERule_3].getdesc = _GetDescRule_3;
	RI[RULERule_3].getattrs = _GetAttrsRule_3;
	RI[RULERule_3].getvlpropertyids = _GetVLPropertyIdsRule_3;
	RI[RULERule_3].getvlvalues = _GetVLValuesRule_3;
	RI[RULERule_3].setattr = _SetAttrRule_3;
	RI[RULERule_3].insert = _InsertRule_3;
	RI[RULERule_3].extract = _ExtractRule_3;
	RI[RULERule_3].getminmax = _GetMinMaxRule_3;
	RI[RULERule_4].rulename = "Rule_4";
	RI[RULERule_4].ruletype = 0;
	RI[RULERule_4].create = _CreateRule_4;
	RI[RULERule_4].delrule = _DeleteRule_4;
	RI[RULERule_4].getdesc = _GetDescRule_4;
	RI[RULERule_4].getattrs = _GetAttrsRule_4;
	RI[RULERule_4].getvlpropertyids = _GetVLPropertyIdsRule_4;
	RI[RULERule_4].getvlvalues = _GetVLValuesRule_4;
	RI[RULERule_4].setattr = _SetAttrRule_4;
	RI[RULERule_4].insert = _InsertRule_4;
	RI[RULERule_4].extract = _ExtractRule_4;
	RI[RULERule_4].getminmax = _GetMinMaxRule_4;
	RI[RULEpSimpleState].rulename = "pSimpleState";
	RI[RULEpSimpleState].ruletype = 0;
	RI[RULEpSimpleState].create = _CreatepSimpleState;
	RI[RULEpSimpleState].delrule = _DeletepSimpleState;
	RI[RULEpSimpleState].getdesc = _GetDescpSimpleState;
	RI[RULEpSimpleState].getattrs = _GetAttrspSimpleState;
	RI[RULEpSimpleState].getvlpropertyids = _GetVLPropertyIdspSimpleState;
	RI[RULEpSimpleState].getvlvalues = _GetVLValuespSimpleState;
	RI[RULEpSimpleState].setattr = _SetAttrpSimpleState;
	RI[RULEpSimpleState].insert = _InsertpSimpleState;
	RI[RULEpSimpleState].extract = _ExtractpSimpleState;
	RI[RULEpSimpleState].getminmax = _GetMinMaxpSimpleState;
	RI[RULERule_5].rulename = "Rule_5";
	RI[RULERule_5].ruletype = 0;
	RI[RULERule_5].create = _CreateRule_5;
	RI[RULERule_5].delrule = _DeleteRule_5;
	RI[RULERule_5].getdesc = _GetDescRule_5;
	RI[RULERule_5].getattrs = _GetAttrsRule_5;
	RI[RULERule_5].getvlpropertyids = _GetVLPropertyIdsRule_5;
	RI[RULERule_5].getvlvalues = _GetVLValuesRule_5;
	RI[RULERule_5].setattr = _SetAttrRule_5;
	RI[RULERule_5].insert = _InsertRule_5;
	RI[RULERule_5].extract = _ExtractRule_5;
	RI[RULERule_5].getminmax = _GetMinMaxRule_5;
	RI[RULERule_6].rulename = "Rule_6";
	RI[RULERule_6].ruletype = 0;
	RI[RULERule_6].create = _CreateRule_6;
	RI[RULERule_6].delrule = _DeleteRule_6;
	RI[RULERule_6].getdesc = _GetDescRule_6;
	RI[RULERule_6].getattrs = _GetAttrsRule_6;
	RI[RULERule_6].getvlpropertyids = _GetVLPropertyIdsRule_6;
	RI[RULERule_6].getvlvalues = _GetVLValuesRule_6;
	RI[RULERule_6].setattr = _SetAttrRule_6;
	RI[RULERule_6].insert = _InsertRule_6;
	RI[RULERule_6].extract = _ExtractRule_6;
	RI[RULERule_6].getminmax = _GetMinMaxRule_6;
	RI[RULERule_7].rulename = "Rule_7";
	RI[RULERule_7].ruletype = 0;
	RI[RULERule_7].create = _CreateRule_7;
	RI[RULERule_7].delrule = _DeleteRule_7;
	RI[RULERule_7].getdesc = _GetDescRule_7;
	RI[RULERule_7].getattrs = _GetAttrsRule_7;
	RI[RULERule_7].getvlpropertyids = _GetVLPropertyIdsRule_7;
	RI[RULERule_7].getvlvalues = _GetVLValuesRule_7;
	RI[RULERule_7].setattr = _SetAttrRule_7;
	RI[RULERule_7].insert = _InsertRule_7;
	RI[RULERule_7].extract = _ExtractRule_7;
	RI[RULERule_7].getminmax = _GetMinMaxRule_7;
	RI[RULEpXORSuperstate].rulename = "pXORSuperstate";
	RI[RULEpXORSuperstate].ruletype = 0;
	RI[RULEpXORSuperstate].create = _CreatepXORSuperstate;
	RI[RULEpXORSuperstate].delrule = _DeletepXORSuperstate;
	RI[RULEpXORSuperstate].getdesc = _GetDescpXORSuperstate;
	RI[RULEpXORSuperstate].getattrs = _GetAttrspXORSuperstate;
	RI[RULEpXORSuperstate].getvlpropertyids = _GetVLPropertyIdspXORSuperstate;
	RI[RULEpXORSuperstate].getvlvalues = _GetVLValuespXORSuperstate;
	RI[RULEpXORSuperstate].setattr = _SetAttrpXORSuperstate;
	RI[RULEpXORSuperstate].insert = _InsertpXORSuperstate;
	RI[RULEpXORSuperstate].extract = _ExtractpXORSuperstate;
	RI[RULEpXORSuperstate].getminmax = _GetMinMaxpXORSuperstate;
	RI[RULERule_8].rulename = "Rule_8";
	RI[RULERule_8].ruletype = 0;
	RI[RULERule_8].create = _CreateRule_8;
	RI[RULERule_8].delrule = _DeleteRule_8;
	RI[RULERule_8].getdesc = _GetDescRule_8;
	RI[RULERule_8].getattrs = _GetAttrsRule_8;
	RI[RULERule_8].getvlpropertyids = _GetVLPropertyIdsRule_8;
	RI[RULERule_8].getvlvalues = _GetVLValuesRule_8;
	RI[RULERule_8].setattr = _SetAttrRule_8;
	RI[RULERule_8].insert = _InsertRule_8;
	RI[RULERule_8].extract = _ExtractRule_8;
	RI[RULERule_8].getminmax = _GetMinMaxRule_8;
	RI[RULERule_9].rulename = "Rule_9";
	RI[RULERule_9].ruletype = 0;
	RI[RULERule_9].create = _CreateRule_9;
	RI[RULERule_9].delrule = _DeleteRule_9;
	RI[RULERule_9].getdesc = _GetDescRule_9;
	RI[RULERule_9].getattrs = _GetAttrsRule_9;
	RI[RULERule_9].getvlpropertyids = _GetVLPropertyIdsRule_9;
	RI[RULERule_9].getvlvalues = _GetVLValuesRule_9;
	RI[RULERule_9].setattr = _SetAttrRule_9;
	RI[RULERule_9].insert = _InsertRule_9;
	RI[RULERule_9].extract = _ExtractRule_9;
	RI[RULERule_9].getminmax = _GetMinMaxRule_9;
	RI[RULERule_10].rulename = "Rule_10";
	RI[RULERule_10].ruletype = 0;
	RI[RULERule_10].create = _CreateRule_10;
	RI[RULERule_10].delrule = _DeleteRule_10;
	RI[RULERule_10].getdesc = _GetDescRule_10;
	RI[RULERule_10].getattrs = _GetAttrsRule_10;
	RI[RULERule_10].getvlpropertyids = _GetVLPropertyIdsRule_10;
	RI[RULERule_10].getvlvalues = _GetVLValuesRule_10;
	RI[RULERule_10].setattr = _SetAttrRule_10;
	RI[RULERule_10].insert = _InsertRule_10;
	RI[RULERule_10].extract = _ExtractRule_10;
	RI[RULERule_10].getminmax = _GetMinMaxRule_10;
	RI[RULEpANDSuperstate].rulename = "pANDSuperstate";
	RI[RULEpANDSuperstate].ruletype = 0;
	RI[RULEpANDSuperstate].create = _CreatepANDSuperstate;
	RI[RULEpANDSuperstate].delrule = _DeletepANDSuperstate;
	RI[RULEpANDSuperstate].getdesc = _GetDescpANDSuperstate;
	RI[RULEpANDSuperstate].getattrs = _GetAttrspANDSuperstate;
	RI[RULEpANDSuperstate].getvlpropertyids = _GetVLPropertyIdspANDSuperstate;
	RI[RULEpANDSuperstate].getvlvalues = _GetVLValuespANDSuperstate;
	RI[RULEpANDSuperstate].setattr = _SetAttrpANDSuperstate;
	RI[RULEpANDSuperstate].insert = _InsertpANDSuperstate;
	RI[RULEpANDSuperstate].extract = _ExtractpANDSuperstate;
	RI[RULEpANDSuperstate].getminmax = _GetMinMaxpANDSuperstate;
	RI[RULERule_11].rulename = "Rule_11";
	RI[RULERule_11].ruletype = 0;
	RI[RULERule_11].create = _CreateRule_11;
	RI[RULERule_11].delrule = _DeleteRule_11;
	RI[RULERule_11].getdesc = _GetDescRule_11;
	RI[RULERule_11].getattrs = _GetAttrsRule_11;
	RI[RULERule_11].getvlpropertyids = _GetVLPropertyIdsRule_11;
	RI[RULERule_11].getvlvalues = _GetVLValuesRule_11;
	RI[RULERule_11].setattr = _SetAttrRule_11;
	RI[RULERule_11].insert = _InsertRule_11;
	RI[RULERule_11].extract = _ExtractRule_11;
	RI[RULERule_11].getminmax = _GetMinMaxRule_11;
	RI[RULEpANDRegion].rulename = "pANDRegion";
	RI[RULEpANDRegion].ruletype = 0;
	RI[RULEpANDRegion].create = _CreatepANDRegion;
	RI[RULEpANDRegion].delrule = _DeletepANDRegion;
	RI[RULEpANDRegion].getdesc = _GetDescpANDRegion;
	RI[RULEpANDRegion].getattrs = _GetAttrspANDRegion;
	RI[RULEpANDRegion].getvlpropertyids = _GetVLPropertyIdspANDRegion;
	RI[RULEpANDRegion].getvlvalues = _GetVLValuespANDRegion;
	RI[RULEpANDRegion].setattr = _SetAttrpANDRegion;
	RI[RULEpANDRegion].insert = _InsertpANDRegion;
	RI[RULEpANDRegion].extract = _ExtractpANDRegion;
	RI[RULEpANDRegion].getminmax = _GetMinMaxpANDRegion;
	RI[RULERule_12].rulename = "Rule_12";
	RI[RULERule_12].ruletype = 0;
	RI[RULERule_12].create = _CreateRule_12;
	RI[RULERule_12].delrule = _DeleteRule_12;
	RI[RULERule_12].getdesc = _GetDescRule_12;
	RI[RULERule_12].getattrs = _GetAttrsRule_12;
	RI[RULERule_12].getvlpropertyids = _GetVLPropertyIdsRule_12;
	RI[RULERule_12].getvlvalues = _GetVLValuesRule_12;
	RI[RULERule_12].setattr = _SetAttrRule_12;
	RI[RULERule_12].insert = _InsertRule_12;
	RI[RULERule_12].extract = _ExtractRule_12;
	RI[RULERule_12].getminmax = _GetMinMaxRule_12;
	RI[RULEpTransition].rulename = "pTransition";
	RI[RULEpTransition].ruletype = 0;
	RI[RULEpTransition].create = _CreatepTransition;
	RI[RULEpTransition].delrule = _DeletepTransition;
	RI[RULEpTransition].getdesc = _GetDescpTransition;
	RI[RULEpTransition].getattrs = _GetAttrspTransition;
	RI[RULEpTransition].getvlpropertyids = _GetVLPropertyIdspTransition;
	RI[RULEpTransition].getvlvalues = _GetVLValuespTransition;
	RI[RULEpTransition].setattr = _SetAttrpTransition;
	RI[RULEpTransition].insert = _InsertpTransition;
	RI[RULEpTransition].extract = _ExtractpTransition;
	RI[RULEpTransition].getminmax = _GetMinMaxpTransition;
	RI[RULEp_List_Substate].rulename = "Substate List";
	RI[RULEp_List_Substate].ruletype = 1;
	RI[RULEp_List_Substate].create = _Createp_List_Substate;
	RI[RULEp_List_Substate].delrule = _Deletep_List_Substate;
	RI[RULEp_List_Substate].getdesc = _GetDescp_List_Substate;
	RI[RULEp_List_Substate].insert = _Insertp_List_Substate;
	RI[RULEp_List_Substate].extract = _Extractp_List_Substate;
	RI[RULEp_List_ANDRegion].rulename = "ANDRegion List";
	RI[RULEp_List_ANDRegion].ruletype = 1;
	RI[RULEp_List_ANDRegion].create = _Createp_List_ANDRegion;
	RI[RULEp_List_ANDRegion].delrule = _Deletep_List_ANDRegion;
	RI[RULEp_List_ANDRegion].getdesc = _GetDescp_List_ANDRegion;
	RI[RULEp_List_ANDRegion].insert = _Insertp_List_ANDRegion;
	RI[RULEp_List_ANDRegion].extract = _Extractp_List_ANDRegion;
	RI[RULEp_List_Transition].rulename = "Transition List";
	RI[RULEp_List_Transition].ruletype = 1;
	RI[RULEp_List_Transition].create = _Createp_List_Transition;
	RI[RULEp_List_Transition].delrule = _Deletep_List_Transition;
	RI[RULEp_List_Transition].getdesc = _GetDescp_List_Transition;
	RI[RULEp_List_Transition].insert = _Insertp_List_Transition;
	RI[RULEp_List_Transition].extract = _Extractp_List_Transition;
}

/* Symbol Information Table */

Symbinfo SI[ SI_LEN ];

void InitSymbolTable()
{
	int i;
	for(i = 0; i < SI_LEN; i++)
	{
		SI[i].symbname = "(none)";
		SI[i].listelement = -1;
		SI[i].defaultprod = -1;
	}

	SI[SYMBStateList].symbname = "StateList";
	SI[SYMBTransitionList].symbname = "TransitionList";
	SI[SYMBStatechart].symbname = "Statechart";
	SI[SYMBROOT].symbname = "ROOT";
	SI[SYMBSubstate].symbname = "Substate";
	SI[SYMBSimpleState].symbname = "SimpleState";
	SI[SYMBXORName].symbname = "XORName";
	SI[SYMBXORSubstates].symbname = "XORSubstates";
	SI[SYMBXORSuperstate].symbname = "XORSuperstate";
	SI[SYMBANDName].symbname = "ANDName";
	SI[SYMBANDRegions].symbname = "ANDRegions";
	SI[SYMBANDSuperstate].symbname = "ANDSuperstate";
	SI[SYMBANDRegion].symbname = "ANDRegion";
	SI[SYMBTransitionLabel].symbname = "TransitionLabel";
	SI[SYMBTransition].symbname = "Transition";
	SI[SYMB_List_Substate].symbname = "Substate List";
	SI[SYMB_List_Substate].listelement = SYMBSubstate;
	SI[SYMB_List_Substate].defaultprod = RULEp_List_Substate;
	SI[SYMB_List_ANDRegion].symbname = "ANDRegion List";
	SI[SYMB_List_ANDRegion].listelement = SYMBANDRegion;
	SI[SYMB_List_ANDRegion].defaultprod = RULEp_List_ANDRegion;
	SI[SYMB_List_Transition].symbname = "Transition List";
	SI[SYMB_List_Transition].listelement = SYMBTransition;
	SI[SYMB_List_Transition].defaultprod = RULEp_List_Transition;
	SI[SYMBStateList].defaultprod = RULERule_1;
	SI[SYMBTransitionList].defaultprod = RULERule_2;
	SI[SYMBStatechart].defaultprod = RULERule_3;
	SI[SYMBROOT].defaultprod = RULERule_4;
	SI[SYMBSubstate].defaultprod = RULEpSimpleState;
	SI[SYMBSimpleState].defaultprod = RULERule_5;
	SI[SYMBXORName].defaultprod = RULERule_6;
	SI[SYMBXORSubstates].defaultprod = RULERule_7;
	SI[SYMBSubstate].defaultprod = RULEpXORSuperstate;
	SI[SYMBXORSuperstate].defaultprod = RULERule_8;
	SI[SYMBANDName].defaultprod = RULERule_9;
	SI[SYMBANDRegions].defaultprod = RULERule_10;
	SI[SYMBSubstate].defaultprod = RULEpANDSuperstate;
	SI[SYMBANDSuperstate].defaultprod = RULERule_11;
	SI[SYMBANDRegion].defaultprod = RULEpANDRegion;
	SI[SYMBTransitionLabel].defaultprod = RULERule_12;
	SI[SYMBTransition].defaultprod = RULEpTransition;
}
