# ----------------------------------------------------------------------
# Module View
# ----------------------------------------------------------------------
# Code for determining an editor for a production
# Code to open visual editor panes
# This module is generated. ** DO NOT EDIT **
namespace eval ::view {
}

proc ::view::init {} {
	variable editors
	if {[array exists editors]} {unset editors}
	set title "The View"
	lappend editors($::vl::symb(ROOT)) [list ::view::open_view0 $title "view0"]
	set title "Edit Statechart Properties"
	lappend editors($::vl::symb(Statechart)) [list ::dialog::editStatechart $title "editStatechart dialog"]
	set title "Edit SimpleState Properties"
	lappend editors($::vl::symb(SimpleState)) [list ::dialog::editSimpleState $title "editSimpleState dialog"]
	set title "Edit XORSuperstate Properties"
	lappend editors($::vl::symb(XORSuperstate)) [list ::dialog::editXORSuperstate $title "editXORSuperstate dialog"]
	set title "Edit ANDSuperstate Properties"
	lappend editors($::vl::symb(ANDSuperstate)) [list ::dialog::editANDSuperstate $title "editANDSuperstate dialog"]
	set title "Edit Transition Properties"
	lappend editors($::vl::symb(Transition)) [list ::dialog::editTransition $title "editTransition dialog"]
	# Set Name of a default view, if available
	set ::cfg::mainview "::view::open_view0"
}

proc ::view::get_editors {node} {
	variable editors
	set code [::vl::lhs [::vl::getCode $node]]
	if {[info exists editors($code)]} {
		return $editors($code)
	} else {
		return ""
	}
}
proc ::view::is_editable {node} {
	variable editors
	set code [::vl::lhs [::vl::getCode $node]]
	if {[info exists editors($code)]} {
		return 1
	} else {
		return 0
	}
}
# ----------------------------------------------------------------------
# Implementation of Visual Editor: view0
# ----------------------------------------------------------------------

proc ::view::open_view0 {id args} {
	array set attr [::vl::getAttrs $id]
	set title "The View"
	set frameargs ""
	set visargs ""
	foreach {opt val} $args {
		switch -- $opt {
			 -selectnode {lappend visargs $opt $val}
			 -selectattr {lappend visargs $opt $val}
			 default     {lappend frameargs $opt $val}
		}
	}
	set window [eval {::MDIFrame::New_Window $title $id} $frameargs]
	set client [::MDIFrame::GetClient $window]
	set var [eval {::visual::create $window.win $id "view0"} $visargs]
	::MDIFrame::SetSelectcommand $client "::visual::select $window.win"
	# Configure toolbar
	::visual::add_toolbutton $window.win $::vl::prod(pSimpleState) "" -text "SimpleState" -relief groove
	::visual::add_toolbutton $window.win $::vl::prod(pXORSuperstate) "" -text "XORSuperstate" -relief groove
	::visual::add_toolbutton $window.win $::vl::prod(pANDSuperstate) "" -text "ANDSuperstate" -relief groove
	::visual::add_toolbutton $window.win $::vl::prod(pANDRegion) "" -text "ANDRegion" -relief groove
	::visual::add_toolbutton $window.win $::vl::prod(pTransition) "" -text "Transition" -relief groove

	# Set Interwindow-Drag & Drop

	# Do first update
	::visual::update_after_idle $window.win
}

