# ----------------------------------------------------------------------
# Module: Iconmanager
# ----------------------------------------------------------------------
# $Id: iconmanager.tcl,v 3.1.1.1 1999/07/05 14:10:17 mjung Exp $
#

namespace eval ::icon {
    variable icon
    variable nexticon 0
}

proc ::icon::loadicon {name scales} {
    
    variable icon
    variable nexticon

    set maxscale [lindex [lsort -integer $scales] end]

    foreach scale $scales {
	if {$scale == $maxscale} {
	    set filename "$name.gif"
	} else {
	    set filename "$name.$scale.gif"
	}

	set icon($name,$scale) [image create photo vl_icon_[incr nexticon] \
		-file $::cfg::libdir/$filename]
    }
}

proc ::icon::geticon { name {scale 0} } {
    if {$scale == 0} {
	return $::icon::icon($name,[lindex $::cfg::gridsizes end])
    } else {
	return $::icon::icon($name,$scale)
    }
}

proc ::icon::width { iconname } {
    return [icon width $iconname]
}

proc ::icon::height { iconname } {
    return [icon height $iconname]
}
