
/* definition of tree node structure */

#ifndef NODE_H
#define NODE_H
#include "err.h"
#include "nodeptr.h" /* defines NODEPTR */
#include "HEAD.h"

#define _NODE_UPREF 1
#if _NODE_UPREF
#define _NODEFATHERREF struct NODEPTR_struct *_father;
#else
#define _NODEFATHERREF
#endif
#ifdef MONITOR
#define _NODECOMMON int _prod; POSITION _coord; _NODEFATHERREF
#else
#define _NODECOMMON int _prod; _NODEFATHERREF
#endif

struct NODEPTR_struct {
        _NODECOMMON
#ifdef __cplusplus
        void* operator new(size_t size);
        void operator delete(void *data);
#endif
};

typedef struct _TSStateList* _TSPStateList;
typedef struct _TS_List_Substate* _TSP_List_Substate;
typedef struct _TSTransitionList* _TSPTransitionList;
typedef struct _TS_List_Transition* _TSP_List_Transition;
typedef struct _TSStatechart* _TSPStatechart;
typedef struct _TSROOT* _TSPROOT;
typedef struct _TSSubstate* _TSPSubstate;
typedef struct _TSSimpleState* _TSPSimpleState;
typedef struct _TSXORName* _TSPXORName;
typedef struct _TSXORSubstates* _TSPXORSubstates;
typedef struct _TSXORSuperstate* _TSPXORSuperstate;
typedef struct _TSANDName* _TSPANDName;
typedef struct _TSANDRegions* _TSPANDRegions;
typedef struct _TS_List_ANDRegion* _TSP_List_ANDRegion;
typedef struct _TSANDSuperstate* _TSPANDSuperstate;
typedef struct _TSANDRegion* _TSPANDRegion;
typedef struct _TSTransitionLabel* _TSPTransitionLabel;
typedef struct _TSTransition* _TSPTransition;
typedef struct _TSLST__List_Substate* _TSPLST__List_Substate;
typedef struct _TSLST__List_ANDRegion* _TSPLST__List_ANDRegion;
typedef struct _TSLST__List_Transition* _TSPLST__List_Transition;
typedef struct _TPRule_1* _TPPRule_1;
typedef struct _TPRule_2* _TPPRule_2;
typedef struct _TPRule_3* _TPPRule_3;
typedef struct _TPRule_4* _TPPRule_4;
typedef struct _TPpSimpleState* _TPPpSimpleState;
typedef struct _TPRule_5* _TPPRule_5;
typedef struct _TPRule_6* _TPPRule_6;
typedef struct _TPRule_7* _TPPRule_7;
typedef struct _TPpXORSuperstate* _TPPpXORSuperstate;
typedef struct _TPRule_8* _TPPRule_8;
typedef struct _TPRule_9* _TPPRule_9;
typedef struct _TPRule_10* _TPPRule_10;
typedef struct _TPpANDSuperstate* _TPPpANDSuperstate;
typedef struct _TPRule_11* _TPPRule_11;
typedef struct _TPpANDRegion* _TPPpANDRegion;
typedef struct _TPRule_12* _TPPRule_12;
typedef struct _TPpTransition* _TPPpTransition;
typedef struct _TPp_List_Substate* _TPPp_List_Substate;
typedef struct _TPp_List_ANDRegion* _TPPp_List_ANDRegion;
typedef struct _TPp_List_Transition* _TPPp_List_Transition;
typedef struct _TPLST_Substatep_List_Substate* _TPPLST_Substatep_List_Substate;
typedef struct _TPLST_ANDRegionp_List_ANDRegion* _TPPLST_ANDRegionp_List_ANDRegion;
typedef struct _TPLST_Transitionp_List_Transition* _TPPLST_Transitionp_List_Transition;
typedef struct _TPLST_0p_List_Substate* _TPPLST_0p_List_Substate;
typedef struct _TPLST_0p_List_ANDRegion* _TPPLST_0p_List_ANDRegion;
typedef struct _TPLST_0p_List_Transition* _TPPLST_0p_List_Transition;

struct _TSStateList
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_AT_const0;
};

struct _TS_List_Substate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_ATVP_ListContextPTR;
};

struct _TSTransitionList
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TS_List_Transition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _view0_ATVP_OptDD;
VisContainerInterfacePtr _view0_ATVP_AreaContainerPtr;
};

struct _TSStatechart
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_ATVP_ContextPtr;
VisCrossAreaPtrList _view0_ATVP_SubCrossRelationAreas;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
};

struct _TSROOT
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSSubstate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
};

struct _TSSimpleState
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLCharPtr _view0_ATVP_OptText;
VLCharPtr _view0_ATVP_OptFont;
VisBorderDimensions _view0_ATVP_Border;
VLCharPtr _view0_ATVP_FinalText;
VisContainerInterface2Ptr _view0_ATVP_InnerContainerInterface2Ptr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
NODEPTR _view0_ATVP_VisualContext;
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
};

struct _TSXORName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSXORSubstates
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_AT_const0;
};

struct _TSXORSuperstate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_AT_ptr_persview0Size;
VLString _view0_ATpersName;
VisSetPtr _view0_ATVP_ObjectPtr;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
NODEPTR _view0_ATVP_VisualContext;
int _view0_ATVP_OptShape;
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
};

struct _TSANDName
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLCharPtr _view0_ATVP_OptText;
VLCharPtr _view0_ATVP_OptFont;
VisBorderDimensions _view0_ATVP_Border;
VLCharPtr _view0_ATVP_FinalText;
VisContainerInterface2Ptr _view0_ATVP_InnerContainerInterface2Ptr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
NODEPTR _view0_ATVP_VisualContext;
};

struct _TSANDRegions
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TS_List_ANDRegion
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLCharPtr _view0_ATVP_OptInsPointProc;
VLListPtr _view0_ATVP_OptInsPointProcArgs;
NODEPTR _view0_ATVP_OptInsPointValidity;
VisSimpleListPtr _view0_ATVP_ObjectPtr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
VisContainerInterfacePtrList _view0_ATVP_ListElements;
};

struct _TSANDSuperstate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _view0_ATpersName;
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
VisDrawingTrafoPtr _view0_ATVP_DrawingTrafo;
};

struct _TSANDRegion
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_AT_ptr_persview0Size;
VisSetPtr _view0_ATVP_ObjectPtr;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
};

struct _TSTransitionLabel
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSTransition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArray _view0_ATpersview0FromOffset;
VLPointArray _view0_ATpersview0ToOffset;
VLPropertyPtr _view0_ATpersFrom;
VLPropertyPtr _view0_ATpersTo;
VLString _view0_ATpersEvent;
VLPointArrayPtr _view0_ATVP_TransCoords;
int _view0_ATVP_FromDirection;
int _view0_ATVP_ToDirection;
VLPointArrayPtr _view0_ATVP_FinalFromPoint;
VLPointArrayPtr _view0_ATVP_FinalToPoint;
};

struct _TSLST__List_Substate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST__List_ANDRegion
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TSLST__List_Transition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPRule_1
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_AT_const0;
_TSP_List_Substate _desc1;
};

struct _TPRule_2
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSP_List_Transition _desc1;
};

struct _TPRule_3
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_ATVP_ContextPtr;
VisCrossAreaPtrList _view0_ATVP_SubCrossRelationAreas;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
_TSPStateList _desc1;
_TSPTransitionList _desc2;
VLPointArray _ATTERM_1;
VLString _ATTERM_2;
};

struct _TPRule_4
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPStatechart _desc1;
};

struct _TPpSimpleState
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
_TSPSimpleState _desc1;
VLPointArray _ATTERM_1;
};

struct _TPRule_5
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLCharPtr _view0_ATVP_OptText;
VLCharPtr _view0_ATVP_OptFont;
VisBorderDimensions _view0_ATVP_Border;
VLCharPtr _view0_ATVP_FinalText;
VisContainerInterface2Ptr _view0_ATVP_InnerContainerInterface2Ptr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
NODEPTR _view0_ATVP_VisualContext;
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
VLPointArray _ATTERM_1;
VLString _ATTERM_2;
VLPropertyPtr _ATTERM_3;
};

struct _TPRule_6
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
};

struct _TPRule_7
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_AT_const0;
_TSP_List_Substate _desc1;
};

struct _TPpXORSuperstate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
_TSPXORSuperstate _desc1;
VLPointArray _ATTERM_1;
};

struct _TPRule_8
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_AT_ptr_persview0Size;
VLString _view0_ATpersName;
VisSetPtr _view0_ATVP_ObjectPtr;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
NODEPTR _view0_ATVP_VisualContext;
int _view0_ATVP_OptShape;
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
_TSPXORName _desc1;
_TSPXORSubstates _desc2;
VLPointArray _ATTERM_1;
VLPointArray _ATTERM_2;
VLPropertyPtr _ATTERM_3;
VLString _ATTERM_4;
};

struct _TPRule_9
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLCharPtr _view0_ATVP_OptText;
VLCharPtr _view0_ATVP_OptFont;
VisBorderDimensions _view0_ATVP_Border;
VLCharPtr _view0_ATVP_FinalText;
VisContainerInterface2Ptr _view0_ATVP_InnerContainerInterface2Ptr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
NODEPTR _view0_ATVP_VisualContext;
};

struct _TPRule_10
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSP_List_ANDRegion _desc1;
};

struct _TPpANDSuperstate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
_TSPANDSuperstate _desc1;
VLPointArray _ATTERM_1;
};

struct _TPRule_11
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLString _view0_ATpersName;
VLPointArrayPtr _view0_ATVP_MovablePosPtr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
VisDrawingTrafoPtr _view0_ATVP_DrawingTrafo;
_TSPANDName _desc1;
_TSPANDRegions _desc2;
VLPointArray _ATTERM_1;
VLPropertyPtr _ATTERM_2;
VLString _ATTERM_3;
};

struct _TPpANDRegion
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArrayPtr _view0_AT_ptr_persview0Size;
VisSetPtr _view0_ATVP_ObjectPtr;
VisContainerInterfacePtr _view0_ATVP_ContainerInterfacePtr;
_TSP_List_Substate _desc1;
VLPointArray _ATTERM_1;
VLPointArray _ATTERM_2;
};

struct _TPRule_12
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArray _ATTERM_1;
};

struct _TPpTransition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLPointArray _view0_ATpersview0FromOffset;
VLPointArray _view0_ATpersview0ToOffset;
VLPropertyPtr _view0_ATpersFrom;
VLPropertyPtr _view0_ATpersTo;
VLString _view0_ATpersEvent;
VLPointArrayPtr _view0_ATVP_TransCoords;
int _view0_ATVP_FromDirection;
int _view0_ATVP_ToDirection;
VLPointArrayPtr _view0_ATVP_FinalFromPoint;
VLPointArrayPtr _view0_ATVP_FinalToPoint;
_TSPTransitionLabel _desc1;
VLPointArray _ATTERM_1;
VLPointArray _ATTERM_2;
VLPointArray _ATTERM_3;
VLPointArray _ATTERM_4;
VLPointArray _ATTERM_5;
VLPointArray _ATTERM_6;
VLPropertyPtr _ATTERM_7;
VLPropertyPtr _ATTERM_8;
VLString _ATTERM_9;
};

struct _TPp_List_Substate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _view0_ATVP_ListContextPTR;
_TSPLST__List_Substate _desc1;
};

struct _TPp_List_ANDRegion
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
VLCharPtr _view0_ATVP_OptInsPointProc;
VLListPtr _view0_ATVP_OptInsPointProcArgs;
NODEPTR _view0_ATVP_OptInsPointValidity;
VisSimpleListPtr _view0_ATVP_ObjectPtr;
VisDrawingTrafoPtr _view0_ATVP_FrameDrawingTrafo;
VisContainerInterfacePtrList _view0_ATVP_ListElements;
_TSPLST__List_ANDRegion _desc1;
};

struct _TPp_List_Transition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
int _view0_ATVP_OptDD;
VisContainerInterfacePtr _view0_ATVP_AreaContainerPtr;
_TSPLST__List_Transition _desc1;
};

struct _TPLST_Substatep_List_Substate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPSubstate _desc1;
_TSPLST__List_Substate _desc2;
};

struct _TPLST_ANDRegionp_List_ANDRegion
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPANDRegion _desc1;
_TSPLST__List_ANDRegion _desc2;
};

struct _TPLST_Transitionp_List_Transition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
_TSPTransition _desc1;
_TSPLST__List_Transition _desc2;
};

struct _TPLST_0p_List_Substate
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0p_List_ANDRegion
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

struct _TPLST_0p_List_Transition
#ifdef __cplusplus
	: public NODEPTR_struct {
#else
{
_NODECOMMON
#endif
NODEPTR _desc1;
NODEPTR _desc2;
};

#undef _NODECOMMON
#undef _NODEFATHERREF

#endif
