
# Dieses Modul ermoeglicht einen objektorientierten Programmierstiel:
# Objekten koennen bestimmte Methoden zuordnet werden.
# Diese Methoden koennen aufgerugen werden durch:
# ::oop::msg objekt methodenname parameter ...
#
# Anmerkung: Ggf. sind noch einige Erweiterungen notwendig...

namespace eval ::oop {
    variable data
}

proc ::oop::tryeval {script} {
    if { [catch [uplevel 1 $script] err] } {
      ::log::log "tryeval hat folgenden Fehler aufgedeckt:"
      ::log::log $err
  }
}


proc ::oop::private {} {

    set methodNamespace [uplevel 1 {namespace current}]
    set callerNamespace [uplevel 2 {namespace current}]

    if { "$methodNamespace" != "$callerNamespace" } {
	set methodName [lindex [info level [expr [info level]-1]] 0]
	log::log "Private method $methodName called from Namespace $callerNamespace"
    }
}


proc ::oop::setClass {id class} {
    variable data
    setAlias $id $id
    set data($id-class) $class
}

proc ::oop::setAlias {id aliasId} {
    variable data
    if { [info exists data($aliasId-realId)] } {
	::log::log "oop: Object $aliasId already exists!"
    }
    set data($aliasId-realId) $id
}

proc ::oop::msg {id msgname args} {
    msgArglist $id $msgname $args
}

proc ::oop::msgArglist {id msgname arglist} {
    variable data
    set id $data($id-realId)
    eval [list ::$data($id-class)::$msgname $id] $arglist
}

proc ::oop::understandsMessage {id msgname} {
    variable data
    set id $data($id-realId)
    return [expr ![catch {info args ::$data($id-class)::$msgname }]]
}



