namespace eval ::process {
    variable procdata
}

proc ::process::open {prog name readcmd {closecmd ""}} {
    variable procdata

    set handle [::open "|$prog" "r+"]
    fconfigure $handle -buffering line
    fconfigure $handle -blocking false
    fileevent $handle readable \
	    "::process::_read $handle"
    set procdata($handle,name) $name
    set procdata($handle,readcmd) $readcmd
    set procdata($handle,closecmd) $closecmd
    set procdata($handle,flushed) 0
    return $handle
}

proc ::process::close {handle} {
    variable procdata

    if {[info exists procdata($handle,name)]} {
	if {$procdata($handle,closecmd) != ""} {
	    eval $procdata($handle,closecmd) $handle
	}
	catch {::close $handle}
	unset procdata($handle,name)
	unset procdata($handle,readcmd)
	unset procdata($handle,closecmd)
	unset procdata($handle,flushed)
    }
}

proc ::process::_read {handle} {
    variable procdata

    set data [gets $handle]
    if {[eof $handle] < 0} {
	::log::log "$procdata($handle,name) closed the connection."
	# by cs: ist dies ein Fehler?
	
	::process::close $handle

    } elseif {![fblocked $handle]} {
	eval $procdata($handle,readcmd) {$data}
    }
}

proc ::process::_flushed {handle} {
    variable procdata

    set procdata($handle,flushed) 1
    fileevent $handle writable {}\
}

proc ::process::write {handle data} {
    variable procdata

    set procdata($handle,flushed) 0
    puts $handle $data
    fileevent $handle writable \
	    "::process::_flushed $handle"
}

proc ::process::is_open {handle} {
    variable procdata

    if {[info exists procdata($handle,name)]} {
	return true
    } else {
	return false
    }
}

proc ::process::is_flushed {handle} {
    variable procdata

    return $procdata($handle,flushed)
}

proc ::process::get_name {handle} {
    variable procdata

    return $procdata($handle,name)
}
