

#include "std.drawings.h"


FrameDrawing::FrameDrawing(char *attr, VisBorderDimensions innerPad, 
  VisIntVector minSize,VisIntVector align)
{
  if(attr) figure(2,"rect",attr);
  point(-innerPad.left, -innerPad.top);
  point(minSize.x+innerPad.right, minSize.y+innerPad.bottom);
  container("default",0,0,minSize.x,minSize.y,
   VisAlignmentAdvice(align.x), VisAlignmentAdvice(align.y));
  stretchX(0,minSize.x);
  stretchY(0,minSize.y);
}


RoundedFrameDrawing::RoundedFrameDrawing(
  char *attr, 
  VisBorderDimensions innerPad, 
  int cornerradius, 
  VisIntVector align)
{

        int minSizex = max(3*cornerradius/2, innerPad.left+innerPad.right) + 1;
        int minSizey = max(3*cornerradius/2, innerPad.top+innerPad.bottom) + 1;

        char *attr2=GETVLSTRING(sprintf(VLStringBuffer,"-cornerradius %i %s",cornerradius,attr));
        figure(2,"roundedrectangle",attr2); 
        point(0,0); point(minSizex, minSizey);
          
        container("default", 
           innerPad.left, 
           innerPad.top,
           minSizex-innerPad.right,
           minSizey-innerPad.bottom,
           VisAlignmentAdvice(align.x), VisAlignmentAdvice(align.y));

        stretchX(innerPad.left, minSizex-innerPad.right);
        stretchY(innerPad.top, minSizey-innerPad.bottom);

#ifdef no
        int minSizex = 2*cornerradius + 1 - innerPad.left - innerPad.right;
        int minSizey = 2*cornerradius + 1 - innerPad.top - innerPad.bottom;
        figure(2,"roundedrectangle",attr2); 
        point(-innerPad.left, -innerPad.top); point(minSizex + innerPad.right, minSizey + innerPad.bottom);

        int strX = 0 - innerPad.left + cornerradius;
        int strY = 0 - innerPad.top + cornerradius;
        stretchX(strX, strX + 1);
        stretchY(strY, strY + 1);
#endif

}


CircleFrameDrawing::CircleFrameDrawing(char *attr, VisBorderDimensions innerPad, 
                VisIntVector minSize, VisIntVector align)
{
        if (attr) figure(2, "oval", attr);
        point(-innerPad.left, -innerPad.top);
        point(minSize.x+innerPad.right, minSize.y+innerPad.bottom);
        container("default",0,0,minSize.x,minSize.y,
        VisAlignmentAdvice(align.x), VisAlignmentAdvice(align.y));
        stretchX(0,minSize.x);
        stretchY(0,minSize.y);
        stretchIsometrical=VisIntVector(0,0);
        
}



OvalFrameDrawing::OvalFrameDrawing(char *attr, VisBorderDimensions innerPad, 
                VisIntVector minSize, VisIntVector align)
{
        if (attr) figure(2, "oval", attr);
        point(-innerPad.left, -innerPad.top);
        point(minSize.x+innerPad.right, minSize.y+innerPad.bottom);
        container("default",0,0,minSize.x,minSize.y,
        VisAlignmentAdvice(align.x), VisAlignmentAdvice(align.y));
        stretchX(0,minSize.x);
        stretchY(0,minSize.y);
        
}

