
/* interface of tree construction functions */

#ifndef TREECON_H
#define TREECON_H
#include "eliproto.h"

#include "err.h"

#include "nodeptr.h"

#include "HEAD.h"


extern void InitTree ELI_ARG((void));

extern void FreeTree ELI_ARG((void));

extern void TreeNodeDelete ELI_ARG((void *data));

extern int TreeNodeCheck ELI_ARG((void *data));

extern NODEPTR MkStateList ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR Mk_List_Substate ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionList ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR Mk_List_Transition ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkStatechart ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkROOT ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSubstate ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSimpleState ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkXORName ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkXORSubstates ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkXORSuperstate ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkANDName ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkANDRegions ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR Mk_List_ANDRegion ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkANDSuperstate ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkANDRegion ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransitionLabel ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkTransition ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkRule_1 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkRule_2 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkRule_3 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, VLPointArray _TERM1, VLString _TERM2));
extern NODEPTR MkRule_4 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpSimpleState ELI_ARG((POSITION *_coordref, NODEPTR _desc1, VLPointArray _TERM1));
extern NODEPTR MkRule_5 ELI_ARG((POSITION *_coordref, VLPointArray _TERM1, VLString _TERM2, VLPropertyPtr _TERM3));
extern NODEPTR MkRule_6 ELI_ARG((POSITION *_coordref));
extern NODEPTR MkRule_7 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpXORSuperstate ELI_ARG((POSITION *_coordref, NODEPTR _desc1, VLPointArray _TERM1));
extern NODEPTR MkRule_8 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, VLPointArray _TERM1, VLPointArray _TERM2, VLPropertyPtr _TERM3, VLString _TERM4));
extern NODEPTR MkRule_9 ELI_ARG((POSITION *_coordref));
extern NODEPTR MkRule_10 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpANDSuperstate ELI_ARG((POSITION *_coordref, NODEPTR _desc1, VLPointArray _TERM1));
extern NODEPTR MkRule_11 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, VLPointArray _TERM1, VLPropertyPtr _TERM2, VLString _TERM3));
extern NODEPTR MkpANDRegion ELI_ARG((POSITION *_coordref, NODEPTR _desc1, VLPointArray _TERM1, VLPointArray _TERM2));
extern NODEPTR MkRule_12 ELI_ARG((POSITION *_coordref, VLPointArray _TERM1));
extern NODEPTR MkpTransition ELI_ARG((POSITION *_coordref, NODEPTR _desc1, VLPointArray _TERM1, VLPointArray _TERM2, VLPointArray _TERM3, VLPointArray _TERM4, VLPointArray _TERM5, VLPointArray _TERM6, VLPropertyPtr _TERM7, VLPropertyPtr _TERM8, VLString _TERM9));
#define Mk0p_List_Substate(_coordref) NULLNODEPTR
extern NODEPTR Mk2p_List_Substate ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkp_List_Substate ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk0p_List_ANDRegion(_coordref) NULLNODEPTR
extern NODEPTR Mk2p_List_ANDRegion ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkp_List_ANDRegion ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk0p_List_Transition(_coordref) NULLNODEPTR
extern NODEPTR Mk2p_List_Transition ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkp_List_Transition ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk_Term_Transition_persEvent(pos,val) (val)
#define Mk_Term_Transition_persTo(pos,val) (val)
#define Mk_Term_Transition_persFrom(pos,val) (val)
#define Mk_Term_Transition_persview0IntermediatePoints(pos,val) (val)
#define Mk_Term_Transition_persview0SavedToOffset(pos,val) (val)
#define Mk_Term_Transition_persview0SavedFromOffset(pos,val) (val)
#define Mk_Term_Transition_persview0ToOffset(pos,val) (val)
#define Mk_Term_Transition_persview0FromOffset(pos,val) (val)
#define Mk_Term_Transition_persview0Pos(pos,val) (val)
#define Mk_Term_TransitionLabel_persview0Pos(pos,val) (val)
#define Mk_Term_ANDRegion_persview0Size(pos,val) (val)
#define Mk_Term_ANDRegion_persview0Pos(pos,val) (val)
#define Mk_Term_ANDSuperstate_persName(pos,val) (val)
#define Mk_Term_ANDSuperstate_persEndpoint(pos,val) (val)
#define Mk_Term_ANDSuperstate_persview0SavedPos(pos,val) (val)
#define Mk_Term_XORSuperstate_persName(pos,val) (val)
#define Mk_Term_XORSuperstate_persEndpoint(pos,val) (val)
#define Mk_Term_XORSuperstate_persview0Size(pos,val) (val)
#define Mk_Term_XORSuperstate_persview0SavedPos(pos,val) (val)
#define Mk_Term_SimpleState_persEndpoint(pos,val) (val)
#define Mk_Term_SimpleState_persName(pos,val) (val)
#define Mk_Term_SimpleState_persview0SavedPos(pos,val) (val)
#define Mk_Term_Substate_persview0Pos(pos,val) (val)
#define Mk_Term_Statechart_persName(pos,val) (val)
#define Mk_Term_Statechart_persview0Size(pos,val) (val)
#endif
