# ----------------------------------------------------------------------
# Module Visual Inspoint
# ----------------------------------------------------------------------
# Code to Manage Insertion Points
#
# $Id: visual.tcl,v 3.4 1999/10/22 15:54:38 mjung Exp $

# Create our namespace.
namespace eval ::visual {
}

proc ::visual::inspoint_init {} {
}

proc ::visual::create_inspoint_kind {kind canvastype defaultattrs numcoords setcoords onselect} {
# kind:          The name of the insertion point kind, without spaces or commas please
# canvastype:    Name of canvas item to draw
# defaultattrs:  Attributes to draw the canvas item with
# numcoords:     Length of coordinate array that must be supplied.
# setcoords:     If not empty, adjusts coords.
# onselect:      Called with insertion point id and a flag. 
#                This Code is executed to draw / hide the selection of the insertion point.

    variable inspointkind

    set inspointkind(canvastype,$kind) $canvastype
    set inspointkind(defaultattrs,$kind) $defaultattrs
    set inspointkind(numcoords,$kind) $numcoords
    set inspointkind(onselect,$kind) $onselect
    set inspointkind(setcoords,$kind) $setcoords
}



